/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.51.0-dev-20240702(c321d0fbecb50ab8a5365fa1965476b0ae63fc87)
 * Released under the MIT license
 * https://github.com/microsoft/vscode/blob/main/LICENSE.txt
 *-----------------------------------------------------------*/(function(){var J=["require","exports","vs/editor/common/core/range","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/errors","vs/base/common/strings","vs/base/common/arrays","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/arraysFind","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/objects","vs/base/common/uri","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/map","vs/base/common/stopwatch","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/codiconsUtil","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/textLength","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/base/common/cache","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/process","vs/base/common/path","vs/base/common/cancellation","vs/base/common/hash","vs/base/common/codiconsLibrary","vs/base/common/codicons","vs/editor/common/core/selection","vs/editor/common/core/positionToOffset","vs/editor/common/core/textEdit","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/findSectionHeaders","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],Z=function(W){for(var n=[],r=0,D=W.length;r<D;r++)n[r]=J[W[r]];return n};const Re=this,Ae=typeof global=="object"?global:{};var le;(function(W){W.global=Re;class n{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=n._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof W.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}W.Environment=n})(le||(le={}));var le;(function(W){class n{constructor(m,h,v){this.type=m,this.detail=h,this.timestamp=v}}W.LoaderEvent=n;class r{constructor(m){this._events=[new n(1,"",m)]}record(m,h){this._events.push(new n(m,h,W.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}W.LoaderEventRecorder=r;class D{record(m,h){}getEvents(){return[]}}D.INSTANCE=new D,W.NullLoaderEventRecorder=D})(le||(le={}));var le;(function(W){class n{static fileUriToFilePath(D,A){if(A=decodeURI(A).replace(/%23/g,"#"),D){if(/^file:\/\/\//.test(A))return A.substr(8);if(/^file:\/\//.test(A))return A.substr(5)}else if(/^file:\/\//.test(A))return A.substr(7);return A}static startsWith(D,A){return D.length>=A.length&&D.substr(0,A.length)===A}static endsWith(D,A){return D.length>=A.length&&D.substr(D.length-A.length)===A}static containsQueryString(D){return/^[^\#]*\?/gi.test(D)}static isAbsolutePath(D){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(D)}static forEachProperty(D,A){if(D){let m;for(m in D)D.hasOwnProperty(m)&&A(m,D[m])}}static isEmpty(D){let A=!0;return n.forEachProperty(D,()=>{A=!1}),A}static recursiveClone(D){if(!D||typeof D!="object"||D instanceof RegExp||!Array.isArray(D)&&Object.getPrototypeOf(D)!==Object.prototype)return D;let A=Array.isArray(D)?[]:{};return n.forEachProperty(D,(m,h)=>{h&&typeof h=="object"?A[m]=n.recursiveClone(h):A[m]=h}),A}static generateAnonymousModule(){return"===anonymous"+n.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(D){return n.startsWith(D,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=W.global.performance&&typeof W.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?W.global.performance.now():Date.now()}}n.NEXT_ANONYMOUS_ID=1,n.PERFORMANCE_NOW_PROBED=!1,n.HAS_PERFORMANCE_NOW=!1,W.Utilities=n})(le||(le={}));var le;(function(W){function n(A){if(A instanceof Error)return A;const m=new Error(A.message||String(A)||"Unknown Error");return A.stack&&(m.stack=A.stack),m}W.ensureError=n;class r{static validateConfigurationOptions(m){function h(v){if(v.phase==="loading"){console.error('Loading "'+v.moduleId+'" failed'),console.error(v),console.error("Here are the modules that depend on it:"),console.error(v.neededBy);return}if(v.phase==="factory"){console.error('The factory function of "'+v.moduleId+'" has thrown an exception'),console.error(v),console.error("Here are the modules that depend on it:"),console.error(v.neededBy);return}}if(m=m||{},typeof m.baseUrl!="string"&&(m.baseUrl=""),typeof m.isBuild!="boolean"&&(m.isBuild=!1),typeof m.paths!="object"&&(m.paths={}),typeof m.config!="object"&&(m.config={}),typeof m.catchError>"u"&&(m.catchError=!1),typeof m.recordStats>"u"&&(m.recordStats=!1),typeof m.urlArgs!="string"&&(m.urlArgs=""),typeof m.onError!="function"&&(m.onError=h),Array.isArray(m.ignoreDuplicateModules)||(m.ignoreDuplicateModules=[]),m.baseUrl.length>0&&(W.Utilities.endsWith(m.baseUrl,"/")||(m.baseUrl+="/")),typeof m.cspNonce!="string"&&(m.cspNonce=""),typeof m.preferScriptTags>"u"&&(m.preferScriptTags=!1),m.nodeCachedData&&typeof m.nodeCachedData=="object"&&(typeof m.nodeCachedData.seed!="string"&&(m.nodeCachedData.seed="seed"),(typeof m.nodeCachedData.writeDelay!="number"||m.nodeCachedData.writeDelay<0)&&(m.nodeCachedData.writeDelay=1e3*7),!m.nodeCachedData.path||typeof m.nodeCachedData.path!="string")){const v=n(new Error("INVALID cached data configuration, 'path' MUST be set"));v.phase="configuration",m.onError(v),m.nodeCachedData=void 0}return m}static mergeConfigurationOptions(m=null,h=null){let v=W.Utilities.recursiveClone(h||{});return W.Utilities.forEachProperty(m,(l,a)=>{l==="ignoreDuplicateModules"&&typeof v.ignoreDuplicateModules<"u"?v.ignoreDuplicateModules=v.ignoreDuplicateModules.concat(a):l==="paths"&&typeof v.paths<"u"?W.Utilities.forEachProperty(a,(g,e)=>v.paths[g]=e):l==="config"&&typeof v.config<"u"?W.Utilities.forEachProperty(a,(g,e)=>v.config[g]=e):v[l]=W.Utilities.recursiveClone(a)}),r.validateConfigurationOptions(v)}}W.ConfigurationOptionsUtil=r;class D{constructor(m,h){if(this._env=m,this.options=r.mergeConfigurationOptions(h),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let v=this.options.nodeRequire.main.filename,l=Math.max(v.lastIndexOf("/"),v.lastIndexOf("\\"));this.options.baseUrl=v.substring(0,l+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let m=0;m<this.options.ignoreDuplicateModules.length;m++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[m]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],W.Utilities.forEachProperty(this.options.paths,(m,h)=>{Array.isArray(h)?this.sortedPathsRules.push({from:m,to:h}):this.sortedPathsRules.push({from:m,to:[h]})}),this.sortedPathsRules.sort((m,h)=>h.from.length-m.from.length)}cloneAndMerge(m){return new D(this._env,r.mergeConfigurationOptions(m,this.options))}getOptionsLiteral(){return this.options}_applyPaths(m){let h;for(let v=0,l=this.sortedPathsRules.length;v<l;v++)if(h=this.sortedPathsRules[v],W.Utilities.startsWith(m,h.from)){let a=[];for(let g=0,e=h.to.length;g<e;g++)a.push(h.to[g]+m.substr(h.from.length));return a}return[m]}_addUrlArgsToUrl(m){return W.Utilities.containsQueryString(m)?m+"&"+this.options.urlArgs:m+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(m){return this.options.urlArgs?this._addUrlArgsToUrl(m):m}_addUrlArgsIfNecessaryToUrls(m){if(this.options.urlArgs)for(let h=0,v=m.length;h<v;h++)m[h]=this._addUrlArgsToUrl(m[h]);return m}moduleIdToPaths(m){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(m))return this.isBuild()?["empty:"]:["node|"+m];let h=m,v;if(!W.Utilities.endsWith(h,".js")&&!W.Utilities.isAbsolutePath(h)){v=this._applyPaths(h);for(let l=0,a=v.length;l<a;l++)this.isBuild()&&v[l]==="empty:"||(W.Utilities.isAbsolutePath(v[l])||(v[l]=this.options.baseUrl+v[l]),!W.Utilities.endsWith(v[l],".js")&&!W.Utilities.containsQueryString(v[l])&&(v[l]=v[l]+".js"))}else!W.Utilities.endsWith(h,".js")&&!W.Utilities.containsQueryString(h)&&(h=h+".js"),v=[h];return this._addUrlArgsIfNecessaryToUrls(v)}requireToUrl(m){let h=m;return W.Utilities.isAbsolutePath(h)||(h=this._applyPaths(h)[0],W.Utilities.isAbsolutePath(h)||(h=this.options.baseUrl+h)),this._addUrlArgsIfNecessaryToUrl(h)}isBuild(){return this.options.isBuild}shouldInvokeFactory(m){return!!(!this.options.isBuild||W.Utilities.isAnonymousModule(m)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[m])}isDuplicateMessageIgnoredFor(m){return this.ignoreDuplicateModulesMap.hasOwnProperty(m)}getConfigForModule(m){if(this.options.config)return this.options.config[m]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(m){this.options.onError(m)}}W.Configuration=D})(le||(le={}));var le;(function(W){class n{constructor(a){this._env=a,this._scriptLoader=null,this._callbackMap={}}load(a,g,e,c){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new A;else if(this._env.isElectronRenderer){const{preferScriptTags:u}=a.getConfig().getOptionsLiteral();u?this._scriptLoader=new r:this._scriptLoader=new m(this._env)}else this._env.isNode?this._scriptLoader=new m(this._env):this._scriptLoader=new r;let i={callback:e,errorback:c};if(this._callbackMap.hasOwnProperty(g)){this._callbackMap[g].push(i);return}this._callbackMap[g]=[i],this._scriptLoader.load(a,g,()=>this.triggerCallback(g),u=>this.triggerErrorback(g,u))}triggerCallback(a){let g=this._callbackMap[a];delete this._callbackMap[a];for(let e=0;e<g.length;e++)g[e].callback()}triggerErrorback(a,g){let e=this._callbackMap[a];delete this._callbackMap[a];for(let c=0;c<e.length;c++)e[c].errorback(g)}}class r{attachListeners(a,g,e){let c=()=>{a.removeEventListener("load",i),a.removeEventListener("error",u)},i=d=>{c(),g()},u=d=>{c(),e(d)};a.addEventListener("load",i),a.addEventListener("error",u)}load(a,g,e,c){if(/^node\|/.test(g)){let i=a.getConfig().getOptionsLiteral(),u=h(a.getRecorder(),i.nodeRequire||W.global.nodeRequire),d=g.split("|"),f=null;try{f=u(d[1])}catch(C){c(C);return}a.enqueueDefineAnonymousModule([],()=>f),e()}else{let i=document.createElement("script");i.setAttribute("async","async"),i.setAttribute("type","text/javascript"),this.attachListeners(i,e,c);const{trustedTypesPolicy:u}=a.getConfig().getOptionsLiteral();u&&(g=u.createScriptURL(g)),i.setAttribute("src",g);const{cspNonce:d}=a.getConfig().getOptionsLiteral();d&&i.setAttribute("nonce",d),document.getElementsByTagName("head")[0].appendChild(i)}}}function D(l){const{trustedTypesPolicy:a}=l.getConfig().getOptionsLiteral();try{return(a?self.eval(a.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class A{constructor(){this._cachedCanUseEval=null}_canUseEval(a){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=D(a)),this._cachedCanUseEval}load(a,g,e,c){if(/^node\|/.test(g)){const i=a.getConfig().getOptionsLiteral(),u=h(a.getRecorder(),i.nodeRequire||W.global.nodeRequire),d=g.split("|");let f=null;try{f=u(d[1])}catch(C){c(C);return}a.enqueueDefineAnonymousModule([],function(){return f}),e()}else{const{trustedTypesPolicy:i}=a.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(g)&&g.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(a)){fetch(g).then(d=>{if(d.status!==200)throw new Error(d.statusText);return d.text()}).then(d=>{d=`${d}
//# sourceURL=${g}`,(i?self.eval(i.createScript("",d)):new Function(d)).call(self),e()}).then(void 0,c);return}try{i&&(g=i.createScriptURL(g)),importScripts(g),e()}catch(d){c(d)}}}}class m{constructor(a){this._env=a,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(a){this._didInitialize||(this._didInitialize=!0,this._fs=a("fs"),this._vm=a("vm"),this._path=a("path"),this._crypto=a("crypto"))}_initNodeRequire(a,g){const{nodeCachedData:e}=g.getConfig().getOptionsLiteral();if(!e||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const c=this,i=a("module");function u(d){const f=d.constructor;let C=function(S){try{return d.require(S)}finally{}};return C.resolve=function(S,M){return f._resolveFilename(S,d,!1,M)},C.resolve.paths=function(S){return f._resolveLookupPaths(S,d)},C.main=process.mainModule,C.extensions=f._extensions,C.cache=f._cache,C}i.prototype._compile=function(d,f){const C=i.wrap(d.replace(/^#!.*/,"")),_=g.getRecorder(),S=c._getCachedDataPath(e,f),M={filename:f};let L;try{const y=c._fs.readFileSync(S);L=y.slice(0,16),M.cachedData=y.slice(16),_.record(60,S)}catch{_.record(61,S)}const b=new c._vm.Script(C,M),s=b.runInThisContext(M),o=c._path.dirname(f),p=u(this),w=[this.exports,p,this,f,o,process,Ae,Buffer],N=s.apply(this.exports,w);return c._handleCachedData(b,C,S,!M.cachedData,g),c._verifyCachedData(b,C,S,L,g),N}}load(a,g,e,c){const i=a.getConfig().getOptionsLiteral(),u=h(a.getRecorder(),i.nodeRequire||W.global.nodeRequire),d=i.nodeInstrumenter||function(C){return C};this._init(u),this._initNodeRequire(u,a);let f=a.getRecorder();if(/^node\|/.test(g)){let C=g.split("|"),_=null;try{_=u(C[1])}catch(S){c(S);return}a.enqueueDefineAnonymousModule([],()=>_),e()}else{g=W.Utilities.fileUriToFilePath(this._env.isWindows,g);const C=this._path.normalize(g),_=this._getElectronRendererScriptPathOrUri(C),S=!!i.nodeCachedData,M=S?this._getCachedDataPath(i.nodeCachedData,g):void 0;this._readSourceAndCachedData(C,M,f,(L,b,s,o)=>{if(L){c(L);return}let p;b.charCodeAt(0)===m._BOM?p=m._PREFIX+b.substring(1)+m._SUFFIX:p=m._PREFIX+b+m._SUFFIX,p=d(p,C);const w={filename:_,cachedData:s},N=this._createAndEvalScript(a,p,w,e,c);this._handleCachedData(N,p,M,S&&!s,a),this._verifyCachedData(N,p,M,o,a)})}}_createAndEvalScript(a,g,e,c,i){const u=a.getRecorder();u.record(31,e.filename);const d=new this._vm.Script(g,e),f=d.runInThisContext(e),C=a.getGlobalAMDDefineFunc();let _=!1;const S=function(){return _=!0,C.apply(null,arguments)};return S.amd=C.amd,f.call(W.global,a.getGlobalAMDRequireFunc(),S,e.filename,this._path.dirname(e.filename)),u.record(32,e.filename),_?c():i(new Error(`Didn't receive define call in ${e.filename}!`)),d}_getElectronRendererScriptPathOrUri(a){if(!this._env.isElectronRenderer)return a;let g=a.match(/^([a-z])\:(.*)/i);return g?`file:///${(g[1].toUpperCase()+":"+g[2]).replace(/\\/g,"/")}`:`file://${a}`}_getCachedDataPath(a,g){const e=this._crypto.createHash("md5").update(g,"utf8").update(a.seed,"utf8").update(process.arch,"").digest("hex"),c=this._path.basename(g).replace(/\.js$/,"");return this._path.join(a.path,`${c}-${e}.code`)}_handleCachedData(a,g,e,c,i){a.cachedDataRejected?this._fs.unlink(e,u=>{i.getRecorder().record(62,e),this._createAndWriteCachedData(a,g,e,i),u&&i.getConfig().onError(u)}):c&&this._createAndWriteCachedData(a,g,e,i)}_createAndWriteCachedData(a,g,e,c){let i=Math.ceil(c.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),u=-1,d=0,f;const C=()=>{setTimeout(()=>{f||(f=this._crypto.createHash("md5").update(g,"utf8").digest());const _=a.createCachedData();if(!(_.length===0||_.length===u||d>=5)){if(_.length<u){C();return}u=_.length,this._fs.writeFile(e,Buffer.concat([f,_]),S=>{S&&c.getConfig().onError(S),c.getRecorder().record(63,e),C()})}},i*Math.pow(4,d++))};C()}_readSourceAndCachedData(a,g,e,c){if(!g)this._fs.readFile(a,{encoding:"utf8"},c);else{let i,u,d,f=2;const C=_=>{_?c(_):--f===0&&c(void 0,i,u,d)};this._fs.readFile(a,{encoding:"utf8"},(_,S)=>{i=S,C(_)}),this._fs.readFile(g,(_,S)=>{!_&&S&&S.length>0?(d=S.slice(0,16),u=S.slice(16),e.record(60,g)):e.record(61,g),C()})}}_verifyCachedData(a,g,e,c,i){c&&(a.cachedDataRejected||setTimeout(()=>{const u=this._crypto.createHash("md5").update(g,"utf8").digest();c.equals(u)||(i.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${e}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(e,d=>{d&&i.getConfig().onError(d)}))},Math.ceil(5e3*(1+Math.random()))))}}m._BOM=65279,m._PREFIX="(function (require, define, __filename, __dirname) { ",m._SUFFIX=`
});`;function h(l,a){if(a.__$__isRecorded)return a;const g=function(c){l.record(33,c);try{return a(c)}finally{l.record(34,c)}};return g.__$__isRecorded=!0,g}W.ensureRecordedNodeRequire=h;function v(l){return new n(l)}W.createScriptLoader=v})(le||(le={}));var le;(function(W){class n{constructor(l){let a=l.lastIndexOf("/");a!==-1?this.fromModulePath=l.substr(0,a+1):this.fromModulePath=""}static _normalizeModuleId(l){let a=l,g;for(g=/\/\.\//;g.test(a);)a=a.replace(g,"/");for(a=a.replace(/^\.\//g,""),g=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;g.test(a);)a=a.replace(g,"/");return a=a.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),a}resolveModule(l){let a=l;return W.Utilities.isAbsolutePath(a)||(W.Utilities.startsWith(a,"./")||W.Utilities.startsWith(a,"../"))&&(a=n._normalizeModuleId(this.fromModulePath+a)),a}}n.ROOT=new n(""),W.ModuleIdResolver=n;class r{constructor(l,a,g,e,c,i){this.id=l,this.strId=a,this.dependencies=g,this._callback=e,this._errorback=c,this.moduleIdResolver=i,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(l,a){try{return{returnedValue:l.apply(W.global,a),producedError:null}}catch(g){return{returnedValue:null,producedError:g}}}static _invokeFactory(l,a,g,e){return l.shouldInvokeFactory(a)?l.shouldCatchError()?this._safeInvokeFunction(g,e):{returnedValue:g.apply(W.global,e),producedError:null}:{returnedValue:null,producedError:null}}complete(l,a,g,e){this._isComplete=!0;let c=null;if(this._callback)if(typeof this._callback=="function"){l.record(21,this.strId);let i=r._invokeFactory(a,this.strId,this._callback,g);c=i.producedError,l.record(22,this.strId),!c&&typeof i.returnedValue<"u"&&(!this.exportsPassedIn||W.Utilities.isEmpty(this.exports))&&(this.exports=i.returnedValue)}else this.exports=this._callback;if(c){let i=W.ensureError(c);i.phase="factory",i.moduleId=this.strId,i.neededBy=e(this.id),this.error=i,a.onError(i)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(l){return this._isComplete=!0,this.error=l,this._errorback?(this._errorback(l),!0):!1}isComplete(){return this._isComplete}}W.Module=r;class D{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(l){let a=this._strModuleIdToIntModuleId.get(l);return typeof a>"u"&&(a=this._nextId++,this._strModuleIdToIntModuleId.set(l,a),this._intModuleIdToStrModuleId[a]=l),a}getStrModuleId(l){return this._intModuleIdToStrModuleId[l]}}class A{constructor(l){this.id=l}}A.EXPORTS=new A(0),A.MODULE=new A(1),A.REQUIRE=new A(2),W.RegularDependency=A;class m{constructor(l,a,g){this.id=l,this.pluginId=a,this.pluginParam=g}}W.PluginDependency=m;class h{constructor(l,a,g,e,c=0){this._env=l,this._scriptLoader=a,this._loaderAvailableTimestamp=c,this._defineFunc=g,this._requireFunc=e,this._moduleIdProvider=new D,this._config=new W.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new h(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(l,a){let g=i=>i.replace(/\\/g,"/"),e=g(l),c=a.split(/\n/);for(let i=0;i<c.length;i++){let u=c[i].match(/(.*):(\d+):(\d+)\)?$/);if(u){let d=u[1],f=u[2],C=u[3],_=Math.max(d.lastIndexOf(" ")+1,d.lastIndexOf("(")+1);if(d=d.substr(_),d=g(d),d===e){let S={line:parseInt(f,10),col:parseInt(C,10)};return S.line===1&&(S.col-=53),S}}}throw new Error("Could not correlate define call site for needle "+l)}getBuildInfo(){if(!this._config.isBuild())return null;let l=[],a=0;for(let g=0,e=this._modules2.length;g<e;g++){let c=this._modules2[g];if(!c)continue;let i=this._buildInfoPath[c.id]||null,u=this._buildInfoDefineStack[c.id]||null,d=this._buildInfoDependencies[c.id];l[a++]={id:c.strId,path:i,defineLocation:i&&u?h._findRelevantLocationInStack(i,u):null,dependencies:d,shim:null,exports:c.exports}}return l}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new W.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=W.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(l,a){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let g=null;this._config.isBuild()&&(g=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:g,dependencies:l,callback:a}}defineModule(l,a,g,e,c,i=new n(l)){let u=this._moduleIdProvider.getModuleId(l);if(this._modules2[u]){this._config.isDuplicateMessageIgnoredFor(l)||console.warn("Duplicate definition of module '"+l+"'");return}let d=new r(u,l,this._normalizeDependencies(a,i),g,e,i);this._modules2[u]=d,this._config.isBuild()&&(this._buildInfoDefineStack[u]=c,this._buildInfoDependencies[u]=(d.dependencies||[]).map(f=>this._moduleIdProvider.getStrModuleId(f.id))),this._resolve(d)}_normalizeDependency(l,a){if(l==="exports")return A.EXPORTS;if(l==="module")return A.MODULE;if(l==="require")return A.REQUIRE;let g=l.indexOf("!");if(g>=0){let e=a.resolveModule(l.substr(0,g)),c=a.resolveModule(l.substr(g+1)),i=this._moduleIdProvider.getModuleId(e+"!"+c),u=this._moduleIdProvider.getModuleId(e);return new m(i,u,c)}return new A(this._moduleIdProvider.getModuleId(a.resolveModule(l)))}_normalizeDependencies(l,a){let g=[],e=0;for(let c=0,i=l.length;c<i;c++)g[e++]=this._normalizeDependency(l[c],a);return g}_relativeRequire(l,a,g,e){if(typeof a=="string")return this.synchronousRequire(a,l);this.defineModule(W.Utilities.generateAnonymousModule(),a,g,e,null,l)}synchronousRequire(l,a=new n(l)){let g=this._normalizeDependency(l,a),e=this._modules2[g.id];if(!e)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This is the first mention of this module!");if(!e.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This module has not been resolved completely yet.");if(e.error)throw e.error;return e.exports}configure(l,a){let g=this._config.shouldRecordStats();a?this._config=new W.Configuration(this._env,l):this._config=this._config.cloneAndMerge(l),this._config.shouldRecordStats()&&!g&&(this._recorder=null)}getConfig(){return this._config}_onLoad(l){if(this._currentAnonymousDefineCall!==null){let a=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(l),a.dependencies,a.callback,null,a.stack)}}_createLoadError(l,a){let g=this._moduleIdProvider.getStrModuleId(l),e=(this._inverseDependencies2[l]||[]).map(i=>this._moduleIdProvider.getStrModuleId(i));const c=W.ensureError(a);return c.phase="loading",c.moduleId=g,c.neededBy=e,c}_onLoadError(l,a){const g=this._createLoadError(l,a);this._modules2[l]||(this._modules2[l]=new r(l,this._moduleIdProvider.getStrModuleId(l),[],()=>{},null,null));let e=[];for(let u=0,d=this._moduleIdProvider.getMaxModuleId();u<d;u++)e[u]=!1;let c=!1,i=[];for(i.push(l),e[l]=!0;i.length>0;){let u=i.shift(),d=this._modules2[u];d&&(c=d.onDependencyError(g)||c);let f=this._inverseDependencies2[u];if(f)for(let C=0,_=f.length;C<_;C++){let S=f[C];e[S]||(i.push(S),e[S]=!0)}}c||this._config.onError(g)}_hasDependencyPath(l,a){let g=this._modules2[l];if(!g)return!1;let e=[];for(let i=0,u=this._moduleIdProvider.getMaxModuleId();i<u;i++)e[i]=!1;let c=[];for(c.push(g),e[l]=!0;c.length>0;){let u=c.shift().dependencies;if(u)for(let d=0,f=u.length;d<f;d++){let C=u[d];if(C.id===a)return!0;let _=this._modules2[C.id];_&&!e[C.id]&&(e[C.id]=!0,c.push(_))}}return!1}_findCyclePath(l,a,g){if(l===a||g===50)return[l];let e=this._modules2[l];if(!e)return null;let c=e.dependencies;if(c)for(let i=0,u=c.length;i<u;i++){let d=this._findCyclePath(c[i].id,a,g+1);if(d!==null)return d.push(l),d}return null}_createRequire(l){let a=(g,e,c)=>this._relativeRequire(l,g,e,c);return a.toUrl=g=>this._config.requireToUrl(l.resolveModule(g)),a.getStats=()=>this.getLoaderEvents(),a.hasDependencyCycle=()=>this._hasDependencyCycle,a.config=(g,e=!1)=>{this.configure(g,e)},a.__$__nodeRequire=W.global.nodeRequire,a}_loadModule(l){if(this._modules2[l]||this._knownModules2[l])return;this._knownModules2[l]=!0;let a=this._moduleIdProvider.getStrModuleId(l),g=this._config.moduleIdToPaths(a),e=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(a.indexOf("/")===-1||e.test(a))&&g.push("node|"+a);let c=-1,i=u=>{if(c++,c>=g.length)this._onLoadError(l,u);else{let d=g[c],f=this.getRecorder();if(this._config.isBuild()&&d==="empty:"){this._buildInfoPath[l]=d,this.defineModule(this._moduleIdProvider.getStrModuleId(l),[],null,null,null),this._onLoad(l);return}f.record(10,d),this._scriptLoader.load(this,d,()=>{this._config.isBuild()&&(this._buildInfoPath[l]=d),f.record(11,d),this._onLoad(l)},C=>{f.record(12,d),i(C)})}};i(null)}_loadPluginDependency(l,a){if(this._modules2[a.id]||this._knownModules2[a.id])return;this._knownModules2[a.id]=!0;let g=e=>{this.defineModule(this._moduleIdProvider.getStrModuleId(a.id),[],e,null,null)};g.error=e=>{this._config.onError(this._createLoadError(a.id,e))},l.load(a.pluginParam,this._createRequire(n.ROOT),g,this._config.getOptionsLiteral())}_resolve(l){let a=l.dependencies;if(a)for(let g=0,e=a.length;g<e;g++){let c=a[g];if(c===A.EXPORTS){l.exportsPassedIn=!0,l.unresolvedDependenciesCount--;continue}if(c===A.MODULE){l.unresolvedDependenciesCount--;continue}if(c===A.REQUIRE){l.unresolvedDependenciesCount--;continue}let i=this._modules2[c.id];if(i&&i.isComplete()){if(i.error){l.onDependencyError(i.error);return}l.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(c.id,l.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(c.id)+"' and '"+this._moduleIdProvider.getStrModuleId(l.id)+"'. The cyclic path follows:");let u=this._findCyclePath(c.id,l.id,0)||[];u.reverse(),u.push(c.id),console.warn(u.map(d=>this._moduleIdProvider.getStrModuleId(d)).join(` => 
`)),l.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[c.id]=this._inverseDependencies2[c.id]||[],this._inverseDependencies2[c.id].push(l.id),c instanceof m){let u=this._modules2[c.pluginId];if(u&&u.isComplete()){this._loadPluginDependency(u.exports,c);continue}let d=this._inversePluginDependencies2.get(c.pluginId);d||(d=[],this._inversePluginDependencies2.set(c.pluginId,d)),d.push(c),this._loadModule(c.pluginId);continue}this._loadModule(c.id)}l.unresolvedDependenciesCount===0&&this._onModuleComplete(l)}_onModuleComplete(l){let a=this.getRecorder();if(l.isComplete())return;let g=l.dependencies,e=[];if(g)for(let d=0,f=g.length;d<f;d++){let C=g[d];if(C===A.EXPORTS){e[d]=l.exports;continue}if(C===A.MODULE){e[d]={id:l.strId,config:()=>this._config.getConfigForModule(l.strId)};continue}if(C===A.REQUIRE){e[d]=this._createRequire(l.moduleIdResolver);continue}let _=this._modules2[C.id];if(_){e[d]=_.exports;continue}e[d]=null}const c=d=>(this._inverseDependencies2[d]||[]).map(f=>this._moduleIdProvider.getStrModuleId(f));l.complete(a,this._config,e,c);let i=this._inverseDependencies2[l.id];if(this._inverseDependencies2[l.id]=null,i)for(let d=0,f=i.length;d<f;d++){let C=i[d],_=this._modules2[C];_.unresolvedDependenciesCount--,_.unresolvedDependenciesCount===0&&this._onModuleComplete(_)}let u=this._inversePluginDependencies2.get(l.id);if(u){this._inversePluginDependencies2.delete(l.id);for(let d=0,f=u.length;d<f;d++)this._loadPluginDependency(l.exports,u[d])}}}W.ModuleManager=h})(le||(le={}));var Y,le;(function(W){const n=new W.Environment;let r=null;const D=function(v,l,a){typeof v!="string"&&(a=l,l=v,v=null),(typeof l!="object"||!Array.isArray(l))&&(a=l,l=null),l||(l=["require","exports","module"]),v?r.defineModule(v,l,a,null,null):r.enqueueDefineAnonymousModule(l,a)};D.amd={jQuery:!0};const A=function(v,l=!1){r.configure(v,l)},m=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){A(arguments[0]);return}if(typeof arguments[0]=="string")return r.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){r.defineModule(W.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};m.config=A,m.getConfig=function(){return r.getConfig().getOptionsLiteral()},m.reset=function(){r=r.reset()},m.getBuildInfo=function(){return r.getBuildInfo()},m.getStats=function(){return r.getLoaderEvents()},m.define=D;function h(){if(typeof W.global.require<"u"||typeof require<"u"){const v=W.global.require||require;if(typeof v=="function"&&typeof v.resolve=="function"){const l=W.ensureRecordedNodeRequire(r.getRecorder(),v);W.global.nodeRequire=l,m.nodeRequire=l,m.__$__nodeRequire=l}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?module.exports=m:(n.isElectronRenderer||(W.global.define=D),W.global.require=m)}W.init=h,(typeof W.global.define!="function"||!W.global.define.amd)&&(r=new W.ModuleManager(n,W.createScriptLoader(n),D,m,W.Utilities.getHighPerformanceTimestamp()),typeof W.global.require<"u"&&typeof W.global.require!="function"&&m.config(W.global.require),Y=function(){return D.apply(null,arguments)},Y.amd=D.amd,typeof doNotInitLoader>"u"&&h())})(le||(le={})),function(){const W=globalThis.MonacoEnvironment,n=W&&W.baseUrl?W.baseUrl:"../../../";function r(g,e){var c;if(W?.createTrustedTypesPolicy)try{return W.createTrustedTypesPolicy(g,e)}catch(i){console.warn(i);return}try{return(c=self.trustedTypes)===null||c===void 0?void 0:c.createPolicy(g,e)}catch(i){console.warn(i);return}}const D=r("amdLoader",{createScriptURL:g=>g,createScript:(g,...e)=>{const c=e.slice(0,-1).join(","),i=e.pop().toString();return`(function anonymous(${c}) { ${i}
})`}});function A(){try{return(D?globalThis.eval(D.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function m(){return new Promise((g,e)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return g();const c=n+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(c)&&c.substring(0,globalThis.origin.length)!==globalThis.origin)&&A()){fetch(c).then(u=>{if(u.status!==200)throw new Error(u.statusText);return u.text()}).then(u=>{u=`${u}
//# sourceURL=${c}`,(D?globalThis.eval(D.createScript("",u)):new Function(u)).call(globalThis),g()}).then(void 0,e);return}D?importScripts(D.createScriptURL(c)):importScripts(c),g()})}function h(){require.config({baseUrl:n,catchError:!0,trustedTypesPolicy:D,amdModulesPattern:/^vs\//})}function v(g){m().then(()=>{h(),require([g],function(e){setTimeout(function(){const c=e.create((i,u)=>{globalThis.postMessage(i,u)},null);for(globalThis.onmessage=i=>c.onmessage(i.data,i.ports);a.length>0;){const i=a.shift();c.onmessage(i.data,i.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&h();let l=!0;const a=[];globalThis.onmessage=g=>{if(!l){a.push(g);return}l=!1,v(g.data)}}(),Y(J[7],Z([0,1]),function(W,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Permutation=n.CallbackIterable=n.ArrayQueue=n.booleanComparator=n.numberComparator=n.CompareResult=void 0,n.tail=r,n.tail2=D,n.equals=A,n.removeFastWithoutKeepingOrder=m,n.binarySearch=h,n.binarySearch2=v,n.quickSelect=l,n.groupBy=a,n.groupAdjacentBy=g,n.forEachAdjacent=e,n.forEachWithNeighbors=c,n.coalesce=i,n.coalesceInPlace=u,n.isFalsyOrEmpty=d,n.isNonEmptyArray=f,n.distinct=C,n.firstOrDefault=_,n.range=S,n.arrayInsert=M,n.pushToStart=L,n.pushToEnd=b,n.pushMany=s,n.asArray=o,n.insertInto=p,n.splice=w,n.compareBy=E,n.tieBreakComparators=R,n.reverseOrder=F;function r(T,O=0){return T[T.length-(1+O)]}function D(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}function A(T,O,B=(z,j)=>z===j){if(T===O)return!0;if(!T||!O||T.length!==O.length)return!1;for(let z=0,j=T.length;z<j;z++)if(!B(T[z],O[z]))return!1;return!0}function m(T,O){const B=T.length-1;O<B&&(T[O]=T[B]),T.pop()}function h(T,O,B){return v(T.length,z=>B(T[z],O))}function v(T,O){let B=0,z=T-1;for(;B<=z;){const j=(B+z)/2|0,K=O(j);if(K<0)B=j+1;else if(K>0)z=j-1;else return j}return-(B+1)}function l(T,O,B){if(T=T|0,T>=O.length)throw new TypeError("invalid index");const z=O[Math.floor(O.length*Math.random())],j=[],K=[],ne=[];for(const se of O){const oe=B(se,z);oe<0?j.push(se):oe>0?K.push(se):ne.push(se)}return T<j.length?l(T,j,B):T<j.length+ne.length?ne[0]:l(T-(j.length+ne.length),K,B)}function a(T,O){const B=[];let z;for(const j of T.slice(0).sort(O))!z||O(z[0],j)!==0?(z=[j],B.push(z)):z.push(j);return B}function*g(T,O){let B,z;for(const j of T)z!==void 0&&O(z,j)?B.push(j):(B&&(yield B),B=[j]),z=j;B&&(yield B)}function e(T,O){for(let B=0;B<=T.length;B++)O(B===0?void 0:T[B-1],B===T.length?void 0:T[B])}function c(T,O){for(let B=0;B<T.length;B++)O(B===0?void 0:T[B-1],T[B],B+1===T.length?void 0:T[B+1])}function i(T){return T.filter(O=>!!O)}function u(T){let O=0;for(let B=0;B<T.length;B++)T[B]&&(T[O]=T[B],O+=1);T.length=O}function d(T){return!Array.isArray(T)||T.length===0}function f(T){return Array.isArray(T)&&T.length>0}function C(T,O=B=>B){const B=new Set;return T.filter(z=>{const j=O(z);return B.has(j)?!1:(B.add(j),!0)})}function _(T,O){return T.length>0?T[0]:O}function S(T,O){let B=typeof O=="number"?T:0;typeof O=="number"?B=T:(B=0,O=T);const z=[];if(B<=O)for(let j=B;j<O;j++)z.push(j);else for(let j=B;j>O;j--)z.push(j);return z}function M(T,O,B){const z=T.slice(0,O),j=T.slice(O);return z.concat(B,j)}function L(T,O){const B=T.indexOf(O);B>-1&&(T.splice(B,1),T.unshift(O))}function b(T,O){const B=T.indexOf(O);B>-1&&(T.splice(B,1),T.push(O))}function s(T,O){for(const B of O)T.push(B)}function o(T){return Array.isArray(T)?T:[T]}function p(T,O,B){const z=N(T,O),j=T.length,K=B.length;T.length=j+K;for(let ne=j-1;ne>=z;ne--)T[ne+K]=T[ne];for(let ne=0;ne<K;ne++)T[ne+z]=B[ne]}function w(T,O,B,z){const j=N(T,O);let K=T.splice(j,B);return K===void 0&&(K=[]),p(T,j,z),K}function N(T,O){return O<0?Math.max(O+T.length,0):Math.min(O,T.length)}var y;(function(T){function O(K){return K<0}T.isLessThan=O;function B(K){return K<=0}T.isLessThanOrEqual=B;function z(K){return K>0}T.isGreaterThan=z;function j(K){return K===0}T.isNeitherLessOrGreaterThan=j,T.greaterThan=1,T.lessThan=-1,T.neitherLessOrGreaterThan=0})(y||(n.CompareResult=y={}));function E(T,O){return(B,z)=>O(T(B),T(z))}function R(...T){return(O,B)=>{for(const z of T){const j=z(O,B);if(!y.isNeitherLessOrGreaterThan(j))return j}return y.neitherLessOrGreaterThan}}const x=(T,O)=>T-O;n.numberComparator=x;const P=(T,O)=>(0,n.numberComparator)(T?1:0,O?1:0);n.booleanComparator=P;function F(T){return(O,B)=>-T(O,B)}class I{constructor(O){this.items=O,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(O){let B=this.firstIdx;for(;B<this.items.length&&O(this.items[B]);)B++;const z=B===this.firstIdx?null:this.items.slice(this.firstIdx,B);return this.firstIdx=B,z}takeFromEndWhile(O){let B=this.lastIdx;for(;B>=0&&O(this.items[B]);)B--;const z=B===this.lastIdx?null:this.items.slice(B+1,this.lastIdx+1);return this.lastIdx=B,z}peek(){if(this.length!==0)return this.items[this.firstIdx]}dequeue(){const O=this.items[this.firstIdx];return this.firstIdx++,O}takeCount(O){const B=this.items.slice(this.firstIdx,this.firstIdx+O);return this.firstIdx+=O,B}}n.ArrayQueue=I;class V{constructor(O){this.iterate=O}toArray(){const O=[];return this.iterate(B=>(O.push(B),!0)),O}filter(O){return new V(B=>this.iterate(z=>O(z)?B(z):!0))}map(O){return new V(B=>this.iterate(z=>B(O(z))))}findLast(O){let B;return this.iterate(z=>(O(z)&&(B=z),!0)),B}findLastMaxBy(O){let B,z=!0;return this.iterate(j=>((z||y.isGreaterThan(O(j,B)))&&(z=!1,B=j),!0)),B}}n.CallbackIterable=V,V.empty=new V(T=>{});class ${constructor(O){this._indexMap=O}static createSortPermutation(O,B){const z=Array.from(O.keys()).sort((j,K)=>B(O[j],O[K]));return new $(z)}apply(O){return O.map((B,z)=>O[this._indexMap[z]])}inverse(){const O=this._indexMap.slice();for(let B=0;B<this._indexMap.length;B++)O[this._indexMap[B]]=B;return new $(O)}}n.Permutation=$}),Y(J[12],Z([0,1]),function(W,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MonotonousArray=void 0,n.findLast=r,n.findLastIdx=D,n.findLastMonotonous=A,n.findLastIdxMonotonous=m,n.findFirstMonotonous=h,n.findFirstIdxMonotonousOrArrLen=v,n.findFirstMax=a,n.findLastMax=g,n.findFirstMin=e,n.findMaxIdx=c,n.mapFindFirst=i;function r(u,d){const f=D(u,d);if(f!==-1)return u[f]}function D(u,d,f=u.length-1){for(let C=f;C>=0;C--){const _=u[C];if(d(_))return C}return-1}function A(u,d){const f=m(u,d);return f===-1?void 0:u[f]}function m(u,d,f=0,C=u.length){let _=f,S=C;for(;_<S;){const M=Math.floor((_+S)/2);d(u[M])?_=M+1:S=M}return _-1}function h(u,d){const f=v(u,d);return f===u.length?void 0:u[f]}function v(u,d,f=0,C=u.length){let _=f,S=C;for(;_<S;){const M=Math.floor((_+S)/2);d(u[M])?S=M:_=M+1}return _}class l{constructor(d){this._array=d,this._findLastMonotonousLastIdx=0}findLastMonotonous(d){if(l.assertInvariants){if(this._prevFindLastPredicate){for(const C of this._array)if(this._prevFindLastPredicate(C)&&!d(C))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=d}const f=m(this._array,d,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=f+1,f===-1?void 0:this._array[f]}}n.MonotonousArray=l,l.assertInvariants=!1;function a(u,d){if(u.length===0)return;let f=u[0];for(let C=1;C<u.length;C++){const _=u[C];d(_,f)>0&&(f=_)}return f}function g(u,d){if(u.length===0)return;let f=u[0];for(let C=1;C<u.length;C++){const _=u[C];d(_,f)>=0&&(f=_)}return f}function e(u,d){return a(u,(f,C)=>-d(f,C))}function c(u,d){if(u.length===0)return-1;let f=0;for(let C=1;C<u.length;C++){const _=u[C];d(_,u[f])>0&&(f=C)}return f}function i(u,d){for(const f of u){const C=d(f);if(C!==void 0)return C}}}),Y(J[34],Z([0,1]),function(W,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CachedFunction=n.LRUCachedFunction=void 0,n.identity=r;function r(m){return m}class D{constructor(h,v){this.lastCache=void 0,this.lastArgKey=void 0,typeof h=="function"?(this._fn=h,this._computeKey=r):(this._fn=v,this._computeKey=h.getCacheKey)}get(h){const v=this._computeKey(h);return this.lastArgKey!==v&&(this.lastArgKey=v,this.lastCache=this._fn(h)),this.lastCache}}n.LRUCachedFunction=D;class A{get cachedValues(){return this._map}constructor(h,v){this._map=new Map,this._map2=new Map,typeof h=="function"?(this._fn=h,this._computeKey=r):(this._fn=v,this._computeKey=h.getCacheKey)}get(h){const v=this._computeKey(h);if(this._map2.has(v))return this._map2.get(v);const l=this._fn(h);return this._map.set(h,l),this._map2.set(v,l),l}}n.CachedFunction=A}),Y(J[35],Z([0,1]),function(W,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Color=n.HSVA=n.HSLA=n.RGBA=void 0;function r(v,l){const a=Math.pow(10,l);return Math.round(v*a)/a}class D{constructor(l,a,g,e=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,l))|0,this.g=Math.min(255,Math.max(0,a))|0,this.b=Math.min(255,Math.max(0,g))|0,this.a=r(Math.max(Math.min(1,e),0),3)}static equals(l,a){return l.r===a.r&&l.g===a.g&&l.b===a.b&&l.a===a.a}}n.RGBA=D;class A{constructor(l,a,g,e){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=r(Math.max(Math.min(1,a),0),3),this.l=r(Math.max(Math.min(1,g),0),3),this.a=r(Math.max(Math.min(1,e),0),3)}static equals(l,a){return l.h===a.h&&l.s===a.s&&l.l===a.l&&l.a===a.a}static fromRGBA(l){const a=l.r/255,g=l.g/255,e=l.b/255,c=l.a,i=Math.max(a,g,e),u=Math.min(a,g,e);let d=0,f=0;const C=(u+i)/2,_=i-u;if(_>0){switch(f=Math.min(C<=.5?_/(2*C):_/(2-2*C),1),i){case a:d=(g-e)/_+(g<e?6:0);break;case g:d=(e-a)/_+2;break;case e:d=(a-g)/_+4;break}d*=60,d=Math.round(d)}return new A(d,f,C,c)}static _hue2rgb(l,a,g){return g<0&&(g+=1),g>1&&(g-=1),g<1/6?l+(a-l)*6*g:g<1/2?a:g<2/3?l+(a-l)*(2/3-g)*6:l}static toRGBA(l){const a=l.h/360,{s:g,l:e,a:c}=l;let i,u,d;if(g===0)i=u=d=e;else{const f=e<.5?e*(1+g):e+g-e*g,C=2*e-f;i=A._hue2rgb(C,f,a+1/3),u=A._hue2rgb(C,f,a),d=A._hue2rgb(C,f,a-1/3)}return new D(Math.round(i*255),Math.round(u*255),Math.round(d*255),c)}}n.HSLA=A;class m{constructor(l,a,g,e){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=r(Math.max(Math.min(1,a),0),3),this.v=r(Math.max(Math.min(1,g),0),3),this.a=r(Math.max(Math.min(1,e),0),3)}static equals(l,a){return l.h===a.h&&l.s===a.s&&l.v===a.v&&l.a===a.a}static fromRGBA(l){const a=l.r/255,g=l.g/255,e=l.b/255,c=Math.max(a,g,e),i=Math.min(a,g,e),u=c-i,d=c===0?0:u/c;let f;return u===0?f=0:c===a?f=((g-e)/u%6+6)%6:c===g?f=(e-a)/u+2:f=(a-g)/u+4,new m(Math.round(f*60),d,c,l.a)}static toRGBA(l){const{h:a,s:g,v:e,a:c}=l,i=e*g,u=i*(1-Math.abs(a/60%2-1)),d=e-i;let[f,C,_]=[0,0,0];return a<60?(f=i,C=u):a<120?(f=u,C=i):a<180?(C=i,_=u):a<240?(C=u,_=i):a<300?(f=u,_=i):a<=360&&(f=i,_=u),f=Math.round((f+d)*255),C=Math.round((C+d)*255),_=Math.round((_+d)*255),new D(f,C,_,c)}}n.HSVA=m;class h{static fromHex(l){return h.Format.CSS.parseHex(l)||h.red}static equals(l,a){return!l&&!a?!0:!l||!a?!1:l.equals(a)}get hsla(){return this._hsla?this._hsla:A.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:m.fromRGBA(this.rgba)}constructor(l){if(l)if(l instanceof D)this.rgba=l;else if(l instanceof A)this._hsla=l,this.rgba=A.toRGBA(l);else if(l instanceof m)this._hsva=l,this.rgba=m.toRGBA(l);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(l){return!!l&&D.equals(this.rgba,l.rgba)&&A.equals(this.hsla,l.hsla)&&m.equals(this.hsva,l.hsva)}getRelativeLuminance(){const l=h._relativeLuminanceForComponent(this.rgba.r),a=h._relativeLuminanceForComponent(this.rgba.g),g=h._relativeLuminanceForComponent(this.rgba.b),e=.2126*l+.7152*a+.0722*g;return r(e,4)}static _relativeLuminanceForComponent(l){const a=l/255;return a<=.03928?a/12.92:Math.pow((a+.055)/1.055,2.4)}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(l){const a=this.getRelativeLuminance(),g=l.getRelativeLuminance();return a>g}isDarkerThan(l){const a=this.getRelativeLuminance(),g=l.getRelativeLuminance();return a<g}lighten(l){return new h(new A(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*l,this.hsla.a))}darken(l){return new h(new A(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*l,this.hsla.a))}transparent(l){const{r:a,g,b:e,a:c}=this.rgba;return new h(new D(a,g,e,c*l))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new h(new D(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}makeOpaque(l){if(this.isOpaque()||l.rgba.a!==1)return this;const{r:a,g,b:e,a:c}=this.rgba;return new h(new D(l.rgba.r-c*(l.rgba.r-a),l.rgba.g-c*(l.rgba.g-g),l.rgba.b-c*(l.rgba.b-e),1))}toString(){return this._toString||(this._toString=h.Format.CSS.format(this)),this._toString}static getLighterColor(l,a,g){if(l.isLighterThan(a))return l;g=g||.5;const e=l.getRelativeLuminance(),c=a.getRelativeLuminance();return g=g*(c-e)/c,l.lighten(g)}static getDarkerColor(l,a,g){if(l.isDarkerThan(a))return l;g=g||.5;const e=l.getRelativeLuminance(),c=a.getRelativeLuminance();return g=g*(e-c)/e,l.darken(g)}}n.Color=h,h.white=new h(new D(255,255,255,1)),h.black=new h(new D(0,0,0,1)),h.red=new h(new D(255,0,0,1)),h.blue=new h(new D(0,0,255,1)),h.green=new h(new D(0,255,0,1)),h.cyan=new h(new D(0,255,255,1)),h.lightgrey=new h(new D(211,211,211,1)),h.transparent=new h(new D(0,0,0,0)),function(v){let l;(function(a){let g;(function(e){function c(b){return b.rgba.a===1?`rgb(${b.rgba.r}, ${b.rgba.g}, ${b.rgba.b})`:v.Format.CSS.formatRGBA(b)}e.formatRGB=c;function i(b){return`rgba(${b.rgba.r}, ${b.rgba.g}, ${b.rgba.b}, ${+b.rgba.a.toFixed(2)})`}e.formatRGBA=i;function u(b){return b.hsla.a===1?`hsl(${b.hsla.h}, ${(b.hsla.s*100).toFixed(2)}%, ${(b.hsla.l*100).toFixed(2)}%)`:v.Format.CSS.formatHSLA(b)}e.formatHSL=u;function d(b){return`hsla(${b.hsla.h}, ${(b.hsla.s*100).toFixed(2)}%, ${(b.hsla.l*100).toFixed(2)}%, ${b.hsla.a.toFixed(2)})`}e.formatHSLA=d;function f(b){const s=b.toString(16);return s.length!==2?"0"+s:s}function C(b){return`#${f(b.rgba.r)}${f(b.rgba.g)}${f(b.rgba.b)}`}e.formatHex=C;function _(b,s=!1){return s&&b.rgba.a===1?v.Format.CSS.formatHex(b):`#${f(b.rgba.r)}${f(b.rgba.g)}${f(b.rgba.b)}${f(Math.round(b.rgba.a*255))}`}e.formatHexA=_;function S(b){return b.isOpaque()?v.Format.CSS.formatHex(b):v.Format.CSS.formatRGBA(b)}e.format=S;function M(b){const s=b.length;if(s===0||b.charCodeAt(0)!==35)return null;if(s===7){const o=16*L(b.charCodeAt(1))+L(b.charCodeAt(2)),p=16*L(b.charCodeAt(3))+L(b.charCodeAt(4)),w=16*L(b.charCodeAt(5))+L(b.charCodeAt(6));return new v(new D(o,p,w,1))}if(s===9){const o=16*L(b.charCodeAt(1))+L(b.charCodeAt(2)),p=16*L(b.charCodeAt(3))+L(b.charCodeAt(4)),w=16*L(b.charCodeAt(5))+L(b.charCodeAt(6)),N=16*L(b.charCodeAt(7))+L(b.charCodeAt(8));return new v(new D(o,p,w,N/255))}if(s===4){const o=L(b.charCodeAt(1)),p=L(b.charCodeAt(2)),w=L(b.charCodeAt(3));return new v(new D(16*o+o,16*p+p,16*w+w))}if(s===5){const o=L(b.charCodeAt(1)),p=L(b.charCodeAt(2)),w=L(b.charCodeAt(3)),N=L(b.charCodeAt(4));return new v(new D(16*o+o,16*p+p,16*w+w,(16*N+N)/255))}return null}e.parseHex=M;function L(b){switch(b){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(g=a.CSS||(a.CSS={}))})(l=v.Format||(v.Format={}))}(h||(n.Color=h={}))}),Y(J[36],Z([0,1]),function(W,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class r{constructor(A,m,h,v){this.originalStart=A,this.originalLength=m,this.modifiedStart=h,this.modifiedLength=v}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=r}),Y(J[5],Z([0,1]),function(W,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BugIndicatingError=n.ErrorNoTelemetry=n.NotSupportedError=n.CancellationError=n.errorHandler=n.ErrorHandler=void 0,n.onUnexpectedError=D,n.onUnexpectedExternalError=A,n.transformErrorForSerialization=m,n.isCancellationError=v,n.canceled=a,n.illegalArgument=g,n.illegalState=e;class r{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(f){setTimeout(()=>{throw f.stack?i.isErrorNoTelemetry(f)?new i(f.message+`

`+f.stack):new Error(f.message+`

`+f.stack):f},0)}}emit(f){this.listeners.forEach(C=>{C(f)})}onUnexpectedError(f){this.unexpectedErrorHandler(f),this.emit(f)}onUnexpectedExternalError(f){this.unexpectedErrorHandler(f)}}n.ErrorHandler=r,n.errorHandler=new r;function D(d){v(d)||n.errorHandler.onUnexpectedError(d)}function A(d){v(d)||n.errorHandler.onUnexpectedExternalError(d)}function m(d){if(d instanceof Error){const{name:f,message:C}=d,_=d.stacktrace||d.stack;return{$isError:!0,name:f,message:C,stack:_,noTelemetry:i.isErrorNoTelemetry(d)}}return d}const h="Canceled";function v(d){return d instanceof l?!0:d instanceof Error&&d.name===h&&d.message===h}class l extends Error{constructor(){super(h),this.name=this.message}}n.CancellationError=l;function a(){const d=new Error(h);return d.name=d.message,d}function g(d){return d?new Error(`Illegal argument: ${d}`):new Error("Illegal argument")}function e(d){return d?new Error(`Illegal state: ${d}`):new Error("Illegal state")}class c extends Error{constructor(f){super("NotSupported"),f&&(this.message=f)}}n.NotSupportedError=c;class i extends Error{constructor(f){super(f),this.name="CodeExpectedError"}static fromError(f){if(f instanceof i)return f;const C=new i;return C.message=f.message,C.stack=f.stack,C}static isErrorNoTelemetry(f){return f.name==="CodeExpectedError"}}n.ErrorNoTelemetry=i;class u extends Error{constructor(f){super(f||"An unexpected bug occurred."),Object.setPrototypeOf(this,u.prototype)}}n.BugIndicatingError=u}),Y(J[9],Z([0,1,5]),function(W,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ok=D,n.assertNever=A,n.softAssert=m,n.assertFn=h,n.checkAdjacentItems=v;function D(l,a){if(!l)throw new Error(a?`Assertion failed (${a})`:"Assertion Failed")}function A(l,a="Unreachable"){throw new Error(a)}function m(l){l||(0,r.onUnexpectedError)(new r.BugIndicatingError("Soft Assertion Failed"))}function h(l){if(!l()){debugger;l(),(0,r.onUnexpectedError)(new r.BugIndicatingError("Assertion Failed"))}}function v(l,a){let g=0;for(;g<l.length-1;){const e=l[g],c=l[g+1];if(!a(e,c))return!1;g++}return!0}}),Y(J[19],Z([0,1]),function(W,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createSingleCallFunction=r;function r(D,A){const m=this;let h=!1,v;return function(){if(h)return v;if(h=!0,A)try{v=D.apply(m,arguments)}finally{A()}else v=D.apply(m,arguments);return v}}}),Y(J[20],Z([0,1]),function(W,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var r;(function(D){function A(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}D.is=A;const m=Object.freeze([]);function h(){return m}D.empty=h;function*v(s){yield s}D.single=v;function l(s){return A(s)?s:v(s)}D.wrap=l;function a(s){return s||m}D.from=a;function*g(s){for(let o=s.length-1;o>=0;o--)yield s[o]}D.reverse=g;function e(s){return!s||s[Symbol.iterator]().next().done===!0}D.isEmpty=e;function c(s){return s[Symbol.iterator]().next().value}D.first=c;function i(s,o){let p=0;for(const w of s)if(o(w,p++))return!0;return!1}D.some=i;function u(s,o){for(const p of s)if(o(p))return p}D.find=u;function*d(s,o){for(const p of s)o(p)&&(yield p)}D.filter=d;function*f(s,o){let p=0;for(const w of s)yield o(w,p++)}D.map=f;function*C(s,o){let p=0;for(const w of s)yield*o(w,p++)}D.flatMap=C;function*_(...s){for(const o of s)yield*o}D.concat=_;function S(s,o,p){let w=p;for(const N of s)w=o(w,N);return w}D.reduce=S;function*M(s,o,p=s.length){for(o<0&&(o+=s.length),p<0?p+=s.length:p>s.length&&(p=s.length);o<p;o++)yield s[o]}D.slice=M;function L(s,o=Number.POSITIVE_INFINITY){const p=[];if(o===0)return[p,s];const w=s[Symbol.iterator]();for(let N=0;N<o;N++){const y=w.next();if(y.done)return[p,D.empty()];p.push(y.value)}return[p,{[Symbol.iterator](){return w}}]}D.consume=L;async function b(s){const o=[];for await(const p of s)o.push(p);return Promise.resolve(o)}D.asyncToArray=b})(r||(n.Iterable=r={}))}),Y(J[37],Z([0,1]),function(W,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=void 0,n.KeyChord=g;class r{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(c,i){this._keyCodeToStr[c]=i,this._strToKeyCode[i.toLowerCase()]=c}keyCodeToStr(c){return this._keyCodeToStr[c]}strToKeyCode(c){return this._strToKeyCode[c.toLowerCase()]||0}}const D=new r,A=new r,m=new r;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const h=[],v=Object.create(null),l=Object.create(null);n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=132;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",c=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],i=[],u=[];for(const d of c){const[f,C,_,S,M,L,b,s,o]=d;if(u[C]||(u[C]=!0,h[C]=_,v[_]=C,l[_.toLowerCase()]=C,f&&(n.IMMUTABLE_CODE_TO_KEY_CODE[C]=S,S!==0&&S!==3&&S!==5&&S!==4&&S!==6&&S!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[S]=C))),!i[S]){if(i[S]=!0,!M)throw new Error(`String representation missing for key code ${S} around scan code ${_}`);D.define(S,M),A.define(S,s||M),m.define(S,o||s||M)}L&&(n.EVENT_KEY_CODE_MAP[L]=S),b&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[b]=S)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var a;(function(e){function c(_){return D.keyCodeToStr(_)}e.toString=c;function i(_){return D.strToKeyCode(_)}e.fromString=i;function u(_){return A.keyCodeToStr(_)}e.toUserSettingsUS=u;function d(_){return m.keyCodeToStr(_)}e.toUserSettingsGeneral=d;function f(_){return A.strToKeyCode(_)||m.strToKeyCode(_)}e.fromUserSettings=f;function C(_){if(_>=98&&_<=113)return null;switch(_){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return D.keyCodeToStr(_)}e.toElectronAccelerator=C})(a||(n.KeyCodeUtils=a={}));function g(e,c){const i=(c&65535)<<16>>>0;return(e|i)>>>0}}),Y(J[38],Z([0,1]),function(W,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Lazy=void 0;class r{constructor(A){this.executor=A,this._didRun=!1}get value(){if(!this._didRun)try{this._value=this.executor()}catch(A){this._error=A}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}n.Lazy=r}),Y(J[13],Z([0,1,19,20]),function(W,n,r,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DisposableMap=n.ImmortalReference=n.RefCountedDisposable=n.MutableDisposable=n.Disposable=n.DisposableStore=void 0,n.setDisposableTracker=h,n.trackDisposable=v,n.markAsDisposed=l,n.markAsSingleton=e,n.isDisposable=c,n.dispose=i,n.combinedDisposable=u,n.toDisposable=d;const A=!1;let m=null;function h(b){m=b}if(A){const b="__is_disposable_tracked__";h(new class{trackDisposable(s){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[b]||console.log(o)},3e3)}setParent(s,o){if(s&&s!==C.None)try{s[b]=!0}catch{}}markAsDisposed(s){if(s&&s!==C.None)try{s[b]=!0}catch{}}markAsSingleton(s){}})}function v(b){return m?.trackDisposable(b),b}function l(b){m?.markAsDisposed(b)}function a(b,s){m?.setParent(b,s)}function g(b,s){if(m)for(const o of b)m.setParent(o,s)}function e(b){return m?.markAsSingleton(b),b}function c(b){return typeof b=="object"&&b!==null&&typeof b.dispose=="function"&&b.dispose.length===0}function i(b){if(D.Iterable.is(b)){const s=[];for(const o of b)if(o)try{o.dispose()}catch(p){s.push(p)}if(s.length===1)throw s[0];if(s.length>1)throw new AggregateError(s,"Encountered errors while disposing of store");return Array.isArray(b)?[]:b}else if(b)return b.dispose(),b}function u(...b){const s=d(()=>i(b));return g(b,s),s}function d(b){const s=v({dispose:(0,r.createSingleCallFunction)(()=>{l(s),b()})});return s}class f{constructor(){this._toDispose=new Set,this._isDisposed=!1,v(this)}dispose(){this._isDisposed||(l(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{i(this._toDispose)}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return a(s,this),this._isDisposed?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}deleteAndLeak(s){s&&this._toDispose.has(s)&&(this._toDispose.delete(s),a(s,null))}}n.DisposableStore=f,f.DISABLE_DISPOSED_WARNING=!1;class C{constructor(){this._store=new f,v(this),a(this._store,this)}dispose(){l(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}n.Disposable=C,C.None=Object.freeze({dispose(){}});class _{constructor(){this._isDisposed=!1,v(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){var o;this._isDisposed||s===this._value||((o=this._value)===null||o===void 0||o.dispose(),s&&a(s,this),this._value=s)}clear(){this.value=void 0}dispose(){var s;this._isDisposed=!0,l(this),(s=this._value)===null||s===void 0||s.dispose(),this._value=void 0}}n.MutableDisposable=_;class S{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}n.RefCountedDisposable=S;class M{constructor(s){this.object=s}dispose(){}}n.ImmortalReference=M;class L{constructor(){this._store=new Map,this._isDisposed=!1,v(this)}dispose(){l(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{i(this._store.values())}finally{this._store.clear()}}get(s){return this._store.get(s)}set(s,o,p=!1){var w;this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),p||(w=this._store.get(s))===null||w===void 0||w.dispose(),this._store.set(s,o)}deleteAndDispose(s){var o;(o=this._store.get(s))===null||o===void 0||o.dispose(),this._store.delete(s)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}n.DisposableMap=L}),Y(J[21],Z([0,1]),function(W,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class r{constructor(m){this.element=m,this.next=r.Undefined,this.prev=r.Undefined}}r.Undefined=new r(void 0);class D{constructor(){this._first=r.Undefined,this._last=r.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===r.Undefined}clear(){let m=this._first;for(;m!==r.Undefined;){const h=m.next;m.prev=r.Undefined,m.next=r.Undefined,m=h}this._first=r.Undefined,this._last=r.Undefined,this._size=0}unshift(m){return this._insert(m,!1)}push(m){return this._insert(m,!0)}_insert(m,h){const v=new r(m);if(this._first===r.Undefined)this._first=v,this._last=v;else if(h){const a=this._last;this._last=v,v.prev=a,a.next=v}else{const a=this._first;this._first=v,v.next=a,a.prev=v}this._size+=1;let l=!1;return()=>{l||(l=!0,this._remove(v))}}shift(){if(this._first!==r.Undefined){const m=this._first.element;return this._remove(this._first),m}}pop(){if(this._last!==r.Undefined){const m=this._last.element;return this._remove(this._last),m}}_remove(m){if(m.prev!==r.Undefined&&m.next!==r.Undefined){const h=m.prev;h.next=m.next,m.next.prev=h}else m.prev===r.Undefined&&m.next===r.Undefined?(this._first=r.Undefined,this._last=r.Undefined):m.next===r.Undefined?(this._last=this._last.prev,this._last.next=r.Undefined):m.prev===r.Undefined&&(this._first=this._first.next,this._first.prev=r.Undefined);this._size-=1}*[Symbol.iterator](){let m=this._first;for(;m!==r.Undefined;)yield m.element,m=m.next}}n.LinkedList=D}),Y(J[22],Z([0,1]),function(W,n){"use strict";var r,D;Object.defineProperty(n,"__esModule",{value:!0}),n.SetMap=n.BidirectionalMap=n.LRUCache=n.LinkedMap=n.ResourceMap=void 0;class A{constructor(i,u){this.uri=i,this.value=u}}function m(c){return Array.isArray(c)}class h{constructor(i,u){if(this[r]="ResourceMap",i instanceof h)this.map=new Map(i.map),this.toKey=u??h.defaultToKey;else if(m(i)){this.map=new Map,this.toKey=u??h.defaultToKey;for(const[d,f]of i)this.set(d,f)}else this.map=new Map,this.toKey=i??h.defaultToKey}set(i,u){return this.map.set(this.toKey(i),new A(i,u)),this}get(i){var u;return(u=this.map.get(this.toKey(i)))===null||u===void 0?void 0:u.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,u){typeof u<"u"&&(i=i.bind(u));for(const[d,f]of this.map)i(f.value,f.uri,this)}*values(){for(const i of this.map.values())yield i.value}*keys(){for(const i of this.map.values())yield i.uri}*entries(){for(const i of this.map.values())yield[i.uri,i.value]}*[(r=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.map)yield[i.uri,i.value]}}n.ResourceMap=h,h.defaultToKey=c=>c.toString();class v{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var i;return(i=this._head)===null||i===void 0?void 0:i.value}get last(){var i;return(i=this._tail)===null||i===void 0?void 0:i.value}has(i){return this._map.has(i)}get(i,u=0){const d=this._map.get(i);if(d)return u!==0&&this.touch(d,u),d.value}set(i,u,d=0){let f=this._map.get(i);if(f)f.value=u,d!==0&&this.touch(f,d);else{switch(f={key:i,value:u,next:void 0,previous:void 0},d){case 0:this.addItemLast(f);break;case 1:this.addItemFirst(f);break;case 2:this.addItemLast(f);break;default:this.addItemLast(f);break}this._map.set(i,f),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const u=this._map.get(i);if(u)return this._map.delete(i),this.removeItem(u),this._size--,u.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,u){const d=this._state;let f=this._head;for(;f;){if(u?i.bind(u)(f.value,f.key,this):i(f.value,f.key,this),this._state!==d)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const i=this,u=this._state;let d=this._head;const f={[Symbol.iterator](){return f},next(){if(i._state!==u)throw new Error("LinkedMap got modified during iteration.");if(d){const C={value:d.key,done:!1};return d=d.next,C}else return{value:void 0,done:!0}}};return f}values(){const i=this,u=this._state;let d=this._head;const f={[Symbol.iterator](){return f},next(){if(i._state!==u)throw new Error("LinkedMap got modified during iteration.");if(d){const C={value:d.value,done:!1};return d=d.next,C}else return{value:void 0,done:!0}}};return f}entries(){const i=this,u=this._state;let d=this._head;const f={[Symbol.iterator](){return f},next(){if(i._state!==u)throw new Error("LinkedMap got modified during iteration.");if(d){const C={value:[d.key,d.value],done:!1};return d=d.next,C}else return{value:void 0,done:!0}}};return f}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let u=this._head,d=this.size;for(;u&&d>i;)this._map.delete(u.key),u=u.next,d--;this._head=u,this._size=d,u&&(u.previous=void 0),this._state++}trimNew(i){if(i>=this.size)return;if(i===0){this.clear();return}let u=this._tail,d=this.size;for(;u&&d>i;)this._map.delete(u.key),u=u.previous,d--;this._tail=u,this._size=d,u&&(u.next=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const u=i.next,d=i.previous;if(!u||!d)throw new Error("Invalid list");u.previous=d,d.next=u}i.next=void 0,i.previous=void 0,this._state++}touch(i,u){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(i===this._head)return;const d=i.next,f=i.previous;i===this._tail?(f.next=void 0,this._tail=f):(d.previous=f,f.next=d),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(u===2){if(i===this._tail)return;const d=i.next,f=i.previous;i===this._head?(d.previous=void 0,this._head=d):(d.previous=f,f.next=d),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((u,d)=>{i.push([d,u])}),i}fromJSON(i){this.clear();for(const[u,d]of i)this.set(u,d)}}n.LinkedMap=v;class l extends v{constructor(i,u=1){super(),this._limit=i,this._ratio=Math.min(Math.max(0,u),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get(i,u=2){return super.get(i,u)}peek(i){return super.get(i,0)}set(i,u){return super.set(i,u,2),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class a extends l{constructor(i,u=1){super(i,u)}trim(i){this.trimOld(i)}set(i,u){return super.set(i,u),this.checkTrim(),this}}n.LRUCache=a;class g{constructor(i){if(this._m1=new Map,this._m2=new Map,i)for(const[u,d]of i)this.set(u,d)}clear(){this._m1.clear(),this._m2.clear()}set(i,u){this._m1.set(i,u),this._m2.set(u,i)}get(i){return this._m1.get(i)}getKey(i){return this._m2.get(i)}delete(i){const u=this._m1.get(i);return u===void 0?!1:(this._m1.delete(i),this._m2.delete(u),!0)}keys(){return this._m1.keys()}values(){return this._m1.values()}}n.BidirectionalMap=g;class e{constructor(){this.map=new Map}add(i,u){let d=this.map.get(i);d||(d=new Set,this.map.set(i,d)),d.add(u)}delete(i,u){const d=this.map.get(i);d&&(d.delete(u),d.size===0&&this.map.delete(i))}forEach(i,u){const d=this.map.get(i);d&&d.forEach(u)}get(i){const u=this.map.get(i);return u||new Set}}n.SetMap=e}),Y(J[14],Z([0,1]),function(W,n){"use strict";var r,D,A;Object.defineProperty(n,"__esModule",{value:!0}),n.isAndroid=n.isEdge=n.isSafari=n.isFirefox=n.isChrome=n.OS=n.setTimeout0=n.setTimeout0IsFaster=n.language=n.userAgent=n.isMobile=n.isIOS=n.webWorkerOrigin=n.isWebWorker=n.isWeb=n.isNative=n.isLinux=n.isMacintosh=n.isWindows=n.LANGUAGE_DEFAULT=void 0,n.isLittleEndian=N,n.LANGUAGE_DEFAULT="en";let m=!1,h=!1,v=!1,l=!1,a=!1,g=!1,e=!1,c=!1,i=!1,u=!1,d,f=n.LANGUAGE_DEFAULT,C=n.LANGUAGE_DEFAULT,_,S;const M=globalThis;let L;typeof M.vscode<"u"&&typeof M.vscode.process<"u"?L=M.vscode.process:typeof process<"u"&&typeof((r=process==null?void 0:process.versions)===null||r===void 0?void 0:r.node)=="string"&&(L=process);const b=typeof((D=L?.versions)===null||D===void 0?void 0:D.electron)=="string",s=b&&L?.type==="renderer";if(typeof L=="object"){m=L.platform==="win32",h=L.platform==="darwin",v=L.platform==="linux",l=v&&!!L.env.SNAP&&!!L.env.SNAP_REVISION,e=b,i=!!L.env.CI||!!L.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=n.LANGUAGE_DEFAULT,f=n.LANGUAGE_DEFAULT;const y=L.env.VSCODE_NLS_CONFIG;if(y)try{const E=JSON.parse(y);d=E.userLocale,C=E.osLocale,f=E.resolvedLanguage||n.LANGUAGE_DEFAULT,_=(A=E.languagePack)===null||A===void 0?void 0:A.translationsConfigFile}catch{}a=!0}else typeof navigator=="object"&&!s?(S=navigator.userAgent,m=S.indexOf("Windows")>=0,h=S.indexOf("Macintosh")>=0,c=(S.indexOf("Macintosh")>=0||S.indexOf("iPad")>=0||S.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,v=S.indexOf("Linux")>=0,u=S?.indexOf("Mobi")>=0,g=!0,f=globalThis._VSCODE_NLS_LANGUAGE||n.LANGUAGE_DEFAULT,d=navigator.language.toLowerCase(),C=d):console.error("Unable to resolve platform.");let o=0;h?o=1:m?o=3:v&&(o=2),n.isWindows=m,n.isMacintosh=h,n.isLinux=v,n.isNative=a,n.isWeb=g,n.isWebWorker=g&&typeof M.importScripts=="function",n.webWorkerOrigin=n.isWebWorker?M.origin:void 0,n.isIOS=c,n.isMobile=u,n.userAgent=S,n.language=f,n.setTimeout0IsFaster=typeof M.postMessage=="function"&&!M.importScripts,n.setTimeout0=(()=>{if(n.setTimeout0IsFaster){const y=[];M.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let x=0,P=y.length;x<P;x++){const F=y[x];if(F.id===R.data.vscodeScheduleAsyncWork){y.splice(x,1),F.callback();return}}});let E=0;return R=>{const x=++E;y.push({id:x,callback:R}),M.postMessage({vscodeScheduleAsyncWork:x},"*")}}return y=>setTimeout(y)})(),n.OS=h||c?2:m?1:3;let p=!0,w=!1;function N(){if(!w){w=!0;const y=new Uint8Array(2);y[0]=1,y[1]=2,p=new Uint16Array(y.buffer)[0]===513}return p}n.isChrome=!!(n.userAgent&&n.userAgent.indexOf("Chrome")>=0),n.isFirefox=!!(n.userAgent&&n.userAgent.indexOf("Firefox")>=0),n.isSafari=!!(!n.isChrome&&n.userAgent&&n.userAgent.indexOf("Safari")>=0),n.isEdge=!!(n.userAgent&&n.userAgent.indexOf("Edg/")>=0),n.isAndroid=!!(n.userAgent&&n.userAgent.indexOf("Android")>=0)}),Y(J[39],Z([0,1,14]),function(W,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.platform=n.env=n.cwd=void 0;let D;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.process<"u"){const m=A.process;D={get platform(){return m.platform},get arch(){return m.arch},get env(){return m.env},cwd(){return m.cwd()}}}else typeof process<"u"?D={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:D={get platform(){return r.isWindows?"win32":r.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};n.cwd=D.cwd,n.env=D.env,n.platform=D.platform}),Y(J[40],Z([0,1,39]),function(W,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.sep=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.normalize=n.posix=n.win32=void 0;const D=65,A=97,m=90,h=122,v=46,l=47,a=92,g=58,e=63;class c extends Error{constructor(o,p,w){let N;typeof p=="string"&&p.indexOf("not ")===0?(N="must not be",p=p.replace(/^not /,"")):N="must be";const y=o.indexOf(".")!==-1?"property":"argument";let E=`The "${o}" ${y} ${N} of type ${p}`;E+=`. Received type ${typeof w}`,super(E),this.code="ERR_INVALID_ARG_TYPE"}}function i(s,o){if(s===null||typeof s!="object")throw new c(o,"Object",s)}function u(s,o){if(typeof s!="string")throw new c(o,"string",s)}const d=r.platform==="win32";function f(s){return s===l||s===a}function C(s){return s===l}function _(s){return s>=D&&s<=m||s>=A&&s<=h}function S(s,o,p,w){let N="",y=0,E=-1,R=0,x=0;for(let P=0;P<=s.length;++P){if(P<s.length)x=s.charCodeAt(P);else{if(w(x))break;x=l}if(w(x)){if(!(E===P-1||R===1))if(R===2){if(N.length<2||y!==2||N.charCodeAt(N.length-1)!==v||N.charCodeAt(N.length-2)!==v){if(N.length>2){const F=N.lastIndexOf(p);F===-1?(N="",y=0):(N=N.slice(0,F),y=N.length-1-N.lastIndexOf(p)),E=P,R=0;continue}else if(N.length!==0){N="",y=0,E=P,R=0;continue}}o&&(N+=N.length>0?`${p}..`:"..",y=2)}else N.length>0?N+=`${p}${s.slice(E+1,P)}`:N=s.slice(E+1,P),y=P-E-1;E=P,R=0}else x===v&&R!==-1?++R:R=-1}return N}function M(s){return s?`${s[0]==="."?"":"."}${s}`:""}function L(s,o){i(o,"pathObject");const p=o.dir||o.root,w=o.base||`${o.name||""}${M(o.ext)}`;return p?p===o.root?`${p}${w}`:`${p}${s}${w}`:w}n.win32={resolve(...s){let o="",p="",w=!1;for(let N=s.length-1;N>=-1;N--){let y;if(N>=0){if(y=s[N],u(y,`paths[${N}]`),y.length===0)continue}else o.length===0?y=r.cwd():(y=r.env[`=${o}`]||r.cwd(),(y===void 0||y.slice(0,2).toLowerCase()!==o.toLowerCase()&&y.charCodeAt(2)===a)&&(y=`${o}\\`));const E=y.length;let R=0,x="",P=!1;const F=y.charCodeAt(0);if(E===1)f(F)&&(R=1,P=!0);else if(f(F))if(P=!0,f(y.charCodeAt(1))){let I=2,V=I;for(;I<E&&!f(y.charCodeAt(I));)I++;if(I<E&&I!==V){const $=y.slice(V,I);for(V=I;I<E&&f(y.charCodeAt(I));)I++;if(I<E&&I!==V){for(V=I;I<E&&!f(y.charCodeAt(I));)I++;(I===E||I!==V)&&(x=`\\\\${$}\\${y.slice(V,I)}`,R=I)}}}else R=1;else _(F)&&y.charCodeAt(1)===g&&(x=y.slice(0,2),R=2,E>2&&f(y.charCodeAt(2))&&(P=!0,R=3));if(x.length>0)if(o.length>0){if(x.toLowerCase()!==o.toLowerCase())continue}else o=x;if(w){if(o.length>0)break}else if(p=`${y.slice(R)}\\${p}`,w=P,P&&o.length>0)break}return p=S(p,!w,"\\",f),w?`${o}\\${p}`:`${o}${p}`||"."},normalize(s){u(s,"path");const o=s.length;if(o===0)return".";let p=0,w,N=!1;const y=s.charCodeAt(0);if(o===1)return C(y)?"\\":s;if(f(y))if(N=!0,f(s.charCodeAt(1))){let R=2,x=R;for(;R<o&&!f(s.charCodeAt(R));)R++;if(R<o&&R!==x){const P=s.slice(x,R);for(x=R;R<o&&f(s.charCodeAt(R));)R++;if(R<o&&R!==x){for(x=R;R<o&&!f(s.charCodeAt(R));)R++;if(R===o)return`\\\\${P}\\${s.slice(x)}\\`;R!==x&&(w=`\\\\${P}\\${s.slice(x,R)}`,p=R)}}}else p=1;else _(y)&&s.charCodeAt(1)===g&&(w=s.slice(0,2),p=2,o>2&&f(s.charCodeAt(2))&&(N=!0,p=3));let E=p<o?S(s.slice(p),!N,"\\",f):"";return E.length===0&&!N&&(E="."),E.length>0&&f(s.charCodeAt(o-1))&&(E+="\\"),w===void 0?N?`\\${E}`:E:N?`${w}\\${E}`:`${w}${E}`},isAbsolute(s){u(s,"path");const o=s.length;if(o===0)return!1;const p=s.charCodeAt(0);return f(p)||o>2&&_(p)&&s.charCodeAt(1)===g&&f(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let o,p;for(let y=0;y<s.length;++y){const E=s[y];u(E,"path"),E.length>0&&(o===void 0?o=p=E:o+=`\\${E}`)}if(o===void 0)return".";let w=!0,N=0;if(typeof p=="string"&&f(p.charCodeAt(0))){++N;const y=p.length;y>1&&f(p.charCodeAt(1))&&(++N,y>2&&(f(p.charCodeAt(2))?++N:w=!1))}if(w){for(;N<o.length&&f(o.charCodeAt(N));)N++;N>=2&&(o=`\\${o.slice(N)}`)}return n.win32.normalize(o)},relative(s,o){if(u(s,"from"),u(o,"to"),s===o)return"";const p=n.win32.resolve(s),w=n.win32.resolve(o);if(p===w||(s=p.toLowerCase(),o=w.toLowerCase(),s===o))return"";let N=0;for(;N<s.length&&s.charCodeAt(N)===a;)N++;let y=s.length;for(;y-1>N&&s.charCodeAt(y-1)===a;)y--;const E=y-N;let R=0;for(;R<o.length&&o.charCodeAt(R)===a;)R++;let x=o.length;for(;x-1>R&&o.charCodeAt(x-1)===a;)x--;const P=x-R,F=E<P?E:P;let I=-1,V=0;for(;V<F;V++){const T=s.charCodeAt(N+V);if(T!==o.charCodeAt(R+V))break;T===a&&(I=V)}if(V!==F){if(I===-1)return w}else{if(P>F){if(o.charCodeAt(R+V)===a)return w.slice(R+V+1);if(V===2)return w.slice(R+V)}E>F&&(s.charCodeAt(N+V)===a?I=V:V===2&&(I=3)),I===-1&&(I=0)}let $="";for(V=N+I+1;V<=y;++V)(V===y||s.charCodeAt(V)===a)&&($+=$.length===0?"..":"\\..");return R+=I,$.length>0?`${$}${w.slice(R,x)}`:(w.charCodeAt(R)===a&&++R,w.slice(R,x))},toNamespacedPath(s){if(typeof s!="string"||s.length===0)return s;const o=n.win32.resolve(s);if(o.length<=2)return s;if(o.charCodeAt(0)===a){if(o.charCodeAt(1)===a){const p=o.charCodeAt(2);if(p!==e&&p!==v)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(_(o.charCodeAt(0))&&o.charCodeAt(1)===g&&o.charCodeAt(2)===a)return`\\\\?\\${o}`;return s},dirname(s){u(s,"path");const o=s.length;if(o===0)return".";let p=-1,w=0;const N=s.charCodeAt(0);if(o===1)return f(N)?s:".";if(f(N)){if(p=w=1,f(s.charCodeAt(1))){let R=2,x=R;for(;R<o&&!f(s.charCodeAt(R));)R++;if(R<o&&R!==x){for(x=R;R<o&&f(s.charCodeAt(R));)R++;if(R<o&&R!==x){for(x=R;R<o&&!f(s.charCodeAt(R));)R++;if(R===o)return s;R!==x&&(p=w=R+1)}}}}else _(N)&&s.charCodeAt(1)===g&&(p=o>2&&f(s.charCodeAt(2))?3:2,w=p);let y=-1,E=!0;for(let R=o-1;R>=w;--R)if(f(s.charCodeAt(R))){if(!E){y=R;break}}else E=!1;if(y===-1){if(p===-1)return".";y=p}return s.slice(0,y)},basename(s,o){o!==void 0&&u(o,"suffix"),u(s,"path");let p=0,w=-1,N=!0,y;if(s.length>=2&&_(s.charCodeAt(0))&&s.charCodeAt(1)===g&&(p=2),o!==void 0&&o.length>0&&o.length<=s.length){if(o===s)return"";let E=o.length-1,R=-1;for(y=s.length-1;y>=p;--y){const x=s.charCodeAt(y);if(f(x)){if(!N){p=y+1;break}}else R===-1&&(N=!1,R=y+1),E>=0&&(x===o.charCodeAt(E)?--E===-1&&(w=y):(E=-1,w=R))}return p===w?w=R:w===-1&&(w=s.length),s.slice(p,w)}for(y=s.length-1;y>=p;--y)if(f(s.charCodeAt(y))){if(!N){p=y+1;break}}else w===-1&&(N=!1,w=y+1);return w===-1?"":s.slice(p,w)},extname(s){u(s,"path");let o=0,p=-1,w=0,N=-1,y=!0,E=0;s.length>=2&&s.charCodeAt(1)===g&&_(s.charCodeAt(0))&&(o=w=2);for(let R=s.length-1;R>=o;--R){const x=s.charCodeAt(R);if(f(x)){if(!y){w=R+1;break}continue}N===-1&&(y=!1,N=R+1),x===v?p===-1?p=R:E!==1&&(E=1):p!==-1&&(E=-1)}return p===-1||N===-1||E===0||E===1&&p===N-1&&p===w+1?"":s.slice(p,N)},format:L.bind(null,"\\"),parse(s){u(s,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return o;const p=s.length;let w=0,N=s.charCodeAt(0);if(p===1)return f(N)?(o.root=o.dir=s,o):(o.base=o.name=s,o);if(f(N)){if(w=1,f(s.charCodeAt(1))){let I=2,V=I;for(;I<p&&!f(s.charCodeAt(I));)I++;if(I<p&&I!==V){for(V=I;I<p&&f(s.charCodeAt(I));)I++;if(I<p&&I!==V){for(V=I;I<p&&!f(s.charCodeAt(I));)I++;I===p?w=I:I!==V&&(w=I+1)}}}}else if(_(N)&&s.charCodeAt(1)===g){if(p<=2)return o.root=o.dir=s,o;if(w=2,f(s.charCodeAt(2))){if(p===3)return o.root=o.dir=s,o;w=3}}w>0&&(o.root=s.slice(0,w));let y=-1,E=w,R=-1,x=!0,P=s.length-1,F=0;for(;P>=w;--P){if(N=s.charCodeAt(P),f(N)){if(!x){E=P+1;break}continue}R===-1&&(x=!1,R=P+1),N===v?y===-1?y=P:F!==1&&(F=1):y!==-1&&(F=-1)}return R!==-1&&(y===-1||F===0||F===1&&y===R-1&&y===E+1?o.base=o.name=s.slice(E,R):(o.name=s.slice(E,y),o.base=s.slice(E,R),o.ext=s.slice(y,R))),E>0&&E!==w?o.dir=s.slice(0,E-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const b=(()=>{if(d){const s=/\\/g;return()=>{const o=r.cwd().replace(s,"/");return o.slice(o.indexOf("/"))}}return()=>r.cwd()})();n.posix={resolve(...s){let o="",p=!1;for(let w=s.length-1;w>=-1&&!p;w--){const N=w>=0?s[w]:b();u(N,`paths[${w}]`),N.length!==0&&(o=`${N}/${o}`,p=N.charCodeAt(0)===l)}return o=S(o,!p,"/",C),p?`/${o}`:o.length>0?o:"."},normalize(s){if(u(s,"path"),s.length===0)return".";const o=s.charCodeAt(0)===l,p=s.charCodeAt(s.length-1)===l;return s=S(s,!o,"/",C),s.length===0?o?"/":p?"./":".":(p&&(s+="/"),o?`/${s}`:s)},isAbsolute(s){return u(s,"path"),s.length>0&&s.charCodeAt(0)===l},join(...s){if(s.length===0)return".";let o;for(let p=0;p<s.length;++p){const w=s[p];u(w,"path"),w.length>0&&(o===void 0?o=w:o+=`/${w}`)}return o===void 0?".":n.posix.normalize(o)},relative(s,o){if(u(s,"from"),u(o,"to"),s===o||(s=n.posix.resolve(s),o=n.posix.resolve(o),s===o))return"";const p=1,w=s.length,N=w-p,y=1,E=o.length-y,R=N<E?N:E;let x=-1,P=0;for(;P<R;P++){const I=s.charCodeAt(p+P);if(I!==o.charCodeAt(y+P))break;I===l&&(x=P)}if(P===R)if(E>R){if(o.charCodeAt(y+P)===l)return o.slice(y+P+1);if(P===0)return o.slice(y+P)}else N>R&&(s.charCodeAt(p+P)===l?x=P:P===0&&(x=0));let F="";for(P=p+x+1;P<=w;++P)(P===w||s.charCodeAt(P)===l)&&(F+=F.length===0?"..":"/..");return`${F}${o.slice(y+x)}`},toNamespacedPath(s){return s},dirname(s){if(u(s,"path"),s.length===0)return".";const o=s.charCodeAt(0)===l;let p=-1,w=!0;for(let N=s.length-1;N>=1;--N)if(s.charCodeAt(N)===l){if(!w){p=N;break}}else w=!1;return p===-1?o?"/":".":o&&p===1?"//":s.slice(0,p)},basename(s,o){o!==void 0&&u(o,"ext"),u(s,"path");let p=0,w=-1,N=!0,y;if(o!==void 0&&o.length>0&&o.length<=s.length){if(o===s)return"";let E=o.length-1,R=-1;for(y=s.length-1;y>=0;--y){const x=s.charCodeAt(y);if(x===l){if(!N){p=y+1;break}}else R===-1&&(N=!1,R=y+1),E>=0&&(x===o.charCodeAt(E)?--E===-1&&(w=y):(E=-1,w=R))}return p===w?w=R:w===-1&&(w=s.length),s.slice(p,w)}for(y=s.length-1;y>=0;--y)if(s.charCodeAt(y)===l){if(!N){p=y+1;break}}else w===-1&&(N=!1,w=y+1);return w===-1?"":s.slice(p,w)},extname(s){u(s,"path");let o=-1,p=0,w=-1,N=!0,y=0;for(let E=s.length-1;E>=0;--E){const R=s.charCodeAt(E);if(R===l){if(!N){p=E+1;break}continue}w===-1&&(N=!1,w=E+1),R===v?o===-1?o=E:y!==1&&(y=1):o!==-1&&(y=-1)}return o===-1||w===-1||y===0||y===1&&o===w-1&&o===p+1?"":s.slice(o,w)},format:L.bind(null,"/"),parse(s){u(s,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return o;const p=s.charCodeAt(0)===l;let w;p?(o.root="/",w=1):w=0;let N=-1,y=0,E=-1,R=!0,x=s.length-1,P=0;for(;x>=w;--x){const F=s.charCodeAt(x);if(F===l){if(!R){y=x+1;break}continue}E===-1&&(R=!1,E=x+1),F===v?N===-1?N=x:P!==1&&(P=1):N!==-1&&(P=-1)}if(E!==-1){const F=y===0&&p?1:y;N===-1||P===0||P===1&&N===E-1&&N===y+1?o.base=o.name=s.slice(F,E):(o.name=s.slice(F,N),o.base=s.slice(F,E),o.ext=s.slice(N,E))}return y>0?o.dir=s.slice(0,y-1):p&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=d?n.win32.normalize:n.posix.normalize,n.resolve=d?n.win32.resolve:n.posix.resolve,n.relative=d?n.win32.relative:n.posix.relative,n.dirname=d?n.win32.dirname:n.posix.dirname,n.basename=d?n.win32.basename:n.posix.basename,n.extname=d?n.win32.extname:n.posix.extname,n.sep=d?n.win32.sep:n.posix.sep}),Y(J[23],Z([0,1]),function(W,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const r=globalThis.performance&&typeof globalThis.performance.now=="function";class D{static create(m){return new D(m)}constructor(m){this._now=r&&m===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}n.StopWatch=D}),Y(J[10],Z([0,1,5,19,13,21,23]),function(W,n,r,D,A,m,h){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.EventMultiplexer=n.MicrotaskEmitter=n.DebounceEmitter=n.PauseableEmitter=n.createEventDeliveryQueue=n.Emitter=n.ListenerRefusalError=n.ListenerLeakError=n.EventProfiling=n.Event=void 0;const v=!1,l=!1,a=!1;var g;(function(R){R.None=()=>A.Disposable.None;function x(te){if(a){const{onDidAddListener:Q}=te,U=u.create();let X=0;te.onDidAddListener=()=>{++X===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),U.print()),Q?.()}}}function P(te,Q){return K(te,()=>{},0,void 0,!0,void 0,Q)}R.defer=P;function F(te){return(Q,U=null,X)=>{let re=!1,k;return k=te(q=>{if(!re)return k?k.dispose():re=!0,Q.call(U,q)},null,X),re&&k.dispose(),k}}R.once=F;function I(te,Q,U){return z((X,re=null,k)=>te(q=>X.call(re,Q(q)),null,k),U)}R.map=I;function V(te,Q,U){return z((X,re=null,k)=>te(q=>{Q(q),X.call(re,q)},null,k),U)}R.forEach=V;function $(te,Q,U){return z((X,re=null,k)=>te(q=>Q(q)&&X.call(re,q),null,k),U)}R.filter=$;function T(te){return te}R.signal=T;function O(...te){return(Q,U=null,X)=>{const re=(0,A.combinedDisposable)(...te.map(k=>k(q=>Q.call(U,q))));return j(re,X)}}R.any=O;function B(te,Q,U,X){let re=U;return I(te,k=>(re=Q(re,k),re),X)}R.reduce=B;function z(te,Q){let U;const X={onWillAddFirstListener(){U=te(re.fire,re)},onDidRemoveLastListener(){U?.dispose()}};Q||x(X);const re=new L(X);return Q?.add(re),re.event}function j(te,Q){return Q instanceof Array?Q.push(te):Q&&Q.add(te),te}function K(te,Q,U=100,X=!1,re=!1,k,q){let H,G,ee,ie=0,ue;const me={leakWarningThreshold:k,onWillAddFirstListener(){H=te(ae=>{ie++,G=Q(G,ae),X&&!ee&&(he.fire(G),G=void 0),ue=()=>{const fe=G;G=void 0,ee=void 0,(!X||ie>1)&&he.fire(fe),ie=0},typeof U=="number"?(clearTimeout(ee),ee=setTimeout(ue,U)):ee===void 0&&(ee=0,queueMicrotask(ue))})},onWillRemoveListener(){re&&ie>0&&ue?.()},onDidRemoveLastListener(){ue=void 0,H.dispose()}};q||x(me);const he=new L(me);return q?.add(he),he.event}R.debounce=K;function ne(te,Q=0,U){return R.debounce(te,(X,re)=>X?(X.push(re),X):[re],Q,void 0,!0,void 0,U)}R.accumulate=ne;function se(te,Q=(X,re)=>X===re,U){let X=!0,re;return $(te,k=>{const q=X||!Q(k,re);return X=!1,re=k,q},U)}R.latch=se;function oe(te,Q,U){return[R.filter(te,Q,U),R.filter(te,X=>!Q(X),U)]}R.split=oe;function ce(te,Q=!1,U=[],X){let re=U.slice(),k=te(G=>{re?re.push(G):H.fire(G)});X&&X.add(k);const q=()=>{re?.forEach(G=>H.fire(G)),re=null},H=new L({onWillAddFirstListener(){k||(k=te(G=>H.fire(G)),X&&X.add(k))},onDidAddFirstListener(){re&&(Q?setTimeout(q):q())},onDidRemoveLastListener(){k&&k.dispose(),k=null}});return X&&X.add(H),H.event}R.buffer=ce;function de(te,Q){return(X,re,k)=>{const q=Q(new ve);return te(function(H){const G=q.evaluate(H);G!==t&&X.call(re,G)},void 0,k)}}R.chain=de;const t=Symbol("HaltChainable");class ve{constructor(){this.steps=[]}map(Q){return this.steps.push(Q),this}forEach(Q){return this.steps.push(U=>(Q(U),U)),this}filter(Q){return this.steps.push(U=>Q(U)?U:t),this}reduce(Q,U){let X=U;return this.steps.push(re=>(X=Q(X,re),X)),this}latch(Q=(U,X)=>U===X){let U=!0,X;return this.steps.push(re=>{const k=U||!Q(re,X);return U=!1,X=re,k?re:t}),this}evaluate(Q){for(const U of this.steps)if(Q=U(Q),Q===t)break;return Q}}function pe(te,Q,U=X=>X){const X=(...H)=>q.fire(U(...H)),re=()=>te.on(Q,X),k=()=>te.removeListener(Q,X),q=new L({onWillAddFirstListener:re,onDidRemoveLastListener:k});return q.event}R.fromNodeEventEmitter=pe;function Le(te,Q,U=X=>X){const X=(...H)=>q.fire(U(...H)),re=()=>te.addEventListener(Q,X),k=()=>te.removeEventListener(Q,X),q=new L({onWillAddFirstListener:re,onDidRemoveLastListener:k});return q.event}R.fromDOMEventEmitter=Le;function Ce(te){return new Promise(Q=>F(te)(Q))}R.toPromise=Ce;function Se(te){const Q=new L;return te.then(U=>{Q.fire(U)},()=>{Q.fire(void 0)}).finally(()=>{Q.dispose()}),Q.event}R.fromPromise=Se;function ye(te,Q,U){return Q(U),te(X=>Q(X))}R.runAndSubscribe=ye;class we{constructor(Q,U){this._observable=Q,this._counter=0,this._hasChanged=!1;const X={onWillAddFirstListener:()=>{Q.addObserver(this)},onDidRemoveLastListener:()=>{Q.removeObserver(this)}};U||x(X),this.emitter=new L(X),U&&U.add(this.emitter)}beginUpdate(Q){this._counter++}handlePossibleChange(Q){}handleChange(Q,U){this._hasChanged=!0}endUpdate(Q){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function ge(te,Q){return new we(te,Q).emitter.event}R.fromObservable=ge;function Ne(te){return(Q,U,X)=>{let re=0,k=!1;const q={beginUpdate(){re++},endUpdate(){re--,re===0&&(te.reportChanges(),k&&(k=!1,Q.call(U)))},handlePossibleChange(){},handleChange(){k=!0}};te.addObserver(q),te.reportChanges();const H={dispose(){te.removeObserver(q)}};return X instanceof A.DisposableStore?X.add(H):Array.isArray(X)&&X.push(H),H}}R.fromObservableLight=Ne})(g||(n.Event=g={}));class e{constructor(x){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${x}_${e._idPool++}`,e.all.add(this)}start(x){this._stopWatch=new h.StopWatch,this.listenerCount=x}stop(){if(this._stopWatch){const x=this._stopWatch.elapsed();this.durations.push(x),this.elapsedOverall+=x,this.invocationCount+=1,this._stopWatch=void 0}}}n.EventProfiling=e,e.all=new Set,e._idPool=0;let c=-1;class i{constructor(x,P,F=(i._idPool++).toString(16).padStart(3,"0")){this._errorHandler=x,this.threshold=P,this.name=F,this._warnCountdown=0}dispose(){var x;(x=this._stacks)===null||x===void 0||x.clear()}check(x,P){const F=this.threshold;if(F<=0||P<F)return;this._stacks||(this._stacks=new Map);const I=this._stacks.get(x.value)||0;if(this._stacks.set(x.value,I+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=F*.5;const[V,$]=this.getMostFrequentStack(),T=`[${this.name}] potential listener LEAK detected, having ${P} listeners already. MOST frequent listener (${$}):`;console.warn(T),console.warn(V);const O=new d(T,V);this._errorHandler(O)}return()=>{const V=this._stacks.get(x.value)||0;this._stacks.set(x.value,V-1)}}getMostFrequentStack(){if(!this._stacks)return;let x,P=0;for(const[F,I]of this._stacks)(!x||P<I)&&(x=[F,I],P=I);return x}}i._idPool=1;class u{static create(){var x;const P=new Error;return new u((x=P.stack)!==null&&x!==void 0?x:"")}constructor(x){this.value=x}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class d extends Error{constructor(x,P){super(x),this.name="ListenerLeakError",this.stack=P}}n.ListenerLeakError=d;class f extends Error{constructor(x,P){super(x),this.name="ListenerRefusalError",this.stack=P}}n.ListenerRefusalError=f;class C{constructor(x){this.value=x}}const _=2,S=(R,x)=>{if(R instanceof C)x(R);else for(let P=0;P<R.length;P++){const F=R[P];F&&x(F)}};let M;if(v){const R=[];setInterval(()=>{R.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(R.join(`
`)),R.length=0)},3e3),M=new FinalizationRegistry(x=>{typeof x=="string"&&R.push(x)})}class L{constructor(x){var P,F,I,V,$,T;this._size=0,this._options=x,this._leakageMon=c>0||!((P=this._options)===null||P===void 0)&&P.leakWarningThreshold?new i((F=x?.onListenerError)!==null&&F!==void 0?F:r.onUnexpectedError,(V=(I=this._options)===null||I===void 0?void 0:I.leakWarningThreshold)!==null&&V!==void 0?V:c):void 0,this._perfMon=!(($=this._options)===null||$===void 0)&&$._profName?new e(this._options._profName):void 0,this._deliveryQueue=(T=this._options)===null||T===void 0?void 0:T.deliveryQueue}dispose(){var x,P,F,I;if(!this._disposed){if(this._disposed=!0,((x=this._deliveryQueue)===null||x===void 0?void 0:x.current)===this&&this._deliveryQueue.reset(),this._listeners){if(l){const V=this._listeners;queueMicrotask(()=>{S(V,$=>{var T;return(T=$.stack)===null||T===void 0?void 0:T.print()})})}this._listeners=void 0,this._size=0}(F=(P=this._options)===null||P===void 0?void 0:P.onDidRemoveLastListener)===null||F===void 0||F.call(P),(I=this._leakageMon)===null||I===void 0||I.dispose()}}get event(){var x;return(x=this._event)!==null&&x!==void 0||(this._event=(P,F,I)=>{var V,$,T,O,B,z,j,K;if(this._leakageMon&&this._size>this._leakageMon.threshold**2){const de=`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this._size} vs ${this._leakageMon.threshold})`;console.warn(de);const t=(V=this._leakageMon.getMostFrequentStack())!==null&&V!==void 0?V:["UNKNOWN stack",-1],ve=new f(`${de}. HINT: Stack shows most frequent listener (${t[1]}-times)`,t[0]);return((($=this._options)===null||$===void 0?void 0:$.onListenerError)||r.onUnexpectedError)(ve),A.Disposable.None}if(this._disposed)return A.Disposable.None;F&&(P=P.bind(F));const ne=new C(P);let se,oe;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(ne.stack=u.create(),se=this._leakageMon.check(ne.stack,this._size+1)),l&&(ne.stack=oe??u.create()),this._listeners?this._listeners instanceof C?((j=this._deliveryQueue)!==null&&j!==void 0||(this._deliveryQueue=new s),this._listeners=[this._listeners,ne]):this._listeners.push(ne):((O=(T=this._options)===null||T===void 0?void 0:T.onWillAddFirstListener)===null||O===void 0||O.call(T,this),this._listeners=ne,(z=(B=this._options)===null||B===void 0?void 0:B.onDidAddFirstListener)===null||z===void 0||z.call(B,this)),this._size++;const ce=(0,A.toDisposable)(()=>{M?.unregister(ce),se?.(),this._removeListener(ne)});if(I instanceof A.DisposableStore?I.add(ce):Array.isArray(I)&&I.push(ce),M){const de=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),t=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(de);M.register(ce,(K=t?.[2])!==null&&K!==void 0?K:de,ce)}return ce}),this._event}_removeListener(x){var P,F,I,V;if((F=(P=this._options)===null||P===void 0?void 0:P.onWillRemoveListener)===null||F===void 0||F.call(P,this),!this._listeners)return;if(this._size===1){this._listeners=void 0,(V=(I=this._options)===null||I===void 0?void 0:I.onDidRemoveLastListener)===null||V===void 0||V.call(I,this),this._size=0;return}const $=this._listeners,T=$.indexOf(x);if(T===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,$[T]=void 0;const O=this._deliveryQueue.current===this;if(this._size*_<=$.length){let B=0;for(let z=0;z<$.length;z++)$[z]?$[B++]=$[z]:O&&(this._deliveryQueue.end--,B<this._deliveryQueue.i&&this._deliveryQueue.i--);$.length=B}}_deliver(x,P){var F;if(!x)return;const I=((F=this._options)===null||F===void 0?void 0:F.onListenerError)||r.onUnexpectedError;if(!I){x.value(P);return}try{x.value(P)}catch(V){I(V)}}_deliverQueue(x){const P=x.current._listeners;for(;x.i<x.end;)this._deliver(P[x.i++],x.value);x.reset()}fire(x){var P,F,I,V;if(!((P=this._deliveryQueue)===null||P===void 0)&&P.current&&(this._deliverQueue(this._deliveryQueue),(F=this._perfMon)===null||F===void 0||F.stop()),(I=this._perfMon)===null||I===void 0||I.start(this._size),this._listeners)if(this._listeners instanceof C)this._deliver(this._listeners,x);else{const $=this._deliveryQueue;$.enqueue(this,x,this._listeners.length),this._deliverQueue($)}(V=this._perfMon)===null||V===void 0||V.stop()}hasListeners(){return this._size>0}}n.Emitter=L;const b=()=>new s;n.createEventDeliveryQueue=b;class s{constructor(){this.i=-1,this.end=0}enqueue(x,P,F){this.i=0,this.end=F,this.current=x,this.value=P}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class o extends L{constructor(x){super(x),this._isPaused=0,this._eventQueue=new m.LinkedList,this._mergeFn=x?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const x=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(x))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(x){this._size&&(this._isPaused!==0?this._eventQueue.push(x):super.fire(x))}}n.PauseableEmitter=o;class p extends o{constructor(x){var P;super(x),this._delay=(P=x.delay)!==null&&P!==void 0?P:100}fire(x){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(x)}}n.DebounceEmitter=p;class w extends L{constructor(x){super(x),this._queuedEvents=[],this._mergeFn=x?.merge}fire(x){this.hasListeners()&&(this._queuedEvents.push(x),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(P=>super.fire(P)),this._queuedEvents=[]}))}}n.MicrotaskEmitter=w;class N{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new L({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(x){const P={event:x,listener:null};this.events.push(P),this.hasListeners&&this.hook(P);const F=()=>{this.hasListeners&&this.unhook(P);const I=this.events.indexOf(P);this.events.splice(I,1)};return(0,A.toDisposable)((0,D.createSingleCallFunction)(F))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(x=>this.hook(x))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(x=>this.unhook(x))}hook(x){x.listener=x.event(P=>this.emitter.fire(P))}unhook(x){var P;(P=x.listener)===null||P===void 0||P.dispose(),x.listener=null}dispose(){var x;this.emitter.dispose();for(const P of this.events)(x=P.listener)===null||x===void 0||x.dispose();this.events=[]}}n.EventMultiplexer=N;class y{constructor(){this.data=[]}wrapEvent(x,P,F){return(I,V,$)=>x(T=>{var O;const B=this.data[this.data.length-1];if(!P){B?B.buffers.push(()=>I.call(V,T)):I.call(V,T);return}const z=B;if(!z){I.call(V,P(F,T));return}(O=z.items)!==null&&O!==void 0||(z.items=[]),z.items.push(T),z.buffers.length===0&&B.buffers.push(()=>{var j;(j=z.reducedResult)!==null&&j!==void 0||(z.reducedResult=F?z.items.reduce(P,F):z.items.reduce(P)),I.call(V,z.reducedResult)})},void 0,$)}bufferEvents(x){const P={buffers:new Array};this.data.push(P);const F=x();return this.data.pop(),P.buffers.forEach(I=>I()),F}}n.EventBufferer=y;class E{constructor(){this.listening=!1,this.inputEvent=g.None,this.inputEventListener=A.Disposable.None,this.emitter=new L({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(x){this.inputEvent=x,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=x(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}n.Relay=E}),Y(J[41],Z([0,1,10]),function(W,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0,n.cancelOnDispose=v;const D=Object.freeze(function(l,a){const g=setTimeout(l.bind(a),0);return{dispose(){clearTimeout(g)}}});var A;(function(l){function a(g){return g===l.None||g===l.Cancelled||g instanceof m?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}l.isCancellationToken=a,l.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:r.Event.None}),l.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(A||(n.CancellationToken=A={}));class m{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?D:(this._emitter||(this._emitter=new r.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class h{constructor(a){this._token=void 0,this._parentListener=void 0,this._parentListener=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new m),this._token}cancel(){this._token?this._token instanceof m&&this._token.cancel():this._token=A.Cancelled}dispose(a=!1){var g;a&&this.cancel(),(g=this._parentListener)===null||g===void 0||g.dispose(),this._token?this._token instanceof m&&this._token.dispose():this._token=A.None}}n.CancellationTokenSource=h;function v(l){const a=new h;return l.add({dispose(){a.cancel()}}),a.token}}),Y(J[6],Z([0,1,34,38]),function(W,n,r,D){"use strict";var A;Object.defineProperty(n,"__esModule",{value:!0}),n.InvisibleCharacters=n.AmbiguousCharacters=n.noBreakWhitespace=n.UTF8_BOM_CHARACTER=n.UNUSUAL_LINE_TERMINATORS=n.GraphemeIterator=n.CodePointIterator=void 0,n.isFalsyOrWhitespace=m,n.format=v,n.htmlAttributeEncodeValue=l,n.escape=a,n.escapeRegExpCharacters=g,n.trim=e,n.ltrim=c,n.rtrim=i,n.convertSimple2RegExpPattern=u,n.stripWildcards=d,n.createRegExp=f,n.regExpLeadsToEndlessLoop=C,n.splitLines=_,n.splitLinesIncludeSeparators=S,n.firstNonWhitespaceIndex=M,n.getLeadingWhitespace=L,n.lastNonWhitespaceIndex=b,n.compare=s,n.compareSubstring=o,n.compareIgnoreCase=p,n.compareSubstringIgnoreCase=w,n.isAsciiDigit=N,n.isLowerAsciiLetter=y,n.isUpperAsciiLetter=E,n.equalsIgnoreCase=R,n.startsWithIgnoreCase=x,n.commonPrefixLength=P,n.commonSuffixLength=F,n.isHighSurrogate=I,n.isLowSurrogate=V,n.computeCodePoint=$,n.getNextCodePoint=T,n.nextCharLength=j,n.prevCharLength=K,n.getCharContainingOffset=ne,n.containsRTL=ce,n.isBasicASCII=t,n.containsUnusualLineTerminators=ve,n.isFullWidthCharacter=pe,n.isEmojiImprecise=Le,n.startsWithUTF8BOM=Ce,n.containsUppercaseCharacter=Se,n.singleLetterHash=ye,n.getLeftDeleteOffset=te;function m(k){return!k||typeof k!="string"?!0:k.trim().length===0}const h=/{(\d+)}/g;function v(k,...q){return q.length===0?k:k.replace(h,function(H,G){const ee=parseInt(G,10);return isNaN(ee)||ee<0||ee>=q.length?H:q[ee]})}function l(k){return k.replace(/[<>"'&]/g,q=>{switch(q){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return q})}function a(k){return k.replace(/[<>&]/g,function(q){switch(q){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return q}})}function g(k){return k.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function e(k,q=" "){const H=c(k,q);return i(H,q)}function c(k,q){if(!k||!q)return k;const H=q.length;if(H===0||k.length===0)return k;let G=0;for(;k.indexOf(q,G)===G;)G=G+H;return k.substring(G)}function i(k,q){if(!k||!q)return k;const H=q.length,G=k.length;if(H===0||G===0)return k;let ee=G,ie=-1;for(;ie=k.lastIndexOf(q,ee-1),!(ie===-1||ie+H!==ee);){if(ie===0)return"";ee=ie}return k.substring(0,ee)}function u(k){return k.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function d(k){return k.replace(/\*/g,"")}function f(k,q,H={}){if(!k)throw new Error("Cannot create regex from empty string");q||(k=g(k)),H.wholeWord&&(/\B/.test(k.charAt(0))||(k="\\b"+k),/\B/.test(k.charAt(k.length-1))||(k=k+"\\b"));let G="";return H.global&&(G+="g"),H.matchCase||(G+="i"),H.multiline&&(G+="m"),H.unicode&&(G+="u"),new RegExp(k,G)}function C(k){return k.source==="^"||k.source==="^$"||k.source==="$"||k.source==="^\\s*$"?!1:!!(k.exec("")&&k.lastIndex===0)}function _(k){return k.split(/\r\n|\r|\n/)}function S(k){var q;const H=[],G=k.split(/(\r\n|\r|\n)/);for(let ee=0;ee<Math.ceil(G.length/2);ee++)H.push(G[2*ee]+((q=G[2*ee+1])!==null&&q!==void 0?q:""));return H}function M(k){for(let q=0,H=k.length;q<H;q++){const G=k.charCodeAt(q);if(G!==32&&G!==9)return q}return-1}function L(k,q=0,H=k.length){for(let G=q;G<H;G++){const ee=k.charCodeAt(G);if(ee!==32&&ee!==9)return k.substring(q,G)}return k.substring(q,H)}function b(k,q=k.length-1){for(let H=q;H>=0;H--){const G=k.charCodeAt(H);if(G!==32&&G!==9)return H}return-1}function s(k,q){return k<q?-1:k>q?1:0}function o(k,q,H=0,G=k.length,ee=0,ie=q.length){for(;H<G&&ee<ie;H++,ee++){const he=k.charCodeAt(H),ae=q.charCodeAt(ee);if(he<ae)return-1;if(he>ae)return 1}const ue=G-H,me=ie-ee;return ue<me?-1:ue>me?1:0}function p(k,q){return w(k,q,0,k.length,0,q.length)}function w(k,q,H=0,G=k.length,ee=0,ie=q.length){for(;H<G&&ee<ie;H++,ee++){let he=k.charCodeAt(H),ae=q.charCodeAt(ee);if(he===ae)continue;if(he>=128||ae>=128)return o(k.toLowerCase(),q.toLowerCase(),H,G,ee,ie);y(he)&&(he-=32),y(ae)&&(ae-=32);const fe=he-ae;if(fe!==0)return fe}const ue=G-H,me=ie-ee;return ue<me?-1:ue>me?1:0}function N(k){return k>=48&&k<=57}function y(k){return k>=97&&k<=122}function E(k){return k>=65&&k<=90}function R(k,q){return k.length===q.length&&w(k,q)===0}function x(k,q){const H=q.length;return q.length>k.length?!1:w(k,q,0,H)===0}function P(k,q){const H=Math.min(k.length,q.length);let G;for(G=0;G<H;G++)if(k.charCodeAt(G)!==q.charCodeAt(G))return G;return H}function F(k,q){const H=Math.min(k.length,q.length);let G;const ee=k.length-1,ie=q.length-1;for(G=0;G<H;G++)if(k.charCodeAt(ee-G)!==q.charCodeAt(ie-G))return G;return H}function I(k){return 55296<=k&&k<=56319}function V(k){return 56320<=k&&k<=57343}function $(k,q){return(k-55296<<10)+(q-56320)+65536}function T(k,q,H){const G=k.charCodeAt(H);if(I(G)&&H+1<q){const ee=k.charCodeAt(H+1);if(V(ee))return $(G,ee)}return G}function O(k,q){const H=k.charCodeAt(q-1);if(V(H)&&q>1){const G=k.charCodeAt(q-2);if(I(G))return $(G,H)}return H}class B{get offset(){return this._offset}constructor(q,H=0){this._str=q,this._len=q.length,this._offset=H}setOffset(q){this._offset=q}prevCodePoint(){const q=O(this._str,this._offset);return this._offset-=q>=65536?2:1,q}nextCodePoint(){const q=T(this._str,this._len,this._offset);return this._offset+=q>=65536?2:1,q}eol(){return this._offset>=this._len}}n.CodePointIterator=B;class z{get offset(){return this._iterator.offset}constructor(q,H=0){this._iterator=new B(q,H)}nextGraphemeLength(){const q=ge.getInstance(),H=this._iterator,G=H.offset;let ee=q.getGraphemeBreakType(H.nextCodePoint());for(;!H.eol();){const ie=H.offset,ue=q.getGraphemeBreakType(H.nextCodePoint());if(we(ee,ue)){H.setOffset(ie);break}ee=ue}return H.offset-G}prevGraphemeLength(){const q=ge.getInstance(),H=this._iterator,G=H.offset;let ee=q.getGraphemeBreakType(H.prevCodePoint());for(;H.offset>0;){const ie=H.offset,ue=q.getGraphemeBreakType(H.prevCodePoint());if(we(ue,ee)){H.setOffset(ie);break}ee=ue}return G-H.offset}eol(){return this._iterator.eol()}}n.GraphemeIterator=z;function j(k,q){return new z(k,q).nextGraphemeLength()}function K(k,q){return new z(k,q).prevGraphemeLength()}function ne(k,q){q>0&&V(k.charCodeAt(q))&&q--;const H=q+j(k,q);return[H-K(k,H),H]}let se;function oe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ce(k){return se||(se=oe()),se.test(k)}const de=/^[\t\n\r\x20-\x7E]*$/;function t(k){return de.test(k)}n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ve(k){return n.UNUSUAL_LINE_TERMINATORS.test(k)}function pe(k){return k>=11904&&k<=55215||k>=63744&&k<=64255||k>=65281&&k<=65374}function Le(k){return k>=127462&&k<=127487||k===8986||k===8987||k===9200||k===9203||k>=9728&&k<=10175||k===11088||k===11093||k>=127744&&k<=128591||k>=128640&&k<=128764||k>=128992&&k<=129008||k>=129280&&k<=129535||k>=129648&&k<=129782}n.UTF8_BOM_CHARACTER="\uFEFF";function Ce(k){return!!(k&&k.length>0&&k.charCodeAt(0)===65279)}function Se(k,q=!1){return k?(q&&(k=k.replace(/\\./g,"")),k.toLowerCase()!==k):!1}function ye(k){return k=k%(2*26),k<26?String.fromCharCode(97+k):String.fromCharCode(65+k-26)}function we(k,q){return k===0?q!==5&&q!==7:k===2&&q===3?!1:k===4||k===2||k===3||q===4||q===2||q===3?!0:!(k===8&&(q===8||q===9||q===11||q===12)||(k===11||k===9)&&(q===9||q===10)||(k===12||k===10)&&q===10||q===5||q===13||q===7||k===1||k===13&&q===14||k===6&&q===6)}class ge{static getInstance(){return ge._INSTANCE||(ge._INSTANCE=new ge),ge._INSTANCE}constructor(){this._data=Ne()}getGraphemeBreakType(q){if(q<32)return q===10?3:q===13?2:4;if(q<127)return 0;const H=this._data,G=H.length/3;let ee=1;for(;ee<=G;)if(q<H[3*ee])ee=2*ee;else if(q>H[3*ee+1])ee=2*ee+1;else return H[3*ee+2];return 0}}ge._INSTANCE=null;function Ne(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function te(k,q){if(k===0)return 0;const H=Q(k,q);if(H!==void 0)return H;const G=new B(q,k);return G.prevCodePoint(),G.offset}function Q(k,q){const H=new B(q,k);let G=H.prevCodePoint();for(;U(G)||G===65039||G===8419;){if(H.offset===0)return;G=H.prevCodePoint()}if(!Le(G))return;let ee=H.offset;return ee>0&&H.prevCodePoint()===8205&&(ee=H.offset),ee}function U(k){return 127995<=k&&k<=127999}n.noBreakWhitespace="\xA0";class X{static getInstance(q){return A.cache.get(Array.from(q))}static getLocales(){return A._locales.value}constructor(q){this.confusableDictionary=q}isAmbiguous(q){return this.confusableDictionary.has(q)}getPrimaryConfusable(q){return this.confusableDictionary.get(q)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}n.AmbiguousCharacters=X,A=X,X.ambiguousCharacterData=new D.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),X.cache=new r.LRUCachedFunction({getCacheKey:JSON.stringify},k=>{function q(ae){const fe=new Map;for(let be=0;be<ae.length;be+=2)fe.set(ae[be],ae[be+1]);return fe}function H(ae,fe){const be=new Map(ae);for(const[_e,Ee]of fe)be.set(_e,Ee);return be}function G(ae,fe){if(!ae)return fe;const be=new Map;for(const[_e,Ee]of ae)fe.has(_e)&&be.set(_e,Ee);return be}const ee=A.ambiguousCharacterData.value;let ie=k.filter(ae=>!ae.startsWith("_")&&ae in ee);ie.length===0&&(ie=["_default"]);let ue;for(const ae of ie){const fe=q(ee[ae]);ue=G(ue,fe)}const me=q(ee._common),he=H(me,ue);return new A(he)}),X._locales=new D.Lazy(()=>Object.keys(A.ambiguousCharacterData.value).filter(k=>!k.startsWith("_")));class re{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(re.getRawData())),this._data}static isInvisibleCharacter(q){return re.getData().has(q)}static get codePoints(){return re.getData()}}n.InvisibleCharacters=re,re._data=void 0}),Y(J[42],Z([0,1,6]),function(W,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=void 0,n.hash=D,n.doHash=A,n.numberHash=m,n.stringHash=v,n.toHexString=i;function D(d){return A(d,0)}function A(d,f){switch(typeof d){case"object":return d===null?m(349,f):Array.isArray(d)?l(d,f):a(d,f);case"string":return v(d,f);case"boolean":return h(d,f);case"number":return m(d,f);case"undefined":return m(937,f);default:return m(617,f)}}function m(d,f){return(f<<5)-f+d|0}function h(d,f){return m(d?433:863,f)}function v(d,f){f=m(149417,f);for(let C=0,_=d.length;C<_;C++)f=m(d.charCodeAt(C),f);return f}function l(d,f){return f=m(104579,f),d.reduce((C,_)=>A(_,C),f)}function a(d,f){return f=m(181387,f),Object.keys(d).sort().reduce((C,_)=>(C=v(_,C),A(d[_],C)),f)}function g(d,f,C=32){const _=C-f,S=~((1<<_)-1);return(d<<f|(S&d)>>>_)>>>0}function e(d,f=0,C=d.byteLength,_=0){for(let S=0;S<C;S++)d[f+S]=_}function c(d,f,C="0"){for(;d.length<f;)d=C+d;return d}function i(d,f=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(C=>C.toString(16).padStart(2,"0")).join(""):c((d>>>0).toString(16),f/4)}class u{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(67),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(f){const C=f.length;if(C===0)return;const _=this._buff;let S=this._buffLen,M=this._leftoverHighSurrogate,L,b;for(M!==0?(L=M,b=-1,M=0):(L=f.charCodeAt(0),b=0);;){let s=L;if(r.isHighSurrogate(L))if(b+1<C){const o=f.charCodeAt(b+1);r.isLowSurrogate(o)?(b++,s=r.computeCodePoint(L,o)):s=65533}else{M=L;break}else r.isLowSurrogate(L)&&(s=65533);if(S=this._push(_,S,s),b++,b<C)L=f.charCodeAt(b);else break}this._buffLen=S,this._leftoverHighSurrogate=M}_push(f,C,_){return _<128?f[C++]=_:_<2048?(f[C++]=192|(_&1984)>>>6,f[C++]=128|(_&63)>>>0):_<65536?(f[C++]=224|(_&61440)>>>12,f[C++]=128|(_&4032)>>>6,f[C++]=128|(_&63)>>>0):(f[C++]=240|(_&1835008)>>>18,f[C++]=128|(_&258048)>>>12,f[C++]=128|(_&4032)>>>6,f[C++]=128|(_&63)>>>0),C>=64&&(this._step(),C-=64,this._totalLen+=64,f[0]=f[64],f[1]=f[65],f[2]=f[66]),C}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),i(this._h0)+i(this._h1)+i(this._h2)+i(this._h3)+i(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,e(this._buff,this._buffLen),this._buffLen>56&&(this._step(),e(this._buff));const f=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(f/4294967296),!1),this._buffDV.setUint32(60,f%4294967296,!1),this._step()}_step(){const f=u._bigBlock32,C=this._buffDV;for(let w=0;w<64;w+=4)f.setUint32(w,C.getUint32(w,!1),!1);for(let w=64;w<320;w+=4)f.setUint32(w,g(f.getUint32(w-12,!1)^f.getUint32(w-32,!1)^f.getUint32(w-56,!1)^f.getUint32(w-64,!1),1),!1);let _=this._h0,S=this._h1,M=this._h2,L=this._h3,b=this._h4,s,o,p;for(let w=0;w<80;w++)w<20?(s=S&M|~S&L,o=1518500249):w<40?(s=S^M^L,o=1859775393):w<60?(s=S&M|S&L|M&L,o=2400959708):(s=S^M^L,o=3395469782),p=g(_,5)+s+b+o+f.getUint32(w*4,!1)&4294967295,b=L,L=M,M=g(S,30),S=_,_=p;this._h0=this._h0+_&4294967295,this._h1=this._h1+S&4294967295,this._h2=this._h2+M&4294967295,this._h3=this._h3+L&4294967295,this._h4=this._h4+b&4294967295}}n.StringSHA1=u,u._bigBlock32=new DataView(new ArrayBuffer(320))}),Y(J[24],Z([0,1,36,42]),function(W,n,r,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.StringDiffSequence=void 0,n.stringDiff=m;class A{constructor(e){this.source=e}getElements(){const e=this.source,c=new Int32Array(e.length);for(let i=0,u=e.length;i<u;i++)c[i]=e.charCodeAt(i);return c}}n.StringDiffSequence=A;function m(g,e,c){return new a(new A(g),new A(e)).ComputeDiff(c).changes}class h{static Assert(e,c){if(!e)throw new Error(c)}}class v{static Copy(e,c,i,u,d){for(let f=0;f<d;f++)i[u+f]=e[c+f]}static Copy2(e,c,i,u,d){for(let f=0;f<d;f++)i[u+f]=e[c+f]}}class l{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new r.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(e,c){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,c),this.m_originalCount++}AddModifiedElement(e,c){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,c),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class a{constructor(e,c,i=null){this.ContinueProcessingPredicate=i,this._originalSequence=e,this._modifiedSequence=c;const[u,d,f]=a._getElements(e),[C,_,S]=a._getElements(c);this._hasStrings=f&&S,this._originalStringElements=u,this._originalElementsOrHash=d,this._modifiedStringElements=C,this._modifiedElementsOrHash=_,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(e){return e.length>0&&typeof e[0]=="string"}static _getElements(e){const c=e.getElements();if(a._isStringArray(c)){const i=new Int32Array(c.length);for(let u=0,d=c.length;u<d;u++)i[u]=(0,D.stringHash)(c[u],0);return[c,i,!0]}return c instanceof Int32Array?[[],c,!1]:[[],new Int32Array(c),!1]}ElementsAreEqual(e,c){return this._originalElementsOrHash[e]!==this._modifiedElementsOrHash[c]?!1:this._hasStrings?this._originalStringElements[e]===this._modifiedStringElements[c]:!0}ElementsAreStrictEqual(e,c){if(!this.ElementsAreEqual(e,c))return!1;const i=a._getStrictElement(this._originalSequence,e),u=a._getStrictElement(this._modifiedSequence,c);return i===u}static _getStrictElement(e,c){return typeof e.getStrictElement=="function"?e.getStrictElement(c):null}OriginalElementsAreEqual(e,c){return this._originalElementsOrHash[e]!==this._originalElementsOrHash[c]?!1:this._hasStrings?this._originalStringElements[e]===this._originalStringElements[c]:!0}ModifiedElementsAreEqual(e,c){return this._modifiedElementsOrHash[e]!==this._modifiedElementsOrHash[c]?!1:this._hasStrings?this._modifiedStringElements[e]===this._modifiedStringElements[c]:!0}ComputeDiff(e){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,e)}_ComputeDiff(e,c,i,u,d){const f=[!1];let C=this.ComputeDiffRecursive(e,c,i,u,f);return d&&(C=this.PrettifyChanges(C)),{quitEarly:f[0],changes:C}}ComputeDiffRecursive(e,c,i,u,d){for(d[0]=!1;e<=c&&i<=u&&this.ElementsAreEqual(e,i);)e++,i++;for(;c>=e&&u>=i&&this.ElementsAreEqual(c,u);)c--,u--;if(e>c||i>u){let L;return i<=u?(h.Assert(e===c+1,"originalStart should only be one more than originalEnd"),L=[new r.DiffChange(e,0,i,u-i+1)]):e<=c?(h.Assert(i===u+1,"modifiedStart should only be one more than modifiedEnd"),L=[new r.DiffChange(e,c-e+1,i,0)]):(h.Assert(e===c+1,"originalStart should only be one more than originalEnd"),h.Assert(i===u+1,"modifiedStart should only be one more than modifiedEnd"),L=[]),L}const f=[0],C=[0],_=this.ComputeRecursionPoint(e,c,i,u,f,C,d),S=f[0],M=C[0];if(_!==null)return _;if(!d[0]){const L=this.ComputeDiffRecursive(e,S,i,M,d);let b=[];return d[0]?b=[new r.DiffChange(S+1,c-(S+1)+1,M+1,u-(M+1)+1)]:b=this.ComputeDiffRecursive(S+1,c,M+1,u,d),this.ConcatenateChanges(L,b)}return[new r.DiffChange(e,c-e+1,i,u-i+1)]}WALKTRACE(e,c,i,u,d,f,C,_,S,M,L,b,s,o,p,w,N,y){let E=null,R=null,x=new l,P=c,F=i,I=s[0]-w[0]-u,V=-1073741824,$=this.m_forwardHistory.length-1;do{const T=I+e;T===P||T<F&&S[T-1]<S[T+1]?(L=S[T+1],o=L-I-u,L<V&&x.MarkNextChange(),V=L,x.AddModifiedElement(L+1,o),I=T+1-e):(L=S[T-1]+1,o=L-I-u,L<V&&x.MarkNextChange(),V=L-1,x.AddOriginalElement(L,o+1),I=T-1-e),$>=0&&(S=this.m_forwardHistory[$],e=S[0],P=1,F=S.length-1)}while(--$>=-1);if(E=x.getReverseChanges(),y[0]){let T=s[0]+1,O=w[0]+1;if(E!==null&&E.length>0){const B=E[E.length-1];T=Math.max(T,B.getOriginalEnd()),O=Math.max(O,B.getModifiedEnd())}R=[new r.DiffChange(T,b-T+1,O,p-O+1)]}else{x=new l,P=f,F=C,I=s[0]-w[0]-_,V=1073741824,$=N?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const T=I+d;T===P||T<F&&M[T-1]>=M[T+1]?(L=M[T+1]-1,o=L-I-_,L>V&&x.MarkNextChange(),V=L+1,x.AddOriginalElement(L+1,o+1),I=T+1-d):(L=M[T-1],o=L-I-_,L>V&&x.MarkNextChange(),V=L,x.AddModifiedElement(L+1,o+1),I=T-1-d),$>=0&&(M=this.m_reverseHistory[$],d=M[0],P=1,F=M.length-1)}while(--$>=-1);R=x.getChanges()}return this.ConcatenateChanges(E,R)}ComputeRecursionPoint(e,c,i,u,d,f,C){let _=0,S=0,M=0,L=0,b=0,s=0;e--,i--,d[0]=0,f[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const o=c-e+(u-i),p=o+1,w=new Int32Array(p),N=new Int32Array(p),y=u-i,E=c-e,R=e-i,x=c-u,F=(E-y)%2===0;w[y]=e,N[E]=c,C[0]=!1;for(let I=1;I<=o/2+1;I++){let V=0,$=0;M=this.ClipDiagonalBound(y-I,I,y,p),L=this.ClipDiagonalBound(y+I,I,y,p);for(let O=M;O<=L;O+=2){O===M||O<L&&w[O-1]<w[O+1]?_=w[O+1]:_=w[O-1]+1,S=_-(O-y)-R;const B=_;for(;_<c&&S<u&&this.ElementsAreEqual(_+1,S+1);)_++,S++;if(w[O]=_,_+S>V+$&&(V=_,$=S),!F&&Math.abs(O-E)<=I-1&&_>=N[O])return d[0]=_,f[0]=S,B<=N[O]&&1447>0&&I<=1448?this.WALKTRACE(y,M,L,R,E,b,s,x,w,N,_,c,d,S,u,f,F,C):null}const T=(V-e+($-i)-I)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(V,T))return C[0]=!0,d[0]=V,f[0]=$,T>0&&1447>0&&I<=1448?this.WALKTRACE(y,M,L,R,E,b,s,x,w,N,_,c,d,S,u,f,F,C):(e++,i++,[new r.DiffChange(e,c-e+1,i,u-i+1)]);b=this.ClipDiagonalBound(E-I,I,E,p),s=this.ClipDiagonalBound(E+I,I,E,p);for(let O=b;O<=s;O+=2){O===b||O<s&&N[O-1]>=N[O+1]?_=N[O+1]-1:_=N[O-1],S=_-(O-E)-x;const B=_;for(;_>e&&S>i&&this.ElementsAreEqual(_,S);)_--,S--;if(N[O]=_,F&&Math.abs(O-y)<=I&&_<=w[O])return d[0]=_,f[0]=S,B>=w[O]&&1447>0&&I<=1448?this.WALKTRACE(y,M,L,R,E,b,s,x,w,N,_,c,d,S,u,f,F,C):null}if(I<=1447){let O=new Int32Array(L-M+2);O[0]=y-M+1,v.Copy2(w,M,O,1,L-M+1),this.m_forwardHistory.push(O),O=new Int32Array(s-b+2),O[0]=E-b+1,v.Copy2(N,b,O,1,s-b+1),this.m_reverseHistory.push(O)}}return this.WALKTRACE(y,M,L,R,E,b,s,x,w,N,_,c,d,S,u,f,F,C)}PrettifyChanges(e){for(let c=0;c<e.length;c++){const i=e[c],u=c<e.length-1?e[c+1].originalStart:this._originalElementsOrHash.length,d=c<e.length-1?e[c+1].modifiedStart:this._modifiedElementsOrHash.length,f=i.originalLength>0,C=i.modifiedLength>0;for(;i.originalStart+i.originalLength<u&&i.modifiedStart+i.modifiedLength<d&&(!f||this.OriginalElementsAreEqual(i.originalStart,i.originalStart+i.originalLength))&&(!C||this.ModifiedElementsAreEqual(i.modifiedStart,i.modifiedStart+i.modifiedLength));){const S=this.ElementsAreStrictEqual(i.originalStart,i.modifiedStart);if(this.ElementsAreStrictEqual(i.originalStart+i.originalLength,i.modifiedStart+i.modifiedLength)&&!S)break;i.originalStart++,i.modifiedStart++}const _=[null];if(c<e.length-1&&this.ChangesOverlap(e[c],e[c+1],_)){e[c]=_[0],e.splice(c+1,1),c--;continue}}for(let c=e.length-1;c>=0;c--){const i=e[c];let u=0,d=0;if(c>0){const L=e[c-1];u=L.originalStart+L.originalLength,d=L.modifiedStart+L.modifiedLength}const f=i.originalLength>0,C=i.modifiedLength>0;let _=0,S=this._boundaryScore(i.originalStart,i.originalLength,i.modifiedStart,i.modifiedLength);for(let L=1;;L++){const b=i.originalStart-L,s=i.modifiedStart-L;if(b<u||s<d||f&&!this.OriginalElementsAreEqual(b,b+i.originalLength)||C&&!this.ModifiedElementsAreEqual(s,s+i.modifiedLength))break;const p=(b===u&&s===d?5:0)+this._boundaryScore(b,i.originalLength,s,i.modifiedLength);p>S&&(S=p,_=L)}i.originalStart-=_,i.modifiedStart-=_;const M=[null];if(c>0&&this.ChangesOverlap(e[c-1],e[c],M)){e[c-1]=M[0],e.splice(c,1),c++;continue}}if(this._hasStrings)for(let c=1,i=e.length;c<i;c++){const u=e[c-1],d=e[c],f=d.originalStart-u.originalStart-u.originalLength,C=u.originalStart,_=d.originalStart+d.originalLength,S=_-C,M=u.modifiedStart,L=d.modifiedStart+d.modifiedLength,b=L-M;if(f<5&&S<20&&b<20){const s=this._findBetterContiguousSequence(C,S,M,b,f);if(s){const[o,p]=s;(o!==u.originalStart+u.originalLength||p!==u.modifiedStart+u.modifiedLength)&&(u.originalLength=o-u.originalStart,u.modifiedLength=p-u.modifiedStart,d.originalStart=o+f,d.modifiedStart=p+f,d.originalLength=_-d.originalStart,d.modifiedLength=L-d.modifiedStart)}}}return e}_findBetterContiguousSequence(e,c,i,u,d){if(c<d||u<d)return null;const f=e+c-d+1,C=i+u-d+1;let _=0,S=0,M=0;for(let L=e;L<f;L++)for(let b=i;b<C;b++){const s=this._contiguousSequenceScore(L,b,d);s>0&&s>_&&(_=s,S=L,M=b)}return _>0?[S,M]:null}_contiguousSequenceScore(e,c,i){let u=0;for(let d=0;d<i;d++){if(!this.ElementsAreEqual(e+d,c+d))return 0;u+=this._originalStringElements[e+d].length}return u}_OriginalIsBoundary(e){return e<=0||e>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[e])}_OriginalRegionIsBoundary(e,c){if(this._OriginalIsBoundary(e)||this._OriginalIsBoundary(e-1))return!0;if(c>0){const i=e+c;if(this._OriginalIsBoundary(i-1)||this._OriginalIsBoundary(i))return!0}return!1}_ModifiedIsBoundary(e){return e<=0||e>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[e])}_ModifiedRegionIsBoundary(e,c){if(this._ModifiedIsBoundary(e)||this._ModifiedIsBoundary(e-1))return!0;if(c>0){const i=e+c;if(this._ModifiedIsBoundary(i-1)||this._ModifiedIsBoundary(i))return!0}return!1}_boundaryScore(e,c,i,u){const d=this._OriginalRegionIsBoundary(e,c)?1:0,f=this._ModifiedRegionIsBoundary(i,u)?1:0;return d+f}ConcatenateChanges(e,c){const i=[];if(e.length===0||c.length===0)return c.length>0?c:e;if(this.ChangesOverlap(e[e.length-1],c[0],i)){const u=new Array(e.length+c.length-1);return v.Copy(e,0,u,0,e.length-1),u[e.length-1]=i[0],v.Copy(c,1,u,e.length,c.length-1),u}else{const u=new Array(e.length+c.length);return v.Copy(e,0,u,0,e.length),v.Copy(c,0,u,e.length,c.length),u}}ChangesOverlap(e,c,i){if(h.Assert(e.originalStart<=c.originalStart,"Left change is not less than or equal to right change"),h.Assert(e.modifiedStart<=c.modifiedStart,"Left change is not less than or equal to right change"),e.originalStart+e.originalLength>=c.originalStart||e.modifiedStart+e.modifiedLength>=c.modifiedStart){const u=e.originalStart;let d=e.originalLength;const f=e.modifiedStart;let C=e.modifiedLength;return e.originalStart+e.originalLength>=c.originalStart&&(d=c.originalStart+c.originalLength-e.originalStart),e.modifiedStart+e.modifiedLength>=c.modifiedStart&&(C=c.modifiedStart+c.modifiedLength-e.modifiedStart),i[0]=new r.DiffChange(u,d,f,C),!0}else return i[0]=null,!1}ClipDiagonalBound(e,c,i,u){if(e>=0&&e<u)return e;const d=i,f=u-i-1,C=c%2===0;if(e<0){const _=d%2===0;return C===_?0:1}else{const _=f%2===0;return C===_?u-1:u-2}}}n.LcsDiff=a}),Y(J[25],Z([0,1]),function(W,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.isString=r,n.isObject=D,n.isTypedArray=A,n.isNumber=m,n.isIterable=h,n.isBoolean=v,n.isUndefined=l,n.isDefined=a,n.isUndefinedOrNull=g,n.assertType=e,n.assertIsDefined=c,n.isFunction=i,n.validateConstraints=u,n.validateConstraint=d;function r(f){return typeof f=="string"}function D(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}function A(f){const C=Object.getPrototypeOf(Uint8Array);return typeof f=="object"&&f instanceof C}function m(f){return typeof f=="number"&&!isNaN(f)}function h(f){return!!f&&typeof f[Symbol.iterator]=="function"}function v(f){return f===!0||f===!1}function l(f){return typeof f>"u"}function a(f){return!g(f)}function g(f){return l(f)||f===null}function e(f,C){if(!f)throw new Error(C?`Unexpected type, expected '${C}'`:"Unexpected type")}function c(f){if(g(f))throw new Error("Assertion Failed: argument is undefined or null");return f}function i(f){return typeof f=="function"}function u(f,C){const _=Math.min(f.length,C.length);for(let S=0;S<_;S++)d(f[S],C[S])}function d(f,C){if(r(C)){if(typeof f!==C)throw new Error(`argument does not match constraint: typeof ${C}`)}else if(i(C)){try{if(f instanceof C)return}catch{}if(!g(f)&&f.constructor===C||C.length===1&&C.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),Y(J[26],Z([0,1,25]),function(W,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.register=A,n.getCodiconFontCharacters=m;const D=Object.create(null);function A(h,v){if((0,r.isString)(v)){const l=D[v];if(l===void 0)throw new Error(`${h} references an unknown codicon: ${v}`);v=l}return D[h]=v,{id:h}}function m(){return D}}),Y(J[43],Z([0,1,26]),function(W,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.codiconsLibrary=void 0,n.codiconsLibrary={add:(0,r.register)("add",6e4),plus:(0,r.register)("plus",6e4),gistNew:(0,r.register)("gist-new",6e4),repoCreate:(0,r.register)("repo-create",6e4),lightbulb:(0,r.register)("lightbulb",60001),lightBulb:(0,r.register)("light-bulb",60001),repo:(0,r.register)("repo",60002),repoDelete:(0,r.register)("repo-delete",60002),gistFork:(0,r.register)("gist-fork",60003),repoForked:(0,r.register)("repo-forked",60003),gitPullRequest:(0,r.register)("git-pull-request",60004),gitPullRequestAbandoned:(0,r.register)("git-pull-request-abandoned",60004),recordKeys:(0,r.register)("record-keys",60005),keyboard:(0,r.register)("keyboard",60005),tag:(0,r.register)("tag",60006),gitPullRequestLabel:(0,r.register)("git-pull-request-label",60006),tagAdd:(0,r.register)("tag-add",60006),tagRemove:(0,r.register)("tag-remove",60006),person:(0,r.register)("person",60007),personFollow:(0,r.register)("person-follow",60007),personOutline:(0,r.register)("person-outline",60007),personFilled:(0,r.register)("person-filled",60007),gitBranch:(0,r.register)("git-branch",60008),gitBranchCreate:(0,r.register)("git-branch-create",60008),gitBranchDelete:(0,r.register)("git-branch-delete",60008),sourceControl:(0,r.register)("source-control",60008),mirror:(0,r.register)("mirror",60009),mirrorPublic:(0,r.register)("mirror-public",60009),star:(0,r.register)("star",60010),starAdd:(0,r.register)("star-add",60010),starDelete:(0,r.register)("star-delete",60010),starEmpty:(0,r.register)("star-empty",60010),comment:(0,r.register)("comment",60011),commentAdd:(0,r.register)("comment-add",60011),alert:(0,r.register)("alert",60012),warning:(0,r.register)("warning",60012),search:(0,r.register)("search",60013),searchSave:(0,r.register)("search-save",60013),logOut:(0,r.register)("log-out",60014),signOut:(0,r.register)("sign-out",60014),logIn:(0,r.register)("log-in",60015),signIn:(0,r.register)("sign-in",60015),eye:(0,r.register)("eye",60016),eyeUnwatch:(0,r.register)("eye-unwatch",60016),eyeWatch:(0,r.register)("eye-watch",60016),circleFilled:(0,r.register)("circle-filled",60017),primitiveDot:(0,r.register)("primitive-dot",60017),closeDirty:(0,r.register)("close-dirty",60017),debugBreakpoint:(0,r.register)("debug-breakpoint",60017),debugBreakpointDisabled:(0,r.register)("debug-breakpoint-disabled",60017),debugHint:(0,r.register)("debug-hint",60017),terminalDecorationSuccess:(0,r.register)("terminal-decoration-success",60017),primitiveSquare:(0,r.register)("primitive-square",60018),edit:(0,r.register)("edit",60019),pencil:(0,r.register)("pencil",60019),info:(0,r.register)("info",60020),issueOpened:(0,r.register)("issue-opened",60020),gistPrivate:(0,r.register)("gist-private",60021),gitForkPrivate:(0,r.register)("git-fork-private",60021),lock:(0,r.register)("lock",60021),mirrorPrivate:(0,r.register)("mirror-private",60021),close:(0,r.register)("close",60022),removeClose:(0,r.register)("remove-close",60022),x:(0,r.register)("x",60022),repoSync:(0,r.register)("repo-sync",60023),sync:(0,r.register)("sync",60023),clone:(0,r.register)("clone",60024),desktopDownload:(0,r.register)("desktop-download",60024),beaker:(0,r.register)("beaker",60025),microscope:(0,r.register)("microscope",60025),vm:(0,r.register)("vm",60026),deviceDesktop:(0,r.register)("device-desktop",60026),file:(0,r.register)("file",60027),fileText:(0,r.register)("file-text",60027),more:(0,r.register)("more",60028),ellipsis:(0,r.register)("ellipsis",60028),kebabHorizontal:(0,r.register)("kebab-horizontal",60028),mailReply:(0,r.register)("mail-reply",60029),reply:(0,r.register)("reply",60029),organization:(0,r.register)("organization",60030),organizationFilled:(0,r.register)("organization-filled",60030),organizationOutline:(0,r.register)("organization-outline",60030),newFile:(0,r.register)("new-file",60031),fileAdd:(0,r.register)("file-add",60031),newFolder:(0,r.register)("new-folder",60032),fileDirectoryCreate:(0,r.register)("file-directory-create",60032),trash:(0,r.register)("trash",60033),trashcan:(0,r.register)("trashcan",60033),history:(0,r.register)("history",60034),clock:(0,r.register)("clock",60034),folder:(0,r.register)("folder",60035),fileDirectory:(0,r.register)("file-directory",60035),symbolFolder:(0,r.register)("symbol-folder",60035),logoGithub:(0,r.register)("logo-github",60036),markGithub:(0,r.register)("mark-github",60036),github:(0,r.register)("github",60036),terminal:(0,r.register)("terminal",60037),console:(0,r.register)("console",60037),repl:(0,r.register)("repl",60037),zap:(0,r.register)("zap",60038),symbolEvent:(0,r.register)("symbol-event",60038),error:(0,r.register)("error",60039),stop:(0,r.register)("stop",60039),variable:(0,r.register)("variable",60040),symbolVariable:(0,r.register)("symbol-variable",60040),array:(0,r.register)("array",60042),symbolArray:(0,r.register)("symbol-array",60042),symbolModule:(0,r.register)("symbol-module",60043),symbolPackage:(0,r.register)("symbol-package",60043),symbolNamespace:(0,r.register)("symbol-namespace",60043),symbolObject:(0,r.register)("symbol-object",60043),symbolMethod:(0,r.register)("symbol-method",60044),symbolFunction:(0,r.register)("symbol-function",60044),symbolConstructor:(0,r.register)("symbol-constructor",60044),symbolBoolean:(0,r.register)("symbol-boolean",60047),symbolNull:(0,r.register)("symbol-null",60047),symbolNumeric:(0,r.register)("symbol-numeric",60048),symbolNumber:(0,r.register)("symbol-number",60048),symbolStructure:(0,r.register)("symbol-structure",60049),symbolStruct:(0,r.register)("symbol-struct",60049),symbolParameter:(0,r.register)("symbol-parameter",60050),symbolTypeParameter:(0,r.register)("symbol-type-parameter",60050),symbolKey:(0,r.register)("symbol-key",60051),symbolText:(0,r.register)("symbol-text",60051),symbolReference:(0,r.register)("symbol-reference",60052),goToFile:(0,r.register)("go-to-file",60052),symbolEnum:(0,r.register)("symbol-enum",60053),symbolValue:(0,r.register)("symbol-value",60053),symbolRuler:(0,r.register)("symbol-ruler",60054),symbolUnit:(0,r.register)("symbol-unit",60054),activateBreakpoints:(0,r.register)("activate-breakpoints",60055),archive:(0,r.register)("archive",60056),arrowBoth:(0,r.register)("arrow-both",60057),arrowDown:(0,r.register)("arrow-down",60058),arrowLeft:(0,r.register)("arrow-left",60059),arrowRight:(0,r.register)("arrow-right",60060),arrowSmallDown:(0,r.register)("arrow-small-down",60061),arrowSmallLeft:(0,r.register)("arrow-small-left",60062),arrowSmallRight:(0,r.register)("arrow-small-right",60063),arrowSmallUp:(0,r.register)("arrow-small-up",60064),arrowUp:(0,r.register)("arrow-up",60065),bell:(0,r.register)("bell",60066),bold:(0,r.register)("bold",60067),book:(0,r.register)("book",60068),bookmark:(0,r.register)("bookmark",60069),debugBreakpointConditionalUnverified:(0,r.register)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,r.register)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,r.register)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,r.register)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,r.register)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,r.register)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,r.register)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,r.register)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,r.register)("debug-breakpoint-log-disabled",60075),briefcase:(0,r.register)("briefcase",60076),broadcast:(0,r.register)("broadcast",60077),browser:(0,r.register)("browser",60078),bug:(0,r.register)("bug",60079),calendar:(0,r.register)("calendar",60080),caseSensitive:(0,r.register)("case-sensitive",60081),check:(0,r.register)("check",60082),checklist:(0,r.register)("checklist",60083),chevronDown:(0,r.register)("chevron-down",60084),chevronLeft:(0,r.register)("chevron-left",60085),chevronRight:(0,r.register)("chevron-right",60086),chevronUp:(0,r.register)("chevron-up",60087),chromeClose:(0,r.register)("chrome-close",60088),chromeMaximize:(0,r.register)("chrome-maximize",60089),chromeMinimize:(0,r.register)("chrome-minimize",60090),chromeRestore:(0,r.register)("chrome-restore",60091),circleOutline:(0,r.register)("circle-outline",60092),circle:(0,r.register)("circle",60092),debugBreakpointUnverified:(0,r.register)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,r.register)("terminal-decoration-incomplete",60092),circleSlash:(0,r.register)("circle-slash",60093),circuitBoard:(0,r.register)("circuit-board",60094),clearAll:(0,r.register)("clear-all",60095),clippy:(0,r.register)("clippy",60096),closeAll:(0,r.register)("close-all",60097),cloudDownload:(0,r.register)("cloud-download",60098),cloudUpload:(0,r.register)("cloud-upload",60099),code:(0,r.register)("code",60100),collapseAll:(0,r.register)("collapse-all",60101),colorMode:(0,r.register)("color-mode",60102),commentDiscussion:(0,r.register)("comment-discussion",60103),creditCard:(0,r.register)("credit-card",60105),dash:(0,r.register)("dash",60108),dashboard:(0,r.register)("dashboard",60109),database:(0,r.register)("database",60110),debugContinue:(0,r.register)("debug-continue",60111),debugDisconnect:(0,r.register)("debug-disconnect",60112),debugPause:(0,r.register)("debug-pause",60113),debugRestart:(0,r.register)("debug-restart",60114),debugStart:(0,r.register)("debug-start",60115),debugStepInto:(0,r.register)("debug-step-into",60116),debugStepOut:(0,r.register)("debug-step-out",60117),debugStepOver:(0,r.register)("debug-step-over",60118),debugStop:(0,r.register)("debug-stop",60119),debug:(0,r.register)("debug",60120),deviceCameraVideo:(0,r.register)("device-camera-video",60121),deviceCamera:(0,r.register)("device-camera",60122),deviceMobile:(0,r.register)("device-mobile",60123),diffAdded:(0,r.register)("diff-added",60124),diffIgnored:(0,r.register)("diff-ignored",60125),diffModified:(0,r.register)("diff-modified",60126),diffRemoved:(0,r.register)("diff-removed",60127),diffRenamed:(0,r.register)("diff-renamed",60128),diff:(0,r.register)("diff",60129),diffSidebyside:(0,r.register)("diff-sidebyside",60129),discard:(0,r.register)("discard",60130),editorLayout:(0,r.register)("editor-layout",60131),emptyWindow:(0,r.register)("empty-window",60132),exclude:(0,r.register)("exclude",60133),extensions:(0,r.register)("extensions",60134),eyeClosed:(0,r.register)("eye-closed",60135),fileBinary:(0,r.register)("file-binary",60136),fileCode:(0,r.register)("file-code",60137),fileMedia:(0,r.register)("file-media",60138),filePdf:(0,r.register)("file-pdf",60139),fileSubmodule:(0,r.register)("file-submodule",60140),fileSymlinkDirectory:(0,r.register)("file-symlink-directory",60141),fileSymlinkFile:(0,r.register)("file-symlink-file",60142),fileZip:(0,r.register)("file-zip",60143),files:(0,r.register)("files",60144),filter:(0,r.register)("filter",60145),flame:(0,r.register)("flame",60146),foldDown:(0,r.register)("fold-down",60147),foldUp:(0,r.register)("fold-up",60148),fold:(0,r.register)("fold",60149),folderActive:(0,r.register)("folder-active",60150),folderOpened:(0,r.register)("folder-opened",60151),gear:(0,r.register)("gear",60152),gift:(0,r.register)("gift",60153),gistSecret:(0,r.register)("gist-secret",60154),gist:(0,r.register)("gist",60155),gitCommit:(0,r.register)("git-commit",60156),gitCompare:(0,r.register)("git-compare",60157),compareChanges:(0,r.register)("compare-changes",60157),gitMerge:(0,r.register)("git-merge",60158),githubAction:(0,r.register)("github-action",60159),githubAlt:(0,r.register)("github-alt",60160),globe:(0,r.register)("globe",60161),grabber:(0,r.register)("grabber",60162),graph:(0,r.register)("graph",60163),gripper:(0,r.register)("gripper",60164),heart:(0,r.register)("heart",60165),home:(0,r.register)("home",60166),horizontalRule:(0,r.register)("horizontal-rule",60167),hubot:(0,r.register)("hubot",60168),inbox:(0,r.register)("inbox",60169),issueReopened:(0,r.register)("issue-reopened",60171),issues:(0,r.register)("issues",60172),italic:(0,r.register)("italic",60173),jersey:(0,r.register)("jersey",60174),json:(0,r.register)("json",60175),kebabVertical:(0,r.register)("kebab-vertical",60176),key:(0,r.register)("key",60177),law:(0,r.register)("law",60178),lightbulbAutofix:(0,r.register)("lightbulb-autofix",60179),linkExternal:(0,r.register)("link-external",60180),link:(0,r.register)("link",60181),listOrdered:(0,r.register)("list-ordered",60182),listUnordered:(0,r.register)("list-unordered",60183),liveShare:(0,r.register)("live-share",60184),loading:(0,r.register)("loading",60185),location:(0,r.register)("location",60186),mailRead:(0,r.register)("mail-read",60187),mail:(0,r.register)("mail",60188),markdown:(0,r.register)("markdown",60189),megaphone:(0,r.register)("megaphone",60190),mention:(0,r.register)("mention",60191),milestone:(0,r.register)("milestone",60192),gitPullRequestMilestone:(0,r.register)("git-pull-request-milestone",60192),mortarBoard:(0,r.register)("mortar-board",60193),move:(0,r.register)("move",60194),multipleWindows:(0,r.register)("multiple-windows",60195),mute:(0,r.register)("mute",60196),noNewline:(0,r.register)("no-newline",60197),note:(0,r.register)("note",60198),octoface:(0,r.register)("octoface",60199),openPreview:(0,r.register)("open-preview",60200),package:(0,r.register)("package",60201),paintcan:(0,r.register)("paintcan",60202),pin:(0,r.register)("pin",60203),play:(0,r.register)("play",60204),run:(0,r.register)("run",60204),plug:(0,r.register)("plug",60205),preserveCase:(0,r.register)("preserve-case",60206),preview:(0,r.register)("preview",60207),project:(0,r.register)("project",60208),pulse:(0,r.register)("pulse",60209),question:(0,r.register)("question",60210),quote:(0,r.register)("quote",60211),radioTower:(0,r.register)("radio-tower",60212),reactions:(0,r.register)("reactions",60213),references:(0,r.register)("references",60214),refresh:(0,r.register)("refresh",60215),regex:(0,r.register)("regex",60216),remoteExplorer:(0,r.register)("remote-explorer",60217),remote:(0,r.register)("remote",60218),remove:(0,r.register)("remove",60219),replaceAll:(0,r.register)("replace-all",60220),replace:(0,r.register)("replace",60221),repoClone:(0,r.register)("repo-clone",60222),repoForcePush:(0,r.register)("repo-force-push",60223),repoPull:(0,r.register)("repo-pull",60224),repoPush:(0,r.register)("repo-push",60225),report:(0,r.register)("report",60226),requestChanges:(0,r.register)("request-changes",60227),rocket:(0,r.register)("rocket",60228),rootFolderOpened:(0,r.register)("root-folder-opened",60229),rootFolder:(0,r.register)("root-folder",60230),rss:(0,r.register)("rss",60231),ruby:(0,r.register)("ruby",60232),saveAll:(0,r.register)("save-all",60233),saveAs:(0,r.register)("save-as",60234),save:(0,r.register)("save",60235),screenFull:(0,r.register)("screen-full",60236),screenNormal:(0,r.register)("screen-normal",60237),searchStop:(0,r.register)("search-stop",60238),server:(0,r.register)("server",60240),settingsGear:(0,r.register)("settings-gear",60241),settings:(0,r.register)("settings",60242),shield:(0,r.register)("shield",60243),smiley:(0,r.register)("smiley",60244),sortPrecedence:(0,r.register)("sort-precedence",60245),splitHorizontal:(0,r.register)("split-horizontal",60246),splitVertical:(0,r.register)("split-vertical",60247),squirrel:(0,r.register)("squirrel",60248),starFull:(0,r.register)("star-full",60249),starHalf:(0,r.register)("star-half",60250),symbolClass:(0,r.register)("symbol-class",60251),symbolColor:(0,r.register)("symbol-color",60252),symbolConstant:(0,r.register)("symbol-constant",60253),symbolEnumMember:(0,r.register)("symbol-enum-member",60254),symbolField:(0,r.register)("symbol-field",60255),symbolFile:(0,r.register)("symbol-file",60256),symbolInterface:(0,r.register)("symbol-interface",60257),symbolKeyword:(0,r.register)("symbol-keyword",60258),symbolMisc:(0,r.register)("symbol-misc",60259),symbolOperator:(0,r.register)("symbol-operator",60260),symbolProperty:(0,r.register)("symbol-property",60261),wrench:(0,r.register)("wrench",60261),wrenchSubaction:(0,r.register)("wrench-subaction",60261),symbolSnippet:(0,r.register)("symbol-snippet",60262),tasklist:(0,r.register)("tasklist",60263),telescope:(0,r.register)("telescope",60264),textSize:(0,r.register)("text-size",60265),threeBars:(0,r.register)("three-bars",60266),thumbsdown:(0,r.register)("thumbsdown",60267),thumbsup:(0,r.register)("thumbsup",60268),tools:(0,r.register)("tools",60269),triangleDown:(0,r.register)("triangle-down",60270),triangleLeft:(0,r.register)("triangle-left",60271),triangleRight:(0,r.register)("triangle-right",60272),triangleUp:(0,r.register)("triangle-up",60273),twitter:(0,r.register)("twitter",60274),unfold:(0,r.register)("unfold",60275),unlock:(0,r.register)("unlock",60276),unmute:(0,r.register)("unmute",60277),unverified:(0,r.register)("unverified",60278),verified:(0,r.register)("verified",60279),versions:(0,r.register)("versions",60280),vmActive:(0,r.register)("vm-active",60281),vmOutline:(0,r.register)("vm-outline",60282),vmRunning:(0,r.register)("vm-running",60283),watch:(0,r.register)("watch",60284),whitespace:(0,r.register)("whitespace",60285),wholeWord:(0,r.register)("whole-word",60286),window:(0,r.register)("window",60287),wordWrap:(0,r.register)("word-wrap",60288),zoomIn:(0,r.register)("zoom-in",60289),zoomOut:(0,r.register)("zoom-out",60290),listFilter:(0,r.register)("list-filter",60291),listFlat:(0,r.register)("list-flat",60292),listSelection:(0,r.register)("list-selection",60293),selection:(0,r.register)("selection",60293),listTree:(0,r.register)("list-tree",60294),debugBreakpointFunctionUnverified:(0,r.register)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,r.register)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,r.register)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,r.register)("debug-stackframe-active",60297),circleSmallFilled:(0,r.register)("circle-small-filled",60298),debugStackframeDot:(0,r.register)("debug-stackframe-dot",60298),terminalDecorationMark:(0,r.register)("terminal-decoration-mark",60298),debugStackframe:(0,r.register)("debug-stackframe",60299),debugStackframeFocused:(0,r.register)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,r.register)("debug-breakpoint-unsupported",60300),symbolString:(0,r.register)("symbol-string",60301),debugReverseContinue:(0,r.register)("debug-reverse-continue",60302),debugStepBack:(0,r.register)("debug-step-back",60303),debugRestartFrame:(0,r.register)("debug-restart-frame",60304),debugAlt:(0,r.register)("debug-alt",60305),callIncoming:(0,r.register)("call-incoming",60306),callOutgoing:(0,r.register)("call-outgoing",60307),menu:(0,r.register)("menu",60308),expandAll:(0,r.register)("expand-all",60309),feedback:(0,r.register)("feedback",60310),gitPullRequestReviewer:(0,r.register)("git-pull-request-reviewer",60310),groupByRefType:(0,r.register)("group-by-ref-type",60311),ungroupByRefType:(0,r.register)("ungroup-by-ref-type",60312),account:(0,r.register)("account",60313),gitPullRequestAssignee:(0,r.register)("git-pull-request-assignee",60313),bellDot:(0,r.register)("bell-dot",60314),debugConsole:(0,r.register)("debug-console",60315),library:(0,r.register)("library",60316),output:(0,r.register)("output",60317),runAll:(0,r.register)("run-all",60318),syncIgnored:(0,r.register)("sync-ignored",60319),pinned:(0,r.register)("pinned",60320),githubInverted:(0,r.register)("github-inverted",60321),serverProcess:(0,r.register)("server-process",60322),serverEnvironment:(0,r.register)("server-environment",60323),pass:(0,r.register)("pass",60324),issueClosed:(0,r.register)("issue-closed",60324),stopCircle:(0,r.register)("stop-circle",60325),playCircle:(0,r.register)("play-circle",60326),record:(0,r.register)("record",60327),debugAltSmall:(0,r.register)("debug-alt-small",60328),vmConnect:(0,r.register)("vm-connect",60329),cloud:(0,r.register)("cloud",60330),merge:(0,r.register)("merge",60331),export:(0,r.register)("export",60332),graphLeft:(0,r.register)("graph-left",60333),magnet:(0,r.register)("magnet",60334),notebook:(0,r.register)("notebook",60335),redo:(0,r.register)("redo",60336),checkAll:(0,r.register)("check-all",60337),pinnedDirty:(0,r.register)("pinned-dirty",60338),passFilled:(0,r.register)("pass-filled",60339),circleLargeFilled:(0,r.register)("circle-large-filled",60340),circleLarge:(0,r.register)("circle-large",60341),circleLargeOutline:(0,r.register)("circle-large-outline",60341),combine:(0,r.register)("combine",60342),gather:(0,r.register)("gather",60342),table:(0,r.register)("table",60343),variableGroup:(0,r.register)("variable-group",60344),typeHierarchy:(0,r.register)("type-hierarchy",60345),typeHierarchySub:(0,r.register)("type-hierarchy-sub",60346),typeHierarchySuper:(0,r.register)("type-hierarchy-super",60347),gitPullRequestCreate:(0,r.register)("git-pull-request-create",60348),runAbove:(0,r.register)("run-above",60349),runBelow:(0,r.register)("run-below",60350),notebookTemplate:(0,r.register)("notebook-template",60351),debugRerun:(0,r.register)("debug-rerun",60352),workspaceTrusted:(0,r.register)("workspace-trusted",60353),workspaceUntrusted:(0,r.register)("workspace-untrusted",60354),workspaceUnknown:(0,r.register)("workspace-unknown",60355),terminalCmd:(0,r.register)("terminal-cmd",60356),terminalDebian:(0,r.register)("terminal-debian",60357),terminalLinux:(0,r.register)("terminal-linux",60358),terminalPowershell:(0,r.register)("terminal-powershell",60359),terminalTmux:(0,r.register)("terminal-tmux",60360),terminalUbuntu:(0,r.register)("terminal-ubuntu",60361),terminalBash:(0,r.register)("terminal-bash",60362),arrowSwap:(0,r.register)("arrow-swap",60363),copy:(0,r.register)("copy",60364),personAdd:(0,r.register)("person-add",60365),filterFilled:(0,r.register)("filter-filled",60366),wand:(0,r.register)("wand",60367),debugLineByLine:(0,r.register)("debug-line-by-line",60368),inspect:(0,r.register)("inspect",60369),layers:(0,r.register)("layers",60370),layersDot:(0,r.register)("layers-dot",60371),layersActive:(0,r.register)("layers-active",60372),compass:(0,r.register)("compass",60373),compassDot:(0,r.register)("compass-dot",60374),compassActive:(0,r.register)("compass-active",60375),azure:(0,r.register)("azure",60376),issueDraft:(0,r.register)("issue-draft",60377),gitPullRequestClosed:(0,r.register)("git-pull-request-closed",60378),gitPullRequestDraft:(0,r.register)("git-pull-request-draft",60379),debugAll:(0,r.register)("debug-all",60380),debugCoverage:(0,r.register)("debug-coverage",60381),runErrors:(0,r.register)("run-errors",60382),folderLibrary:(0,r.register)("folder-library",60383),debugContinueSmall:(0,r.register)("debug-continue-small",60384),beakerStop:(0,r.register)("beaker-stop",60385),graphLine:(0,r.register)("graph-line",60386),graphScatter:(0,r.register)("graph-scatter",60387),pieChart:(0,r.register)("pie-chart",60388),bracket:(0,r.register)("bracket",60175),bracketDot:(0,r.register)("bracket-dot",60389),bracketError:(0,r.register)("bracket-error",60390),lockSmall:(0,r.register)("lock-small",60391),azureDevops:(0,r.register)("azure-devops",60392),verifiedFilled:(0,r.register)("verified-filled",60393),newline:(0,r.register)("newline",60394),layout:(0,r.register)("layout",60395),layoutActivitybarLeft:(0,r.register)("layout-activitybar-left",60396),layoutActivitybarRight:(0,r.register)("layout-activitybar-right",60397),layoutPanelLeft:(0,r.register)("layout-panel-left",60398),layoutPanelCenter:(0,r.register)("layout-panel-center",60399),layoutPanelJustify:(0,r.register)("layout-panel-justify",60400),layoutPanelRight:(0,r.register)("layout-panel-right",60401),layoutPanel:(0,r.register)("layout-panel",60402),layoutSidebarLeft:(0,r.register)("layout-sidebar-left",60403),layoutSidebarRight:(0,r.register)("layout-sidebar-right",60404),layoutStatusbar:(0,r.register)("layout-statusbar",60405),layoutMenubar:(0,r.register)("layout-menubar",60406),layoutCentered:(0,r.register)("layout-centered",60407),target:(0,r.register)("target",60408),indent:(0,r.register)("indent",60409),recordSmall:(0,r.register)("record-small",60410),errorSmall:(0,r.register)("error-small",60411),terminalDecorationError:(0,r.register)("terminal-decoration-error",60411),arrowCircleDown:(0,r.register)("arrow-circle-down",60412),arrowCircleLeft:(0,r.register)("arrow-circle-left",60413),arrowCircleRight:(0,r.register)("arrow-circle-right",60414),arrowCircleUp:(0,r.register)("arrow-circle-up",60415),layoutSidebarRightOff:(0,r.register)("layout-sidebar-right-off",60416),layoutPanelOff:(0,r.register)("layout-panel-off",60417),layoutSidebarLeftOff:(0,r.register)("layout-sidebar-left-off",60418),blank:(0,r.register)("blank",60419),heartFilled:(0,r.register)("heart-filled",60420),map:(0,r.register)("map",60421),mapHorizontal:(0,r.register)("map-horizontal",60421),foldHorizontal:(0,r.register)("fold-horizontal",60421),mapFilled:(0,r.register)("map-filled",60422),mapHorizontalFilled:(0,r.register)("map-horizontal-filled",60422),foldHorizontalFilled:(0,r.register)("fold-horizontal-filled",60422),circleSmall:(0,r.register)("circle-small",60423),bellSlash:(0,r.register)("bell-slash",60424),bellSlashDot:(0,r.register)("bell-slash-dot",60425),commentUnresolved:(0,r.register)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,r.register)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,r.register)("git-pull-request-new-changes",60428),searchFuzzy:(0,r.register)("search-fuzzy",60429),commentDraft:(0,r.register)("comment-draft",60430),send:(0,r.register)("send",60431),sparkle:(0,r.register)("sparkle",60432),insert:(0,r.register)("insert",60433),mic:(0,r.register)("mic",60434),thumbsdownFilled:(0,r.register)("thumbsdown-filled",60435),thumbsupFilled:(0,r.register)("thumbsup-filled",60436),coffee:(0,r.register)("coffee",60437),snake:(0,r.register)("snake",60438),game:(0,r.register)("game",60439),vr:(0,r.register)("vr",60440),chip:(0,r.register)("chip",60441),piano:(0,r.register)("piano",60442),music:(0,r.register)("music",60443),micFilled:(0,r.register)("mic-filled",60444),repoFetch:(0,r.register)("repo-fetch",60445),copilot:(0,r.register)("copilot",60446),lightbulbSparkle:(0,r.register)("lightbulb-sparkle",60447),robot:(0,r.register)("robot",60448),sparkleFilled:(0,r.register)("sparkle-filled",60449),diffSingle:(0,r.register)("diff-single",60450),diffMultiple:(0,r.register)("diff-multiple",60451),surroundWith:(0,r.register)("surround-with",60452),share:(0,r.register)("share",60453),gitStash:(0,r.register)("git-stash",60454),gitStashApply:(0,r.register)("git-stash-apply",60455),gitStashPop:(0,r.register)("git-stash-pop",60456),vscode:(0,r.register)("vscode",60457),vscodeInsiders:(0,r.register)("vscode-insiders",60458),codeOss:(0,r.register)("code-oss",60459),runCoverage:(0,r.register)("run-coverage",60460),runAllCoverage:(0,r.register)("run-all-coverage",60461),coverage:(0,r.register)("coverage",60462),githubProject:(0,r.register)("github-project",60463),mapVertical:(0,r.register)("map-vertical",60464),foldVertical:(0,r.register)("fold-vertical",60464),mapVerticalFilled:(0,r.register)("map-vertical-filled",60465),foldVerticalFilled:(0,r.register)("fold-vertical-filled",60465),goToSearch:(0,r.register)("go-to-search",60466),percentage:(0,r.register)("percentage",60467),sortPercentage:(0,r.register)("sort-percentage",60467),attach:(0,r.register)("attach",60468)}}),Y(J[44],Z([0,1,26,43]),function(W,n,r,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Codicon=n.codiconsDerived=void 0,n.codiconsDerived={dialogError:(0,r.register)("dialog-error","error"),dialogWarning:(0,r.register)("dialog-warning","warning"),dialogInfo:(0,r.register)("dialog-info","info"),dialogClose:(0,r.register)("dialog-close","close"),treeItemExpanded:(0,r.register)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,r.register)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,r.register)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,r.register)("tree-filter-clear","close"),treeItemLoading:(0,r.register)("tree-item-loading","loading"),menuSelection:(0,r.register)("menu-selection","check"),menuSubmenu:(0,r.register)("menu-submenu","chevron-right"),menuBarMore:(0,r.register)("menubar-more","more"),scrollbarButtonLeft:(0,r.register)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,r.register)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,r.register)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,r.register)("scrollbar-button-down","triangle-down"),toolBarMore:(0,r.register)("toolbar-more","more"),quickInputBack:(0,r.register)("quick-input-back","arrow-left"),dropDownButton:(0,r.register)("drop-down-button",60084),symbolCustomColor:(0,r.register)("symbol-customcolor",60252),exportIcon:(0,r.register)("export",60332),workspaceUnspecified:(0,r.register)("workspace-unspecified",60355),newLine:(0,r.register)("newline",60394),thumbsDownFilled:(0,r.register)("thumbsdown-filled",60435),thumbsUpFilled:(0,r.register)("thumbsup-filled",60436),gitFetch:(0,r.register)("git-fetch",60445),lightbulbSparkleAutofix:(0,r.register)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,r.register)("debug-breakpoint-pending",60377)},n.Codicon={...D.codiconsLibrary,...n.codiconsDerived}}),Y(J[15],Z([0,1,25]),function(W,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.deepClone=D,n.deepFreeze=A,n.cloneAndChange=h,n.mixin=l,n.equals=a,n.getAllPropertyNames=g,n.getAllMethodNames=e,n.createProxyObject=c;function D(i){if(!i||typeof i!="object"||i instanceof RegExp)return i;const u=Array.isArray(i)?[]:{};return Object.entries(i).forEach(([d,f])=>{u[d]=f&&typeof f=="object"?D(f):f}),u}function A(i){if(!i||typeof i!="object")return i;const u=[i];for(;u.length>0;){const d=u.shift();Object.freeze(d);for(const f in d)if(m.call(d,f)){const C=d[f];typeof C=="object"&&!Object.isFrozen(C)&&!(0,r.isTypedArray)(C)&&u.push(C)}}return i}const m=Object.prototype.hasOwnProperty;function h(i,u){return v(i,u,new Set)}function v(i,u,d){if((0,r.isUndefinedOrNull)(i))return i;const f=u(i);if(typeof f<"u")return f;if(Array.isArray(i)){const C=[];for(const _ of i)C.push(v(_,u,d));return C}if((0,r.isObject)(i)){if(d.has(i))throw new Error("Cannot clone recursive data-structure");d.add(i);const C={};for(const _ in i)m.call(i,_)&&(C[_]=v(i[_],u,d));return d.delete(i),C}return i}function l(i,u,d=!0){return(0,r.isObject)(i)?((0,r.isObject)(u)&&Object.keys(u).forEach(f=>{f in i?d&&((0,r.isObject)(i[f])&&(0,r.isObject)(u[f])?l(i[f],u[f],d):i[f]=u[f]):i[f]=u[f]}),i):u}function a(i,u){if(i===u)return!0;if(i==null||u===null||u===void 0||typeof i!=typeof u||typeof i!="object"||Array.isArray(i)!==Array.isArray(u))return!1;let d,f;if(Array.isArray(i)){if(i.length!==u.length)return!1;for(d=0;d<i.length;d++)if(!a(i[d],u[d]))return!1}else{const C=[];for(f in i)C.push(f);C.sort();const _=[];for(f in u)_.push(f);if(_.sort(),!a(C,_))return!1;for(d=0;d<C.length;d++)if(!a(i[C[d]],u[C[d]]))return!1}return!0}function g(i){let u=[];for(;Object.prototype!==i;)u=u.concat(Object.getOwnPropertyNames(i)),i=Object.getPrototypeOf(i);return u}function e(i){const u=[];for(const d of g(i))typeof i[d]=="function"&&u.push(d);return u}function c(i,u){const d=C=>function(){const _=Array.prototype.slice.call(arguments,0);return u(C,_)},f={};for(const C of i)f[C]=d(C);return f}}),Y(J[27],Z([0,1]),function(W,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint8=r,n.toUint32=D;function r(A){return A<0?0:A>255?255:A|0}function D(A){return A<0?0:A>4294967295?4294967295:A|0}}),Y(J[16],Z([0,1,40,14]),function(W,n,r,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.URI=void 0,n.uriToFsPath=S;const A=/^\w[\w\d+.-]*$/,m=/^\//,h=/^\/\//;function v(o,p){if(!o.scheme&&p)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!A.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!m.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(h.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function l(o,p){return!o&&!p?"file":o}function a(o,p){switch(o){case"https":case"http":case"file":p?p[0]!==e&&(p=e+p):p=e;break}return p}const g="",e="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class i{static isUri(p){return p instanceof i?!0:p?typeof p.authority=="string"&&typeof p.fragment=="string"&&typeof p.path=="string"&&typeof p.query=="string"&&typeof p.scheme=="string"&&typeof p.fsPath=="string"&&typeof p.with=="function"&&typeof p.toString=="function":!1}constructor(p,w,N,y,E,R=!1){typeof p=="object"?(this.scheme=p.scheme||g,this.authority=p.authority||g,this.path=p.path||g,this.query=p.query||g,this.fragment=p.fragment||g):(this.scheme=l(p,R),this.authority=w||g,this.path=a(this.scheme,N||g),this.query=y||g,this.fragment=E||g,v(this,R))}get fsPath(){return S(this,!1)}with(p){if(!p)return this;let{scheme:w,authority:N,path:y,query:E,fragment:R}=p;return w===void 0?w=this.scheme:w===null&&(w=g),N===void 0?N=this.authority:N===null&&(N=g),y===void 0?y=this.path:y===null&&(y=g),E===void 0?E=this.query:E===null&&(E=g),R===void 0?R=this.fragment:R===null&&(R=g),w===this.scheme&&N===this.authority&&y===this.path&&E===this.query&&R===this.fragment?this:new d(w,N,y,E,R)}static parse(p,w=!1){const N=c.exec(p);return N?new d(N[2]||g,s(N[4]||g),s(N[5]||g),s(N[7]||g),s(N[9]||g),w):new d(g,g,g,g,g)}static file(p){let w=g;if(D.isWindows&&(p=p.replace(/\\/g,e)),p[0]===e&&p[1]===e){const N=p.indexOf(e,2);N===-1?(w=p.substring(2),p=e):(w=p.substring(2,N),p=p.substring(N)||e)}return new d("file",w,p,g,g)}static from(p,w){return new d(p.scheme,p.authority,p.path,p.query,p.fragment,w)}static joinPath(p,...w){if(!p.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let N;return D.isWindows&&p.scheme==="file"?N=i.file(r.win32.join(S(p,!0),...w)).path:N=r.posix.join(p.path,...w),p.with({path:N})}toString(p=!1){return M(this,p)}toJSON(){return this}static revive(p){var w,N;if(p){if(p instanceof i)return p;{const y=new d(p);return y._formatted=(w=p.external)!==null&&w!==void 0?w:null,y._fsPath=p._sep===u&&(N=p.fsPath)!==null&&N!==void 0?N:null,y}}else return p}}n.URI=i;const u=D.isWindows?1:void 0;class d extends i{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=S(this,!1)),this._fsPath}toString(p=!1){return p?M(this,!0):(this._formatted||(this._formatted=M(this,!1)),this._formatted)}toJSON(){const p={$mid:1};return this._fsPath&&(p.fsPath=this._fsPath,p._sep=u),this._formatted&&(p.external=this._formatted),this.path&&(p.path=this.path),this.scheme&&(p.scheme=this.scheme),this.authority&&(p.authority=this.authority),this.query&&(p.query=this.query),this.fragment&&(p.fragment=this.fragment),p}}const f={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function C(o,p,w){let N,y=-1;for(let E=0;E<o.length;E++){const R=o.charCodeAt(E);if(R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57||R===45||R===46||R===95||R===126||p&&R===47||w&&R===91||w&&R===93||w&&R===58)y!==-1&&(N+=encodeURIComponent(o.substring(y,E)),y=-1),N!==void 0&&(N+=o.charAt(E));else{N===void 0&&(N=o.substr(0,E));const x=f[R];x!==void 0?(y!==-1&&(N+=encodeURIComponent(o.substring(y,E)),y=-1),N+=x):y===-1&&(y=E)}}return y!==-1&&(N+=encodeURIComponent(o.substring(y))),N!==void 0?N:o}function _(o){let p;for(let w=0;w<o.length;w++){const N=o.charCodeAt(w);N===35||N===63?(p===void 0&&(p=o.substr(0,w)),p+=f[N]):p!==void 0&&(p+=o[w])}return p!==void 0?p:o}function S(o,p){let w;return o.authority&&o.path.length>1&&o.scheme==="file"?w=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?p?w=o.path.substr(1):w=o.path[1].toLowerCase()+o.path.substr(2):w=o.path,D.isWindows&&(w=w.replace(/\//g,"\\")),w}function M(o,p){const w=p?_:C;let N="",{scheme:y,authority:E,path:R,query:x,fragment:P}=o;if(y&&(N+=y,N+=":"),(E||y==="file")&&(N+=e,N+=e),E){let F=E.indexOf("@");if(F!==-1){const I=E.substr(0,F);E=E.substr(F+1),F=I.lastIndexOf(":"),F===-1?N+=w(I,!1,!1):(N+=w(I.substr(0,F),!1,!1),N+=":",N+=w(I.substr(F+1),!1,!0)),N+="@"}E=E.toLowerCase(),F=E.lastIndexOf(":"),F===-1?N+=w(E,!1,!0):(N+=w(E.substr(0,F),!1,!0),N+=E.substr(F))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const F=R.charCodeAt(1);F>=65&&F<=90&&(R=`/${String.fromCharCode(F+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const F=R.charCodeAt(0);F>=65&&F<=90&&(R=`${String.fromCharCode(F+32)}:${R.substr(2)}`)}N+=w(R,!0,!1)}return x&&(N+="?",N+=w(x,!1,!1)),P&&(N+="#",N+=p?P:C(P,!1,!1)),N}function L(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+L(o.substr(3)):o}}const b=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(o){return o.match(b)?o.replace(b,p=>L(p)):o}}),Y(J[70],Z([0,1,5,10,13,15,14,6]),function(W,n,r,D,A,m,h,v){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.SimpleWorkerServer=n.SimpleWorkerClient=void 0,n.logOnceWebWorkerWarning=g,n.create=b;const l="$initialize";let a=!1;function g(s){h.isWeb&&(a||(a=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(s.message))}class e{constructor(o,p,w,N){this.vsWorker=o,this.req=p,this.method=w,this.args=N,this.type=0}}class c{constructor(o,p,w,N){this.vsWorker=o,this.seq=p,this.res=w,this.err=N,this.type=1}}class i{constructor(o,p,w,N){this.vsWorker=o,this.req=p,this.eventName=w,this.arg=N,this.type=2}}class u{constructor(o,p,w){this.vsWorker=o,this.req=p,this.event=w,this.type=3}}class d{constructor(o,p){this.vsWorker=o,this.req=p,this.type=4}}class f{constructor(o){this._workerId=-1,this._handler=o,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(o){this._workerId=o}sendMessage(o,p){const w=String(++this._lastSentReq);return new Promise((N,y)=>{this._pendingReplies[w]={resolve:N,reject:y},this._send(new e(this._workerId,w,o,p))})}listen(o,p){let w=null;const N=new D.Emitter({onWillAddFirstListener:()=>{w=String(++this._lastSentReq),this._pendingEmitters.set(w,N),this._send(new i(this._workerId,w,o,p))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(w),this._send(new d(this._workerId,w)),w=null}});return N.event}handleMessage(o){!o||!o.vsWorker||this._workerId!==-1&&o.vsWorker!==this._workerId||this._handleMessage(o)}_handleMessage(o){switch(o.type){case 1:return this._handleReplyMessage(o);case 0:return this._handleRequestMessage(o);case 2:return this._handleSubscribeEventMessage(o);case 3:return this._handleEventMessage(o);case 4:return this._handleUnsubscribeEventMessage(o)}}_handleReplyMessage(o){if(!this._pendingReplies[o.seq]){console.warn("Got reply to unknown seq");return}const p=this._pendingReplies[o.seq];if(delete this._pendingReplies[o.seq],o.err){let w=o.err;o.err.$isError&&(w=new Error,w.name=o.err.name,w.message=o.err.message,w.stack=o.err.stack),p.reject(w);return}p.resolve(o.res)}_handleRequestMessage(o){const p=o.req;this._handler.handleMessage(o.method,o.args).then(N=>{this._send(new c(this._workerId,p,N,void 0))},N=>{N.detail instanceof Error&&(N.detail=(0,r.transformErrorForSerialization)(N.detail)),this._send(new c(this._workerId,p,void 0,(0,r.transformErrorForSerialization)(N)))})}_handleSubscribeEventMessage(o){const p=o.req,w=this._handler.handleEvent(o.eventName,o.arg)(N=>{this._send(new u(this._workerId,p,N))});this._pendingEvents.set(p,w)}_handleEventMessage(o){if(!this._pendingEmitters.has(o.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(o.req).fire(o.event)}_handleUnsubscribeEventMessage(o){if(!this._pendingEvents.has(o.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(o.req).dispose(),this._pendingEvents.delete(o.req)}_send(o){const p=[];if(o.type===0)for(let w=0;w<o.args.length;w++)o.args[w]instanceof ArrayBuffer&&p.push(o.args[w]);else o.type===1&&o.res instanceof ArrayBuffer&&p.push(o.res);this._handler.sendMessage(o,p)}}class C extends A.Disposable{constructor(o,p,w){super();let N=null;this._worker=this._register(o.create("vs/base/common/worker/simpleWorker",F=>{this._protocol.handleMessage(F)},F=>{N?.(F)})),this._protocol=new f({sendMessage:(F,I)=>{this._worker.postMessage(F,I)},handleMessage:(F,I)=>{if(typeof w[F]!="function")return Promise.reject(new Error("Missing method "+F+" on main thread host."));try{return Promise.resolve(w[F].apply(w,I))}catch(V){return Promise.reject(V)}},handleEvent:(F,I)=>{if(S(F)){const V=w[F].call(w,I);if(typeof V!="function")throw new Error(`Missing dynamic event ${F} on main thread host.`);return V}if(_(F)){const V=w[F];if(typeof V!="function")throw new Error(`Missing event ${F} on main thread host.`);return V}throw new Error(`Malformed event name ${F}`)}}),this._protocol.setWorkerId(this._worker.getId());let y=null;const E=globalThis.require;typeof E<"u"&&typeof E.getConfig=="function"?y=E.getConfig():typeof globalThis.requirejs<"u"&&(y=globalThis.requirejs.s.contexts._.config);const R=(0,m.getAllMethodNames)(w);this._onModuleLoaded=this._protocol.sendMessage(l,[this._worker.getId(),JSON.parse(JSON.stringify(y)),p,R]);const x=(F,I)=>this._request(F,I),P=(F,I)=>this._protocol.listen(F,I);this._lazyProxy=new Promise((F,I)=>{N=I,this._onModuleLoaded.then(V=>{F(M(V,x,P))},V=>{I(V),this._onError("Worker failed to load "+p,V)})})}getProxyObject(){return this._lazyProxy}_request(o,p){return new Promise((w,N)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(o,p).then(w,N)},N)})}_onError(o,p){console.error(o),console.info(p)}}n.SimpleWorkerClient=C;function _(s){return s[0]==="o"&&s[1]==="n"&&v.isUpperAsciiLetter(s.charCodeAt(2))}function S(s){return/^onDynamic/.test(s)&&v.isUpperAsciiLetter(s.charCodeAt(9))}function M(s,o,p){const w=E=>function(){const R=Array.prototype.slice.call(arguments,0);return o(E,R)},N=E=>function(R){return p(E,R)},y={};for(const E of s){if(S(E)){y[E]=N(E);continue}if(_(E)){y[E]=p(E,void 0);continue}y[E]=w(E)}return y}class L{constructor(o,p){this._requestHandlerFactory=p,this._requestHandler=null,this._protocol=new f({sendMessage:(w,N)=>{o(w,N)},handleMessage:(w,N)=>this._handleMessage(w,N),handleEvent:(w,N)=>this._handleEvent(w,N)})}onmessage(o){this._protocol.handleMessage(o)}_handleMessage(o,p){if(o===l)return this.initialize(p[0],p[1],p[2],p[3]);if(!this._requestHandler||typeof this._requestHandler[o]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+o));try{return Promise.resolve(this._requestHandler[o].apply(this._requestHandler,p))}catch(w){return Promise.reject(w)}}_handleEvent(o,p){if(!this._requestHandler)throw new Error("Missing requestHandler");if(S(o)){const w=this._requestHandler[o].call(this._requestHandler,p);if(typeof w!="function")throw new Error(`Missing dynamic event ${o} on request handler.`);return w}if(_(o)){const w=this._requestHandler[o];if(typeof w!="function")throw new Error(`Missing event ${o} on request handler.`);return w}throw new Error(`Malformed event name ${o}`)}initialize(o,p,w,N){this._protocol.setWorkerId(o);const R=M(N,(x,P)=>this._protocol.sendMessage(x,P),(x,P)=>this._protocol.listen(x,P));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(R),Promise.resolve((0,m.getAllMethodNames)(this._requestHandler))):(p&&(typeof p.baseUrl<"u"&&delete p.baseUrl,typeof p.paths<"u"&&typeof p.paths.vs<"u"&&delete p.paths.vs,typeof p.trustedTypesPolicy<"u"&&delete p.trustedTypesPolicy,p.catchError=!0,globalThis.require.config(p)),new Promise((x,P)=>{(globalThis.require||W)([w],I=>{if(this._requestHandler=I.create(R),!this._requestHandler){P(new Error("No RequestHandler!"));return}x((0,m.getAllMethodNames)(this._requestHandler))},P)}))}}n.SimpleWorkerServer=L;function b(s){return new L(s,null)}}),Y(J[28],Z([0,1,27]),function(W,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class D{constructor(h){const v=(0,r.toUint8)(h);this._defaultValue=v,this._asciiMap=D._createAsciiMap(v),this._map=new Map}static _createAsciiMap(h){const v=new Uint8Array(256);return v.fill(h),v}set(h,v){const l=(0,r.toUint8)(v);h>=0&&h<256?this._asciiMap[h]=l:this._map.set(h,l)}get(h){return h>=0&&h<256?this._asciiMap[h]:this._map.get(h)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}n.CharacterClassifier=D;class A{constructor(){this._actual=new D(0)}add(h){this._actual.set(h,1)}has(h){return this._actual.get(h)===1}clear(){return this._actual.clear()}}n.CharacterSet=A}),Y(J[3],Z([0,1,5]),function(W,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.OffsetRangeSet=n.OffsetRange=void 0;class D{static addRange(h,v){let l=0;for(;l<v.length&&v[l].endExclusive<h.start;)l++;let a=l;for(;a<v.length&&v[a].start<=h.endExclusive;)a++;if(l===a)v.splice(l,0,h);else{const g=Math.min(h.start,v[l].start),e=Math.max(h.endExclusive,v[a-1].endExclusive);v.splice(l,a-l,new D(g,e))}}static tryCreate(h,v){if(!(h>v))return new D(h,v)}static ofLength(h){return new D(0,h)}static ofStartAndLength(h,v){return new D(h,h+v)}constructor(h,v){if(this.start=h,this.endExclusive=v,h>v)throw new r.BugIndicatingError(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(h){return new D(this.start+h,this.endExclusive+h)}deltaStart(h){return new D(this.start+h,this.endExclusive)}deltaEnd(h){return new D(this.start,this.endExclusive+h)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}contains(h){return this.start<=h&&h<this.endExclusive}join(h){return new D(Math.min(this.start,h.start),Math.max(this.endExclusive,h.endExclusive))}intersect(h){const v=Math.max(this.start,h.start),l=Math.min(this.endExclusive,h.endExclusive);if(v<=l)return new D(v,l)}intersects(h){const v=Math.max(this.start,h.start),l=Math.min(this.endExclusive,h.endExclusive);return v<l}isBefore(h){return this.endExclusive<=h.start}isAfter(h){return this.start>=h.endExclusive}slice(h){return h.slice(this.start,this.endExclusive)}substring(h){return h.substring(this.start,this.endExclusive)}clip(h){if(this.isEmpty)throw new r.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,h))}clipCyclic(h){if(this.isEmpty)throw new r.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return h<this.start?this.endExclusive-(this.start-h)%this.length:h>=this.endExclusive?this.start+(h-this.start)%this.length:h}forEach(h){for(let v=this.start;v<this.endExclusive;v++)h(v)}}n.OffsetRange=D;class A{constructor(){this._sortedRanges=[]}addRange(h){let v=0;for(;v<this._sortedRanges.length&&this._sortedRanges[v].endExclusive<h.start;)v++;let l=v;for(;l<this._sortedRanges.length&&this._sortedRanges[l].start<=h.endExclusive;)l++;if(v===l)this._sortedRanges.splice(v,0,h);else{const a=Math.min(h.start,this._sortedRanges[v].start),g=Math.max(h.endExclusive,this._sortedRanges[l-1].endExclusive);this._sortedRanges.splice(v,l-v,new D(a,g))}}toString(){return this._sortedRanges.map(h=>h.toString()).join(", ")}intersectsStrict(h){let v=0;for(;v<this._sortedRanges.length&&this._sortedRanges[v].endExclusive<=h.start;)v++;return v<this._sortedRanges.length&&this._sortedRanges[v].start<h.endExclusive}intersectWithRange(h){const v=new A;for(const l of this._sortedRanges){const a=l.intersect(h);a&&v.addRange(a)}return v}intersectWithRangeLength(h){return this.intersectWithRange(h).length}get length(){return this._sortedRanges.reduce((h,v)=>h+v.length,0)}}n.OffsetRangeSet=A}),Y(J[4],Z([0,1]),function(W,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class r{constructor(A,m){this.lineNumber=A,this.column=m}with(A=this.lineNumber,m=this.column){return A===this.lineNumber&&m===this.column?this:new r(A,m)}delta(A=0,m=0){return this.with(this.lineNumber+A,this.column+m)}equals(A){return r.equals(this,A)}static equals(A,m){return!A&&!m?!0:!!A&&!!m&&A.lineNumber===m.lineNumber&&A.column===m.column}isBefore(A){return r.isBefore(this,A)}static isBefore(A,m){return A.lineNumber<m.lineNumber?!0:m.lineNumber<A.lineNumber?!1:A.column<m.column}isBeforeOrEqual(A){return r.isBeforeOrEqual(this,A)}static isBeforeOrEqual(A,m){return A.lineNumber<m.lineNumber?!0:m.lineNumber<A.lineNumber?!1:A.column<=m.column}static compare(A,m){const h=A.lineNumber|0,v=m.lineNumber|0;if(h===v){const l=A.column|0,a=m.column|0;return l-a}return h-v}clone(){return new r(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(A){return new r(A.lineNumber,A.column)}static isIPosition(A){return A&&typeof A.lineNumber=="number"&&typeof A.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}n.Position=r}),Y(J[2],Z([0,1,4]),function(W,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class D{constructor(m,h,v,l){m>v||m===v&&h>l?(this.startLineNumber=v,this.startColumn=l,this.endLineNumber=m,this.endColumn=h):(this.startLineNumber=m,this.startColumn=h,this.endLineNumber=v,this.endColumn=l)}isEmpty(){return D.isEmpty(this)}static isEmpty(m){return m.startLineNumber===m.endLineNumber&&m.startColumn===m.endColumn}containsPosition(m){return D.containsPosition(this,m)}static containsPosition(m,h){return!(h.lineNumber<m.startLineNumber||h.lineNumber>m.endLineNumber||h.lineNumber===m.startLineNumber&&h.column<m.startColumn||h.lineNumber===m.endLineNumber&&h.column>m.endColumn)}static strictContainsPosition(m,h){return!(h.lineNumber<m.startLineNumber||h.lineNumber>m.endLineNumber||h.lineNumber===m.startLineNumber&&h.column<=m.startColumn||h.lineNumber===m.endLineNumber&&h.column>=m.endColumn)}containsRange(m){return D.containsRange(this,m)}static containsRange(m,h){return!(h.startLineNumber<m.startLineNumber||h.endLineNumber<m.startLineNumber||h.startLineNumber>m.endLineNumber||h.endLineNumber>m.endLineNumber||h.startLineNumber===m.startLineNumber&&h.startColumn<m.startColumn||h.endLineNumber===m.endLineNumber&&h.endColumn>m.endColumn)}strictContainsRange(m){return D.strictContainsRange(this,m)}static strictContainsRange(m,h){return!(h.startLineNumber<m.startLineNumber||h.endLineNumber<m.startLineNumber||h.startLineNumber>m.endLineNumber||h.endLineNumber>m.endLineNumber||h.startLineNumber===m.startLineNumber&&h.startColumn<=m.startColumn||h.endLineNumber===m.endLineNumber&&h.endColumn>=m.endColumn)}plusRange(m){return D.plusRange(this,m)}static plusRange(m,h){let v,l,a,g;return h.startLineNumber<m.startLineNumber?(v=h.startLineNumber,l=h.startColumn):h.startLineNumber===m.startLineNumber?(v=h.startLineNumber,l=Math.min(h.startColumn,m.startColumn)):(v=m.startLineNumber,l=m.startColumn),h.endLineNumber>m.endLineNumber?(a=h.endLineNumber,g=h.endColumn):h.endLineNumber===m.endLineNumber?(a=h.endLineNumber,g=Math.max(h.endColumn,m.endColumn)):(a=m.endLineNumber,g=m.endColumn),new D(v,l,a,g)}intersectRanges(m){return D.intersectRanges(this,m)}static intersectRanges(m,h){let v=m.startLineNumber,l=m.startColumn,a=m.endLineNumber,g=m.endColumn;const e=h.startLineNumber,c=h.startColumn,i=h.endLineNumber,u=h.endColumn;return v<e?(v=e,l=c):v===e&&(l=Math.max(l,c)),a>i?(a=i,g=u):a===i&&(g=Math.min(g,u)),v>a||v===a&&l>g?null:new D(v,l,a,g)}equalsRange(m){return D.equalsRange(this,m)}static equalsRange(m,h){return!m&&!h?!0:!!m&&!!h&&m.startLineNumber===h.startLineNumber&&m.startColumn===h.startColumn&&m.endLineNumber===h.endLineNumber&&m.endColumn===h.endColumn}getEndPosition(){return D.getEndPosition(this)}static getEndPosition(m){return new r.Position(m.endLineNumber,m.endColumn)}getStartPosition(){return D.getStartPosition(this)}static getStartPosition(m){return new r.Position(m.startLineNumber,m.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(m,h){return new D(this.startLineNumber,this.startColumn,m,h)}setStartPosition(m,h){return new D(m,h,this.endLineNumber,this.endColumn)}collapseToStart(){return D.collapseToStart(this)}static collapseToStart(m){return new D(m.startLineNumber,m.startColumn,m.startLineNumber,m.startColumn)}collapseToEnd(){return D.collapseToEnd(this)}static collapseToEnd(m){return new D(m.endLineNumber,m.endColumn,m.endLineNumber,m.endColumn)}delta(m){return new D(this.startLineNumber+m,this.startColumn,this.endLineNumber+m,this.endColumn)}static fromPositions(m,h=m){return new D(m.lineNumber,m.column,h.lineNumber,h.column)}static lift(m){return m?new D(m.startLineNumber,m.startColumn,m.endLineNumber,m.endColumn):null}static isIRange(m){return m&&typeof m.startLineNumber=="number"&&typeof m.startColumn=="number"&&typeof m.endLineNumber=="number"&&typeof m.endColumn=="number"}static areIntersectingOrTouching(m,h){return!(m.endLineNumber<h.startLineNumber||m.endLineNumber===h.startLineNumber&&m.endColumn<h.startColumn||h.endLineNumber<m.startLineNumber||h.endLineNumber===m.startLineNumber&&h.endColumn<m.startColumn)}static areIntersecting(m,h){return!(m.endLineNumber<h.startLineNumber||m.endLineNumber===h.startLineNumber&&m.endColumn<=h.startColumn||h.endLineNumber<m.startLineNumber||h.endLineNumber===m.startLineNumber&&h.endColumn<=m.startColumn)}static compareRangesUsingStarts(m,h){if(m&&h){const a=m.startLineNumber|0,g=h.startLineNumber|0;if(a===g){const e=m.startColumn|0,c=h.startColumn|0;if(e===c){const i=m.endLineNumber|0,u=h.endLineNumber|0;if(i===u){const d=m.endColumn|0,f=h.endColumn|0;return d-f}return i-u}return e-c}return a-g}return(m?1:0)-(h?1:0)}static compareRangesUsingEnds(m,h){return m.endLineNumber===h.endLineNumber?m.endColumn===h.endColumn?m.startLineNumber===h.startLineNumber?m.startColumn-h.startColumn:m.startLineNumber-h.startLineNumber:m.endColumn-h.endColumn:m.endLineNumber-h.endLineNumber}static spansMultipleLines(m){return m.endLineNumber>m.startLineNumber}toJSON(){return this}}n.Range=D}),Y(J[11],Z([0,1,5,3,2,12]),function(W,n,r,D,A,m){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineRangeSet=n.LineRange=void 0;class h{static fromRangeInclusive(a){return new h(a.startLineNumber,a.endLineNumber+1)}static joinMany(a){if(a.length===0)return[];let g=new v(a[0].slice());for(let e=1;e<a.length;e++)g=g.getUnion(new v(a[e].slice()));return g.ranges}static join(a){if(a.length===0)throw new r.BugIndicatingError("lineRanges cannot be empty");let g=a[0].startLineNumber,e=a[0].endLineNumberExclusive;for(let c=1;c<a.length;c++)g=Math.min(g,a[c].startLineNumber),e=Math.max(e,a[c].endLineNumberExclusive);return new h(g,e)}static ofLength(a,g){return new h(a,a+g)}static deserialize(a){return new h(a[0],a[1])}constructor(a,g){if(a>g)throw new r.BugIndicatingError(`startLineNumber ${a} cannot be after endLineNumberExclusive ${g}`);this.startLineNumber=a,this.endLineNumberExclusive=g}contains(a){return this.startLineNumber<=a&&a<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(a){return new h(this.startLineNumber+a,this.endLineNumberExclusive+a)}deltaLength(a){return new h(this.startLineNumber,this.endLineNumberExclusive+a)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(a){return new h(Math.min(this.startLineNumber,a.startLineNumber),Math.max(this.endLineNumberExclusive,a.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(a){const g=Math.max(this.startLineNumber,a.startLineNumber),e=Math.min(this.endLineNumberExclusive,a.endLineNumberExclusive);if(g<=e)return new h(g,e)}intersectsStrict(a){return this.startLineNumber<a.endLineNumberExclusive&&a.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(a){return this.startLineNumber<=a.endLineNumberExclusive&&a.startLineNumber<=this.endLineNumberExclusive}equals(a){return this.startLineNumber===a.startLineNumber&&this.endLineNumberExclusive===a.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new A.Range(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new A.Range(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(a){const g=[];for(let e=this.startLineNumber;e<this.endLineNumberExclusive;e++)g.push(a(e));return g}forEach(a){for(let g=this.startLineNumber;g<this.endLineNumberExclusive;g++)a(g)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(a){return this.startLineNumber<=a&&a<this.endLineNumberExclusive}toOffsetRange(){return new D.OffsetRange(this.startLineNumber-1,this.endLineNumberExclusive-1)}}n.LineRange=h;class v{constructor(a=[]){this._normalizedRanges=a}get ranges(){return this._normalizedRanges}addRange(a){if(a.length===0)return;const g=(0,m.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,c=>c.endLineNumberExclusive>=a.startLineNumber),e=(0,m.findLastIdxMonotonous)(this._normalizedRanges,c=>c.startLineNumber<=a.endLineNumberExclusive)+1;if(g===e)this._normalizedRanges.splice(g,0,a);else if(g===e-1){const c=this._normalizedRanges[g];this._normalizedRanges[g]=c.join(a)}else{const c=this._normalizedRanges[g].join(this._normalizedRanges[e-1]).join(a);this._normalizedRanges.splice(g,e-g,c)}}contains(a){const g=(0,m.findLastMonotonous)(this._normalizedRanges,e=>e.startLineNumber<=a);return!!g&&g.endLineNumberExclusive>a}intersects(a){const g=(0,m.findLastMonotonous)(this._normalizedRanges,e=>e.startLineNumber<a.endLineNumberExclusive);return!!g&&g.endLineNumberExclusive>a.startLineNumber}getUnion(a){if(this._normalizedRanges.length===0)return a;if(a._normalizedRanges.length===0)return this;const g=[];let e=0,c=0,i=null;for(;e<this._normalizedRanges.length||c<a._normalizedRanges.length;){let u=null;if(e<this._normalizedRanges.length&&c<a._normalizedRanges.length){const d=this._normalizedRanges[e],f=a._normalizedRanges[c];d.startLineNumber<f.startLineNumber?(u=d,e++):(u=f,c++)}else e<this._normalizedRanges.length?(u=this._normalizedRanges[e],e++):(u=a._normalizedRanges[c],c++);i===null?i=u:i.endLineNumberExclusive>=u.startLineNumber?i=new h(i.startLineNumber,Math.max(i.endLineNumberExclusive,u.endLineNumberExclusive)):(g.push(i),i=u)}return i!==null&&g.push(i),new v(g)}subtractFrom(a){const g=(0,m.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,u=>u.endLineNumberExclusive>=a.startLineNumber),e=(0,m.findLastIdxMonotonous)(this._normalizedRanges,u=>u.startLineNumber<=a.endLineNumberExclusive)+1;if(g===e)return new v([a]);const c=[];let i=a.startLineNumber;for(let u=g;u<e;u++){const d=this._normalizedRanges[u];d.startLineNumber>i&&c.push(new h(i,d.startLineNumber)),i=d.endLineNumberExclusive}return i<a.endLineNumberExclusive&&c.push(new h(i,a.endLineNumberExclusive)),new v(c)}toString(){return this._normalizedRanges.map(a=>a.toString()).join(", ")}getIntersection(a){const g=[];let e=0,c=0;for(;e<this._normalizedRanges.length&&c<a._normalizedRanges.length;){const i=this._normalizedRanges[e],u=a._normalizedRanges[c],d=i.intersect(u);d&&!d.isEmpty&&g.push(d),i.endLineNumberExclusive<u.endLineNumberExclusive?e++:c++}return new v(g)}getWithDelta(a){return new v(this._normalizedRanges.map(g=>g.delta(a)))}}n.LineRangeSet=v}),Y(J[45],Z([0,1,4,2]),function(W,n,r,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=void 0;class A extends D.Range{constructor(h,v,l,a){super(h,v,l,a),this.selectionStartLineNumber=h,this.selectionStartColumn=v,this.positionLineNumber=l,this.positionColumn=a}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(h){return A.selectionsEqual(this,h)}static selectionsEqual(h,v){return h.selectionStartLineNumber===v.selectionStartLineNumber&&h.selectionStartColumn===v.selectionStartColumn&&h.positionLineNumber===v.positionLineNumber&&h.positionColumn===v.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(h,v){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,h,v):new A(h,v,this.startLineNumber,this.startColumn)}getPosition(){return new r.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new r.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(h,v){return this.getDirection()===0?new A(h,v,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,h,v)}static fromPositions(h,v=h){return new A(h.lineNumber,h.column,v.lineNumber,v.column)}static fromRange(h,v){return v===0?new A(h.startLineNumber,h.startColumn,h.endLineNumber,h.endColumn):new A(h.endLineNumber,h.endColumn,h.startLineNumber,h.startColumn)}static liftSelection(h){return new A(h.selectionStartLineNumber,h.selectionStartColumn,h.positionLineNumber,h.positionColumn)}static selectionsArrEqual(h,v){if(h&&!v||!h&&v)return!1;if(!h&&!v)return!0;if(h.length!==v.length)return!1;for(let l=0,a=h.length;l<a;l++)if(!this.selectionsEqual(h[l],v[l]))return!1;return!0}static isISelection(h){return h&&typeof h.selectionStartLineNumber=="number"&&typeof h.selectionStartColumn=="number"&&typeof h.positionLineNumber=="number"&&typeof h.positionColumn=="number"}static createWithDirection(h,v,l,a,g){return g===0?new A(h,v,l,a):new A(l,a,h,v)}}n.Selection=A}),Y(J[29],Z([0,1,4,2]),function(W,n,r,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TextLength=void 0;class A{static betweenPositions(h,v){return h.lineNumber===v.lineNumber?new A(0,v.column-h.column):new A(v.lineNumber-h.lineNumber,v.column-1)}static ofRange(h){return A.betweenPositions(h.getStartPosition(),h.getEndPosition())}static ofText(h){let v=0,l=0;for(const a of h)a===`
`?(v++,l=0):l++;return new A(v,l)}constructor(h,v){this.lineCount=h,this.columnCount=v}isGreaterThanOrEqualTo(h){return this.lineCount!==h.lineCount?this.lineCount>h.lineCount:this.columnCount>=h.columnCount}createRange(h){return this.lineCount===0?new D.Range(h.lineNumber,h.column,h.lineNumber,h.column+this.columnCount):new D.Range(h.lineNumber,h.column,h.lineNumber+this.lineCount,this.columnCount+1)}addToPosition(h){return this.lineCount===0?new r.Position(h.lineNumber,h.column+this.columnCount):new r.Position(h.lineNumber+this.lineCount,this.columnCount+1)}toString(){return`${this.lineCount},${this.columnCount}`}}n.TextLength=A,A.zero=new A(0,0)}),Y(J[46],Z([0,1,3,29]),function(W,n,r,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PositionOffsetTransformer=void 0;class A{constructor(h){this.text=h,this.lineStartOffsetByLineIdx=[],this.lineStartOffsetByLineIdx.push(0);for(let v=0;v<h.length;v++)h.charAt(v)===`
`&&this.lineStartOffsetByLineIdx.push(v+1)}getOffset(h){return this.lineStartOffsetByLineIdx[h.lineNumber-1]+h.column-1}getOffsetRange(h){return new r.OffsetRange(this.getOffset(h.getStartPosition()),this.getOffset(h.getEndPosition()))}get textLength(){const h=this.lineStartOffsetByLineIdx.length-1;return new D.TextLength(h,this.text.length-this.lineStartOffsetByLineIdx[h])}}n.PositionOffsetTransformer=A}),Y(J[47],Z([0,1,9,5,4,46,2,29]),function(W,n,r,D,A,m,h,v){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringText=n.AbstractText=n.SingleTextEdit=n.TextEdit=void 0;class l{constructor(u){this.edits=u,(0,r.assertFn)(()=>(0,r.checkAdjacentItems)(u,(d,f)=>d.range.getEndPosition().isBeforeOrEqual(f.range.getStartPosition())))}apply(u){let d="",f=new A.Position(1,1);for(const _ of this.edits){const S=_.range,M=S.getStartPosition(),L=S.getEndPosition(),b=g(f,M);b.isEmpty()||(d+=u.getValueOfRange(b)),d+=_.text,f=L}const C=g(f,u.endPositionExclusive);return C.isEmpty()||(d+=u.getValueOfRange(C)),d}applyToString(u){const d=new c(u);return this.apply(d)}getNewRanges(){const u=[];let d=0,f=0,C=0;for(const _ of this.edits){const S=v.TextLength.ofText(_.text),M=A.Position.lift({lineNumber:_.range.startLineNumber+f,column:_.range.startColumn+(_.range.startLineNumber===d?C:0)}),L=S.createRange(M);u.push(L),f=L.endLineNumber-_.range.endLineNumber,C=L.endColumn-_.range.endColumn,d=_.range.endLineNumber}return u}}n.TextEdit=l;class a{constructor(u,d){this.range=u,this.text=d}toSingleEditOperation(){return{range:this.range,text:this.text}}}n.SingleTextEdit=a;function g(i,u){if(i.lineNumber===u.lineNumber&&i.column===Number.MAX_SAFE_INTEGER)return h.Range.fromPositions(u,u);if(!i.isBeforeOrEqual(u))throw new D.BugIndicatingError("start must be before end");return new h.Range(i.lineNumber,i.column,u.lineNumber,u.column)}class e{get endPositionExclusive(){return this.length.addToPosition(new A.Position(1,1))}}n.AbstractText=e;class c extends e{constructor(u){super(),this.value=u,this._t=new m.PositionOffsetTransformer(this.value)}getValueOfRange(u){return this._t.getOffsetRange(u).substring(this.value)}get length(){return this._t.textLength}}n.StringText=c}),Y(J[48],Z([0,1,22,28]),function(W,n,r,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WordCharacterClassifier=void 0,n.getMapForWordSeparators=h;class A extends D.CharacterClassifier{constructor(l,a){super(0),this._segmenter=null,this._cachedLine=null,this._cachedSegments=[],this.intlSegmenterLocales=a,this.intlSegmenterLocales.length>0?this._segmenter=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this._segmenter=null;for(let g=0,e=l.length;g<e;g++)this.set(l.charCodeAt(g),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(l,a){let g=null;for(const e of this._getIntlSegmenterWordsOnLine(l)){if(e.index>a)break;g=e}return g}findNextIntlWordAtOrAfterOffset(l,a){for(const g of this._getIntlSegmenterWordsOnLine(l))if(!(g.index<a))return g;return null}_getIntlSegmenterWordsOnLine(l){return this._segmenter?this._cachedLine===l?this._cachedSegments:(this._cachedLine=l,this._cachedSegments=this._filterWordSegments(this._segmenter.segment(l)),this._cachedSegments):[]}_filterWordSegments(l){const a=[];for(const g of l)this._isWordLike(g)&&a.push(g);return a}_isWordLike(l){return!!l.isWordLike}}n.WordCharacterClassifier=A;const m=new r.LRUCache(10);function h(v,l){const a=`${v}/${l.join(",")}`;let g=m.get(a);return g||(g=new A(v,l),m.set(a,g)),g}}),Y(J[30],Z([0,1,20,21]),function(W,n,r,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.ensureValidWordDefinition=m,n.getWordAtText=v,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(a=""){let g="(-?\\d*\\.\\d\\w*)|([^";for(const e of n.USUAL_WORD_SEPARATORS)a.indexOf(e)>=0||(g+="\\"+e);return g+="\\s]+)",new RegExp(g,"g")}n.DEFAULT_WORD_REGEXP=A();function m(a){let g=n.DEFAULT_WORD_REGEXP;if(a&&a instanceof RegExp)if(a.global)g=a;else{let e="g";a.ignoreCase&&(e+="i"),a.multiline&&(e+="m"),a.unicode&&(e+="u"),g=new RegExp(a.source,e)}return g.lastIndex=0,g}const h=new D.LinkedList;h.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function v(a,g,e,c,i){if(g=m(g),i||(i=r.Iterable.first(h)),e.length>i.maxLen){let _=a-i.maxLen/2;return _<0?_=0:c+=_,e=e.substring(_,a+i.maxLen/2),v(a,g,e,c,i)}const u=Date.now(),d=a-1-c;let f=-1,C=null;for(let _=1;!(Date.now()-u>=i.timeBudget);_++){const S=d-i.windowSize*_;g.lastIndex=Math.max(0,S);const M=l(g,e,d,f);if(!M&&C||(C=M,S<=0))break;f=S}if(C){const _={word:C[0],startColumn:c+1+C.index,endColumn:c+1+C.index+C[0].length};return g.lastIndex=0,_}return null}function l(a,g,e,c){let i;for(;i=a.exec(g);){const u=i.index||0;if(u<=e&&a.lastIndex>=e)return i;if(c>0&&u>c)return null}return null}}),Y(J[8],Z([0,1,7,5,3]),function(W,n,r,D,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DateTimeout=n.InfiniteTimeout=n.OffsetPair=n.SequenceDiff=n.DiffAlgorithmResult=void 0;class m{static trivial(e,c){return new m([new h(A.OffsetRange.ofLength(e.length),A.OffsetRange.ofLength(c.length))],!1)}static trivialTimedOut(e,c){return new m([new h(A.OffsetRange.ofLength(e.length),A.OffsetRange.ofLength(c.length))],!0)}constructor(e,c){this.diffs=e,this.hitTimeout=c}}n.DiffAlgorithmResult=m;class h{static invert(e,c){const i=[];return(0,r.forEachAdjacent)(e,(u,d)=>{i.push(h.fromOffsetPairs(u?u.getEndExclusives():v.zero,d?d.getStarts():new v(c,(u?u.seq2Range.endExclusive-u.seq1Range.endExclusive:0)+c)))}),i}static fromOffsetPairs(e,c){return new h(new A.OffsetRange(e.offset1,c.offset1),new A.OffsetRange(e.offset2,c.offset2))}constructor(e,c){this.seq1Range=e,this.seq2Range=c}swap(){return new h(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(e){return new h(this.seq1Range.join(e.seq1Range),this.seq2Range.join(e.seq2Range))}delta(e){return e===0?this:new h(this.seq1Range.delta(e),this.seq2Range.delta(e))}deltaStart(e){return e===0?this:new h(this.seq1Range.deltaStart(e),this.seq2Range.deltaStart(e))}deltaEnd(e){return e===0?this:new h(this.seq1Range.deltaEnd(e),this.seq2Range.deltaEnd(e))}intersect(e){const c=this.seq1Range.intersect(e.seq1Range),i=this.seq2Range.intersect(e.seq2Range);if(!(!c||!i))return new h(c,i)}getStarts(){return new v(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new v(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}n.SequenceDiff=h;class v{constructor(e,c){this.offset1=e,this.offset2=c}toString(){return`${this.offset1} <-> ${this.offset2}`}delta(e){return e===0?this:new v(this.offset1+e,this.offset2+e)}equals(e){return this.offset1===e.offset1&&this.offset2===e.offset2}}n.OffsetPair=v,v.zero=new v(0,0),v.max=new v(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER);class l{isValid(){return!0}}n.InfiniteTimeout=l,l.instance=new l;class a{constructor(e){if(this.timeout=e,this.startTime=Date.now(),this.valid=!0,e<=0)throw new D.BugIndicatingError("timeout must be positive")}isValid(){if(!(Date.now()-this.startTime<this.timeout)&&this.valid){this.valid=!1;debugger}return this.valid}}n.DateTimeout=a}),Y(J[31],Z([0,1,3,8]),function(W,n,r,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MyersDiffAlgorithm=void 0;class A{compute(a,g,e=D.InfiniteTimeout.instance){if(a.length===0||g.length===0)return D.DiffAlgorithmResult.trivial(a,g);const c=a,i=g;function u(s,o){for(;s<c.length&&o<i.length&&c.getElement(s)===i.getElement(o);)s++,o++;return s}let d=0;const f=new h;f.set(0,u(0,0));const C=new v;C.set(0,f.get(0)===0?null:new m(null,0,0,f.get(0)));let _=0;e:for(;;){if(d++,!e.isValid())return D.DiffAlgorithmResult.trivialTimedOut(c,i);const s=-Math.min(d,i.length+d%2),o=Math.min(d,c.length+d%2);for(_=s;_<=o;_+=2){let p=0;const w=_===o?-1:f.get(_+1),N=_===s?-1:f.get(_-1)+1;p++;const y=Math.min(Math.max(w,N),c.length),E=y-_;if(p++,y>c.length||E>i.length)continue;const R=u(y,E);f.set(_,R);const x=y===w?C.get(_+1):C.get(_-1);if(C.set(_,R!==y?new m(x,y,E,R-y):x),f.get(_)===c.length&&f.get(_)-_===i.length)break e}}let S=C.get(_);const M=[];let L=c.length,b=i.length;for(;;){const s=S?S.x+S.length:0,o=S?S.y+S.length:0;if((s!==L||o!==b)&&M.push(new D.SequenceDiff(new r.OffsetRange(s,L),new r.OffsetRange(o,b))),!S)break;L=S.x,b=S.y,S=S.prev}return M.reverse(),new D.DiffAlgorithmResult(M,!1)}}n.MyersDiffAlgorithm=A;class m{constructor(a,g,e,c){this.prev=a,this.x=g,this.y=e,this.length=c}}class h{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(a){return a<0?(a=-a-1,this.negativeArr[a]):this.positiveArr[a]}set(a,g){if(a<0){if(a=-a-1,a>=this.negativeArr.length){const e=this.negativeArr;this.negativeArr=new Int32Array(e.length*2),this.negativeArr.set(e)}this.negativeArr[a]=g}else{if(a>=this.positiveArr.length){const e=this.positiveArr;this.positiveArr=new Int32Array(e.length*2),this.positiveArr.set(e)}this.positiveArr[a]=g}}}class v{constructor(){this.positiveArr=[],this.negativeArr=[]}get(a){return a<0?(a=-a-1,this.negativeArr[a]):this.positiveArr[a]}set(a,g){a<0?(a=-a-1,this.negativeArr[a]=g):this.positiveArr[a]=g}}}),Y(J[49],Z([0,1,7,3,8]),function(W,n,r,D,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.optimizeSequenceDiffs=m,n.removeShortMatches=a,n.extendDiffsToEntireWordIfAppropriate=g,n.removeVeryShortMatchingLinesBetweenDiffs=c,n.removeVeryShortMatchingTextBetweenLongDiffs=i;function m(u,d,f){let C=f;return C=h(u,d,C),C=h(u,d,C),C=v(u,d,C),C}function h(u,d,f){if(f.length===0)return f;const C=[];C.push(f[0]);for(let S=1;S<f.length;S++){const M=C[C.length-1];let L=f[S];if(L.seq1Range.isEmpty||L.seq2Range.isEmpty){const b=L.seq1Range.start-M.seq1Range.endExclusive;let s;for(s=1;s<=b&&!(u.getElement(L.seq1Range.start-s)!==u.getElement(L.seq1Range.endExclusive-s)||d.getElement(L.seq2Range.start-s)!==d.getElement(L.seq2Range.endExclusive-s));s++);if(s--,s===b){C[C.length-1]=new A.SequenceDiff(new D.OffsetRange(M.seq1Range.start,L.seq1Range.endExclusive-b),new D.OffsetRange(M.seq2Range.start,L.seq2Range.endExclusive-b));continue}L=L.delta(-s)}C.push(L)}const _=[];for(let S=0;S<C.length-1;S++){const M=C[S+1];let L=C[S];if(L.seq1Range.isEmpty||L.seq2Range.isEmpty){const b=M.seq1Range.start-L.seq1Range.endExclusive;let s;for(s=0;s<b&&!(!u.isStronglyEqual(L.seq1Range.start+s,L.seq1Range.endExclusive+s)||!d.isStronglyEqual(L.seq2Range.start+s,L.seq2Range.endExclusive+s));s++);if(s===b){C[S+1]=new A.SequenceDiff(new D.OffsetRange(L.seq1Range.start+b,M.seq1Range.endExclusive),new D.OffsetRange(L.seq2Range.start+b,M.seq2Range.endExclusive));continue}s>0&&(L=L.delta(s))}_.push(L)}return C.length>0&&_.push(C[C.length-1]),_}function v(u,d,f){if(!u.getBoundaryScore||!d.getBoundaryScore)return f;for(let C=0;C<f.length;C++){const _=C>0?f[C-1]:void 0,S=f[C],M=C+1<f.length?f[C+1]:void 0,L=new D.OffsetRange(_?_.seq1Range.endExclusive+1:0,M?M.seq1Range.start-1:u.length),b=new D.OffsetRange(_?_.seq2Range.endExclusive+1:0,M?M.seq2Range.start-1:d.length);S.seq1Range.isEmpty?f[C]=l(S,u,d,L,b):S.seq2Range.isEmpty&&(f[C]=l(S.swap(),d,u,b,L).swap())}return f}function l(u,d,f,C,_){let M=1;for(;u.seq1Range.start-M>=C.start&&u.seq2Range.start-M>=_.start&&f.isStronglyEqual(u.seq2Range.start-M,u.seq2Range.endExclusive-M)&&M<100;)M++;M--;let L=0;for(;u.seq1Range.start+L<C.endExclusive&&u.seq2Range.endExclusive+L<_.endExclusive&&f.isStronglyEqual(u.seq2Range.start+L,u.seq2Range.endExclusive+L)&&L<100;)L++;if(M===0&&L===0)return u;let b=0,s=-1;for(let o=-M;o<=L;o++){const p=u.seq2Range.start+o,w=u.seq2Range.endExclusive+o,N=u.seq1Range.start+o,y=d.getBoundaryScore(N)+f.getBoundaryScore(p)+f.getBoundaryScore(w);y>s&&(s=y,b=o)}return u.delta(b)}function a(u,d,f){const C=[];for(const _ of f){const S=C[C.length-1];if(!S){C.push(_);continue}_.seq1Range.start-S.seq1Range.endExclusive<=2||_.seq2Range.start-S.seq2Range.endExclusive<=2?C[C.length-1]=new A.SequenceDiff(S.seq1Range.join(_.seq1Range),S.seq2Range.join(_.seq2Range)):C.push(_)}return C}function g(u,d,f){const C=A.SequenceDiff.invert(f,u.length),_=[];let S=new A.OffsetPair(0,0);function M(b,s){if(b.offset1<S.offset1||b.offset2<S.offset2)return;const o=u.findWordContaining(b.offset1),p=d.findWordContaining(b.offset2);if(!o||!p)return;let w=new A.SequenceDiff(o,p);const N=w.intersect(s);let y=N.seq1Range.length,E=N.seq2Range.length;for(;C.length>0;){const R=C[0];if(!(R.seq1Range.intersects(w.seq1Range)||R.seq2Range.intersects(w.seq2Range)))break;const P=u.findWordContaining(R.seq1Range.start),F=d.findWordContaining(R.seq2Range.start),I=new A.SequenceDiff(P,F),V=I.intersect(R);if(y+=V.seq1Range.length,E+=V.seq2Range.length,w=w.join(I),w.seq1Range.endExclusive>=R.seq1Range.endExclusive)C.shift();else break}y+E<(w.seq1Range.length+w.seq2Range.length)*2/3&&_.push(w),S=w.getEndExclusives()}for(;C.length>0;){const b=C.shift();b.seq1Range.isEmpty||(M(b.getStarts(),b),M(b.getEndExclusives().delta(-1),b))}return e(f,_)}function e(u,d){const f=[];for(;u.length>0||d.length>0;){const C=u[0],_=d[0];let S;C&&(!_||C.seq1Range.start<_.seq1Range.start)?S=u.shift():S=d.shift(),f.length>0&&f[f.length-1].seq1Range.endExclusive>=S.seq1Range.start?f[f.length-1]=f[f.length-1].join(S):f.push(S)}return f}function c(u,d,f){let C=f;if(C.length===0)return C;let _=0,S;do{S=!1;const M=[C[0]];for(let L=1;L<C.length;L++){let o=function(w,N){const y=new D.OffsetRange(s.seq1Range.endExclusive,b.seq1Range.start);return u.getText(y).replace(/\s/g,"").length<=4&&(w.seq1Range.length+w.seq2Range.length>5||N.seq1Range.length+N.seq2Range.length>5)};const b=C[L],s=M[M.length-1];o(s,b)?(S=!0,M[M.length-1]=M[M.length-1].join(b)):M.push(b)}C=M}while(_++<10&&S);return C}function i(u,d,f){let C=f;if(C.length===0)return C;let _=0,S;do{S=!1;const L=[C[0]];for(let b=1;b<C.length;b++){let p=function(N,y){const E=new D.OffsetRange(o.seq1Range.endExclusive,s.seq1Range.start);if(u.countLinesIn(E)>5||E.length>500)return!1;const x=u.getText(E).trim();if(x.length>20||x.split(/\r\n|\r|\n/).length>1)return!1;const P=u.countLinesIn(N.seq1Range),F=N.seq1Range.length,I=d.countLinesIn(N.seq2Range),V=N.seq2Range.length,$=u.countLinesIn(y.seq1Range),T=y.seq1Range.length,O=d.countLinesIn(y.seq2Range),B=y.seq2Range.length,z=2*40+50;function j(K){return Math.min(K,z)}return Math.pow(Math.pow(j(P*40+F),1.5)+Math.pow(j(I*40+V),1.5),1.5)+Math.pow(Math.pow(j($*40+T),1.5)+Math.pow(j(O*40+B),1.5),1.5)>(z**1.5)**1.5*1.3};const s=C[b],o=L[L.length-1];p(o,s)?(S=!0,L[L.length-1]=L[L.length-1].join(s)):L.push(s)}C=L}while(_++<10&&S);const M=[];return(0,r.forEachWithNeighbors)(C,(L,b,s)=>{let o=b;function p(x){return x.length>0&&x.trim().length<=3&&b.seq1Range.length+b.seq2Range.length>100}const w=u.extendToFullLines(b.seq1Range),N=u.getText(new D.OffsetRange(w.start,b.seq1Range.start));p(N)&&(o=o.deltaStart(-N.length));const y=u.getText(new D.OffsetRange(b.seq1Range.endExclusive,w.endExclusive));p(y)&&(o=o.deltaEnd(y.length));const E=A.SequenceDiff.fromOffsetPairs(L?L.getEndExclusives():A.OffsetPair.zero,s?s.getStarts():A.OffsetPair.max),R=o.intersect(E);M.length>0&&R.getStarts().equals(M[M.length-1].getEndExclusives())?M[M.length-1]=M[M.length-1].join(R):M.push(R)}),M}}),Y(J[50],Z([0,1]),function(W,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineSequence=void 0;class r{constructor(m,h){this.trimmedHash=m,this.lines=h}getElement(m){return this.trimmedHash[m]}get length(){return this.trimmedHash.length}getBoundaryScore(m){const h=m===0?0:D(this.lines[m-1]),v=m===this.lines.length?0:D(this.lines[m]);return 1e3-(h+v)}getText(m){return this.lines.slice(m.start,m.endExclusive).join(`
`)}isStronglyEqual(m,h){return this.lines[m]===this.lines[h]}}n.LineSequence=r;function D(A){let m=0;for(;m<A.length&&(A.charCodeAt(m)===32||A.charCodeAt(m)===9);)m++;return m}}),Y(J[17],Z([0,1]),function(W,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineRangeFragment=n.Array2D=void 0,n.isSpace=D;class r{constructor(h,v){this.width=h,this.height=v,this.array=[],this.array=new Array(h*v)}get(h,v){return this.array[h+v*this.width]}set(h,v,l){this.array[h+v*this.width]=l}}n.Array2D=r;function D(m){return m===32||m===9}class A{static getKey(h){let v=this.chrKeys.get(h);return v===void 0&&(v=this.chrKeys.size,this.chrKeys.set(h,v)),v}constructor(h,v,l){this.range=h,this.lines=v,this.source=l,this.histogram=[];let a=0;for(let g=h.startLineNumber-1;g<h.endLineNumberExclusive-1;g++){const e=v[g];for(let i=0;i<e.length;i++){a++;const u=e[i],d=A.getKey(u);this.histogram[d]=(this.histogram[d]||0)+1}a++;const c=A.getKey(`
`);this.histogram[c]=(this.histogram[c]||0)+1}this.totalCount=a}computeSimilarity(h){var v,l;let a=0;const g=Math.max(this.histogram.length,h.histogram.length);for(let e=0;e<g;e++)a+=Math.abs(((v=this.histogram[e])!==null&&v!==void 0?v:0)-((l=h.histogram[e])!==null&&l!==void 0?l:0));return 1-a/(this.totalCount+h.totalCount)}}n.LineRangeFragment=A,A.chrKeys=new Map}),Y(J[51],Z([0,1,3,8,17]),function(W,n,r,D,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DynamicProgrammingDiffing=void 0;class m{compute(v,l,a=D.InfiniteTimeout.instance,g){if(v.length===0||l.length===0)return D.DiffAlgorithmResult.trivial(v,l);const e=new A.Array2D(v.length,l.length),c=new A.Array2D(v.length,l.length),i=new A.Array2D(v.length,l.length);for(let M=0;M<v.length;M++)for(let L=0;L<l.length;L++){if(!a.isValid())return D.DiffAlgorithmResult.trivialTimedOut(v,l);const b=M===0?0:e.get(M-1,L),s=L===0?0:e.get(M,L-1);let o;v.getElement(M)===l.getElement(L)?(M===0||L===0?o=0:o=e.get(M-1,L-1),M>0&&L>0&&c.get(M-1,L-1)===3&&(o+=i.get(M-1,L-1)),o+=g?g(M,L):1):o=-1;const p=Math.max(b,s,o);if(p===o){const w=M>0&&L>0?i.get(M-1,L-1):0;i.set(M,L,w+1),c.set(M,L,3)}else p===b?(i.set(M,L,0),c.set(M,L,1)):p===s&&(i.set(M,L,0),c.set(M,L,2));e.set(M,L,p)}const u=[];let d=v.length,f=l.length;function C(M,L){(M+1!==d||L+1!==f)&&u.push(new D.SequenceDiff(new r.OffsetRange(M+1,d),new r.OffsetRange(L+1,f))),d=M,f=L}let _=v.length-1,S=l.length-1;for(;_>=0&&S>=0;)c.get(_,S)===3?(C(_,S),_--,S--):c.get(_,S)===1?_--:S--;return C(-1,-1),u.reverse(),new D.DiffAlgorithmResult(u,!1)}}n.DynamicProgrammingDiffing=m}),Y(J[32],Z([0,1,12,3,4,2,17]),function(W,n,r,D,A,m,h){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinesSliceCharSequence=void 0;class v{constructor(i,u,d){this.lines=i,this.considerWhitespaceChanges=d,this.elements=[],this.firstCharOffsetByLine=[],this.additionalOffsetByLine=[];let f=!1;u.start>0&&u.endExclusive>=i.length&&(u=new D.OffsetRange(u.start-1,u.endExclusive),f=!0),this.lineRange=u,this.firstCharOffsetByLine[0]=0;for(let C=this.lineRange.start;C<this.lineRange.endExclusive;C++){let _=i[C],S=0;if(f)S=_.length,_="",f=!1;else if(!d){const M=_.trimStart();S=_.length-M.length,_=M.trimEnd()}this.additionalOffsetByLine.push(S);for(let M=0;M<_.length;M++)this.elements.push(_.charCodeAt(M));C<i.length-1&&(this.elements.push(10),this.firstCharOffsetByLine[C-this.lineRange.start+1]=this.elements.length)}this.additionalOffsetByLine.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new D.OffsetRange(0,this.length))}getText(i){return this.elements.slice(i.start,i.endExclusive).map(u=>String.fromCharCode(u)).join("")}getElement(i){return this.elements[i]}get length(){return this.elements.length}getBoundaryScore(i){const u=e(i>0?this.elements[i-1]:-1),d=e(i<this.elements.length?this.elements[i]:-1);if(u===7&&d===8)return 0;if(u===8)return 150;let f=0;return u!==d&&(f+=10,u===0&&d===1&&(f+=1)),f+=g(u),f+=g(d),f}translateOffset(i){if(this.lineRange.isEmpty)return new A.Position(this.lineRange.start+1,1);const u=(0,r.findLastIdxMonotonous)(this.firstCharOffsetByLine,d=>d<=i);return new A.Position(this.lineRange.start+u+1,i-this.firstCharOffsetByLine[u]+this.additionalOffsetByLine[u]+1)}translateRange(i){return m.Range.fromPositions(this.translateOffset(i.start),this.translateOffset(i.endExclusive))}findWordContaining(i){if(i<0||i>=this.elements.length||!l(this.elements[i]))return;let u=i;for(;u>0&&l(this.elements[u-1]);)u--;let d=i;for(;d<this.elements.length&&l(this.elements[d]);)d++;return new D.OffsetRange(u,d)}countLinesIn(i){return this.translateOffset(i.endExclusive).lineNumber-this.translateOffset(i.start).lineNumber}isStronglyEqual(i,u){return this.elements[i]===this.elements[u]}extendToFullLines(i){var u,d;const f=(u=(0,r.findLastMonotonous)(this.firstCharOffsetByLine,_=>_<=i.start))!==null&&u!==void 0?u:0,C=(d=(0,r.findFirstMonotonous)(this.firstCharOffsetByLine,_=>i.endExclusive<=_))!==null&&d!==void 0?d:this.elements.length;return new D.OffsetRange(f,C)}}n.LinesSliceCharSequence=v;function l(c){return c>=97&&c<=122||c>=65&&c<=90||c>=48&&c<=57}const a={0:0,1:0,2:0,3:10,4:2,5:30,6:3,7:10,8:10};function g(c){return a[c]}function e(c){return c===10?8:c===13?7:(0,h.isSpace)(c)?6:c>=97&&c<=122?0:c>=65&&c<=90?1:c>=48&&c<=57?2:c===-1?3:c===44||c===59?5:4}}),Y(J[33],Z([0,1]),function(W,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MovedText=n.LinesDiff=void 0;class r{constructor(m,h,v){this.changes=m,this.moves=h,this.hitTimeout=v}}n.LinesDiff=r;class D{constructor(m,h){this.lineRangeMapping=m,this.changes=h}}n.MovedText=D}),Y(J[18],Z([0,1,5,11,2,47]),function(W,n,r,D,A,m){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.RangeMapping=n.DetailedLineRangeMapping=n.LineRangeMapping=void 0;class h{static inverse(g,e,c){const i=[];let u=1,d=1;for(const C of g){const _=new h(new D.LineRange(u,C.original.startLineNumber),new D.LineRange(d,C.modified.startLineNumber));_.modified.isEmpty||i.push(_),u=C.original.endLineNumberExclusive,d=C.modified.endLineNumberExclusive}const f=new h(new D.LineRange(u,e+1),new D.LineRange(d,c+1));return f.modified.isEmpty||i.push(f),i}static clip(g,e,c){const i=[];for(const u of g){const d=u.original.intersect(e),f=u.modified.intersect(c);d&&!d.isEmpty&&f&&!f.isEmpty&&i.push(new h(d,f))}return i}constructor(g,e){this.original=g,this.modified=e}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new h(this.modified,this.original)}join(g){return new h(this.original.join(g.original),this.modified.join(g.modified))}toRangeMapping(){const g=this.original.toInclusiveRange(),e=this.modified.toInclusiveRange();if(g&&e)return new l(g,e);if(this.original.startLineNumber===1||this.modified.startLineNumber===1){if(!(this.modified.startLineNumber===1&&this.original.startLineNumber===1))throw new r.BugIndicatingError("not a valid diff");return new l(new A.Range(this.original.startLineNumber,1,this.original.endLineNumberExclusive,1),new A.Range(this.modified.startLineNumber,1,this.modified.endLineNumberExclusive,1))}else return new l(new A.Range(this.original.startLineNumber-1,Number.MAX_SAFE_INTEGER,this.original.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),new A.Range(this.modified.startLineNumber-1,Number.MAX_SAFE_INTEGER,this.modified.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER))}}n.LineRangeMapping=h;class v extends h{static fromRangeMappings(g){const e=D.LineRange.join(g.map(i=>D.LineRange.fromRangeInclusive(i.originalRange))),c=D.LineRange.join(g.map(i=>D.LineRange.fromRangeInclusive(i.modifiedRange)));return new v(e,c,g)}constructor(g,e,c){super(g,e),this.innerChanges=c}flip(){var g;return new v(this.modified,this.original,(g=this.innerChanges)===null||g===void 0?void 0:g.map(e=>e.flip()))}withInnerChangesFromLineRanges(){return new v(this.original,this.modified,[this.toRangeMapping()])}}n.DetailedLineRangeMapping=v;class l{constructor(g,e){this.originalRange=g,this.modifiedRange=e}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new l(this.modifiedRange,this.originalRange)}toTextEdit(g){const e=g.getValueOfRange(this.modifiedRange);return new m.SingleTextEdit(this.originalRange,e)}}n.RangeMapping=l}),Y(J[52],Z([0,1,8,18,7,12,22,11,3,32,17,31]),function(W,n,r,D,A,m,h,v,l,a,g,e){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeMovedLines=c;function c(S,M,L,b,s,o){let{moves:p,excludedChanges:w}=u(S,M,L,o);if(!o.isValid())return[];const N=S.filter(E=>!w.has(E)),y=d(N,b,s,M,L,o);return(0,A.pushMany)(p,y),p=C(p),p=p.filter(E=>{const R=E.original.toOffsetRange().slice(M).map(P=>P.trim());return R.join(`
`).length>=15&&i(R,P=>P.length>=2)>=2}),p=_(S,p),p}function i(S,M){let L=0;for(const b of S)M(b)&&L++;return L}function u(S,M,L,b){const s=[],o=S.filter(N=>N.modified.isEmpty&&N.original.length>=3).map(N=>new g.LineRangeFragment(N.original,M,N)),p=new Set(S.filter(N=>N.original.isEmpty&&N.modified.length>=3).map(N=>new g.LineRangeFragment(N.modified,L,N))),w=new Set;for(const N of o){let y=-1,E;for(const R of p){const x=N.computeSimilarity(R);x>y&&(y=x,E=R)}if(y>.9&&E&&(p.delete(E),s.push(new D.LineRangeMapping(N.range,E.range)),w.add(N.source),w.add(E.source)),!b.isValid())return{moves:s,excludedChanges:w}}return{moves:s,excludedChanges:w}}function d(S,M,L,b,s,o){const p=[],w=new h.SetMap;for(const x of S)for(let P=x.original.startLineNumber;P<x.original.endLineNumberExclusive-2;P++){const F=`${M[P-1]}:${M[P+1-1]}:${M[P+2-1]}`;w.add(F,{range:new v.LineRange(P,P+3)})}const N=[];S.sort((0,A.compareBy)(x=>x.modified.startLineNumber,A.numberComparator));for(const x of S){let P=[];for(let F=x.modified.startLineNumber;F<x.modified.endLineNumberExclusive-2;F++){const I=`${L[F-1]}:${L[F+1-1]}:${L[F+2-1]}`,V=new v.LineRange(F,F+3),$=[];w.forEach(I,({range:T})=>{for(const B of P)if(B.originalLineRange.endLineNumberExclusive+1===T.endLineNumberExclusive&&B.modifiedLineRange.endLineNumberExclusive+1===V.endLineNumberExclusive){B.originalLineRange=new v.LineRange(B.originalLineRange.startLineNumber,T.endLineNumberExclusive),B.modifiedLineRange=new v.LineRange(B.modifiedLineRange.startLineNumber,V.endLineNumberExclusive),$.push(B);return}const O={modifiedLineRange:V,originalLineRange:T};N.push(O),$.push(O)}),P=$}if(!o.isValid())return[]}N.sort((0,A.reverseOrder)((0,A.compareBy)(x=>x.modifiedLineRange.length,A.numberComparator)));const y=new v.LineRangeSet,E=new v.LineRangeSet;for(const x of N){const P=x.modifiedLineRange.startLineNumber-x.originalLineRange.startLineNumber,F=y.subtractFrom(x.modifiedLineRange),I=E.subtractFrom(x.originalLineRange).getWithDelta(P),V=F.getIntersection(I);for(const $ of V.ranges){if($.length<3)continue;const T=$,O=$.delta(-P);p.push(new D.LineRangeMapping(O,T)),y.addRange(T),E.addRange(O)}}p.sort((0,A.compareBy)(x=>x.original.startLineNumber,A.numberComparator));const R=new m.MonotonousArray(S);for(let x=0;x<p.length;x++){const P=p[x],F=R.findLastMonotonous(j=>j.original.startLineNumber<=P.original.startLineNumber),I=(0,m.findLastMonotonous)(S,j=>j.modified.startLineNumber<=P.modified.startLineNumber),V=Math.max(P.original.startLineNumber-F.original.startLineNumber,P.modified.startLineNumber-I.modified.startLineNumber),$=R.findLastMonotonous(j=>j.original.startLineNumber<P.original.endLineNumberExclusive),T=(0,m.findLastMonotonous)(S,j=>j.modified.startLineNumber<P.modified.endLineNumberExclusive),O=Math.max($.original.endLineNumberExclusive-P.original.endLineNumberExclusive,T.modified.endLineNumberExclusive-P.modified.endLineNumberExclusive);let B;for(B=0;B<V;B++){const j=P.original.startLineNumber-B-1,K=P.modified.startLineNumber-B-1;if(j>b.length||K>s.length||y.contains(K)||E.contains(j)||!f(b[j-1],s[K-1],o))break}B>0&&(E.addRange(new v.LineRange(P.original.startLineNumber-B,P.original.startLineNumber)),y.addRange(new v.LineRange(P.modified.startLineNumber-B,P.modified.startLineNumber)));let z;for(z=0;z<O;z++){const j=P.original.endLineNumberExclusive+z,K=P.modified.endLineNumberExclusive+z;if(j>b.length||K>s.length||y.contains(K)||E.contains(j)||!f(b[j-1],s[K-1],o))break}z>0&&(E.addRange(new v.LineRange(P.original.endLineNumberExclusive,P.original.endLineNumberExclusive+z)),y.addRange(new v.LineRange(P.modified.endLineNumberExclusive,P.modified.endLineNumberExclusive+z))),(B>0||z>0)&&(p[x]=new D.LineRangeMapping(new v.LineRange(P.original.startLineNumber-B,P.original.endLineNumberExclusive+z),new v.LineRange(P.modified.startLineNumber-B,P.modified.endLineNumberExclusive+z)))}return p}function f(S,M,L){if(S.trim()===M.trim())return!0;if(S.length>300&&M.length>300)return!1;const s=new e.MyersDiffAlgorithm().compute(new a.LinesSliceCharSequence([S],new l.OffsetRange(0,1),!1),new a.LinesSliceCharSequence([M],new l.OffsetRange(0,1),!1),L);let o=0;const p=r.SequenceDiff.invert(s.diffs,S.length);for(const E of p)E.seq1Range.forEach(R=>{(0,g.isSpace)(S.charCodeAt(R))||o++});function w(E){let R=0;for(let x=0;x<S.length;x++)(0,g.isSpace)(E.charCodeAt(x))||R++;return R}const N=w(S.length>M.length?S:M);return o/N>.6&&N>10}function C(S){if(S.length===0)return S;S.sort((0,A.compareBy)(L=>L.original.startLineNumber,A.numberComparator));const M=[S[0]];for(let L=1;L<S.length;L++){const b=M[M.length-1],s=S[L],o=s.original.startLineNumber-b.original.endLineNumberExclusive,p=s.modified.startLineNumber-b.modified.endLineNumberExclusive;if(o>=0&&p>=0&&o+p<=2){M[M.length-1]=b.join(s);continue}M.push(s)}return M}function _(S,M){const L=new m.MonotonousArray(S);return M=M.filter(b=>{const s=L.findLastMonotonous(w=>w.original.startLineNumber<b.original.endLineNumberExclusive)||new D.LineRangeMapping(new v.LineRange(1,1),new v.LineRange(1,1)),o=(0,m.findLastMonotonous)(S,w=>w.modified.startLineNumber<b.modified.endLineNumberExclusive);return s!==o}),M}}),Y(J[53],Z([0,1,7,9,11,3,2,8,51,31,52,49,50,32,33,18]),function(W,n,r,D,A,m,h,v,l,a,g,e,c,i,u,d){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DefaultLinesDiffComputer=void 0,n.lineRangeMappingFromRangeMappings=C,n.getLineRangeMapping=_;class f{constructor(){this.dynamicProgrammingDiffing=new l.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new a.MyersDiffAlgorithm}computeDiff(M,L,b){if(M.length<=1&&(0,r.equals)(M,L,(z,j)=>z===j))return new u.LinesDiff([],[],!1);if(M.length===1&&M[0].length===0||L.length===1&&L[0].length===0)return new u.LinesDiff([new d.DetailedLineRangeMapping(new A.LineRange(1,M.length+1),new A.LineRange(1,L.length+1),[new d.RangeMapping(new h.Range(1,1,M.length,M[M.length-1].length+1),new h.Range(1,1,L.length,L[L.length-1].length+1))])],[],!1);const s=b.maxComputationTimeMs===0?v.InfiniteTimeout.instance:new v.DateTimeout(b.maxComputationTimeMs),o=!b.ignoreTrimWhitespace,p=new Map;function w(z){let j=p.get(z);return j===void 0&&(j=p.size,p.set(z,j)),j}const N=M.map(z=>w(z.trim())),y=L.map(z=>w(z.trim())),E=new c.LineSequence(N,M),R=new c.LineSequence(y,L),x=E.length+R.length<1700?this.dynamicProgrammingDiffing.compute(E,R,s,(z,j)=>M[z]===L[j]?L[j].length===0?.1:1+Math.log(1+L[j].length):.99):this.myersDiffingAlgorithm.compute(E,R,s);let P=x.diffs,F=x.hitTimeout;P=(0,e.optimizeSequenceDiffs)(E,R,P),P=(0,e.removeVeryShortMatchingLinesBetweenDiffs)(E,R,P);const I=[],V=z=>{if(o)for(let j=0;j<z;j++){const K=$+j,ne=T+j;if(M[K]!==L[ne]){const se=this.refineDiff(M,L,new v.SequenceDiff(new m.OffsetRange(K,K+1),new m.OffsetRange(ne,ne+1)),s,o);for(const oe of se.mappings)I.push(oe);se.hitTimeout&&(F=!0)}}};let $=0,T=0;for(const z of P){(0,D.assertFn)(()=>z.seq1Range.start-$===z.seq2Range.start-T);const j=z.seq1Range.start-$;V(j),$=z.seq1Range.endExclusive,T=z.seq2Range.endExclusive;const K=this.refineDiff(M,L,z,s,o);K.hitTimeout&&(F=!0);for(const ne of K.mappings)I.push(ne)}V(M.length-$);const O=C(I,M,L);let B=[];return b.computeMoves&&(B=this.computeMoves(O,M,L,N,y,s,o)),(0,D.assertFn)(()=>{function z(K,ne){if(K.lineNumber<1||K.lineNumber>ne.length)return!1;const se=ne[K.lineNumber-1];return!(K.column<1||K.column>se.length+1)}function j(K,ne){return!(K.startLineNumber<1||K.startLineNumber>ne.length+1||K.endLineNumberExclusive<1||K.endLineNumberExclusive>ne.length+1)}for(const K of O){if(!K.innerChanges)return!1;for(const ne of K.innerChanges)if(!(z(ne.modifiedRange.getStartPosition(),L)&&z(ne.modifiedRange.getEndPosition(),L)&&z(ne.originalRange.getStartPosition(),M)&&z(ne.originalRange.getEndPosition(),M)))return!1;if(!j(K.modified,L)||!j(K.original,M))return!1}return!0}),new u.LinesDiff(O,B,F)}computeMoves(M,L,b,s,o,p,w){return(0,g.computeMovedLines)(M,L,b,s,o,p).map(E=>{const R=this.refineDiff(L,b,new v.SequenceDiff(E.original.toOffsetRange(),E.modified.toOffsetRange()),p,w),x=C(R.mappings,L,b,!0);return new u.MovedText(E,x)})}refineDiff(M,L,b,s,o){const p=new i.LinesSliceCharSequence(M,b.seq1Range,o),w=new i.LinesSliceCharSequence(L,b.seq2Range,o),N=p.length+w.length<500?this.dynamicProgrammingDiffing.compute(p,w,s):this.myersDiffingAlgorithm.compute(p,w,s);let y=N.diffs;return y=(0,e.optimizeSequenceDiffs)(p,w,y),y=(0,e.extendDiffsToEntireWordIfAppropriate)(p,w,y),y=(0,e.removeShortMatches)(p,w,y),y=(0,e.removeVeryShortMatchingTextBetweenLongDiffs)(p,w,y),{mappings:y.map(R=>new d.RangeMapping(p.translateRange(R.seq1Range),w.translateRange(R.seq2Range))),hitTimeout:N.hitTimeout}}}n.DefaultLinesDiffComputer=f;function C(S,M,L,b=!1){const s=[];for(const o of(0,r.groupAdjacentBy)(S.map(p=>_(p,M,L)),(p,w)=>p.original.overlapOrTouch(w.original)||p.modified.overlapOrTouch(w.modified))){const p=o[0],w=o[o.length-1];s.push(new d.DetailedLineRangeMapping(p.original.join(w.original),p.modified.join(w.modified),o.map(N=>N.innerChanges[0])))}return(0,D.assertFn)(()=>!b&&s.length>0&&(s[0].modified.startLineNumber!==s[0].original.startLineNumber||L.length-s[s.length-1].modified.endLineNumberExclusive!==M.length-s[s.length-1].original.endLineNumberExclusive)?!1:(0,D.checkAdjacentItems)(s,(o,p)=>p.original.startLineNumber-o.original.endLineNumberExclusive===p.modified.startLineNumber-o.modified.endLineNumberExclusive&&o.original.endLineNumberExclusive<p.original.startLineNumber&&o.modified.endLineNumberExclusive<p.modified.startLineNumber)),s}function _(S,M,L){let b=0,s=0;S.modifiedRange.endColumn===1&&S.originalRange.endColumn===1&&S.originalRange.startLineNumber+b<=S.originalRange.endLineNumber&&S.modifiedRange.startLineNumber+b<=S.modifiedRange.endLineNumber&&(s=-1),S.modifiedRange.startColumn-1>=L[S.modifiedRange.startLineNumber-1].length&&S.originalRange.startColumn-1>=M[S.originalRange.startLineNumber-1].length&&S.originalRange.startLineNumber<=S.originalRange.endLineNumber+s&&S.modifiedRange.startLineNumber<=S.modifiedRange.endLineNumber+s&&(b=1);const o=new A.LineRange(S.originalRange.startLineNumber+b,S.originalRange.endLineNumber+1+s),p=new A.LineRange(S.modifiedRange.startLineNumber+b,S.modifiedRange.endLineNumber+1+s);return new d.DetailedLineRangeMapping(o,p,[S])}}),Y(J[54],Z([0,1,24,33,18,6,2,9,11]),function(W,n,r,D,A,m,h,v,l){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=n.LegacyLinesDiffComputer=void 0;const a=3;class g{computeDiff(b,s,o){var p;const N=new C(b,s,{maxComputationTime:o.maxComputationTimeMs,shouldIgnoreTrimWhitespace:o.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),y=[];let E=null;for(const R of N.changes){let x;R.originalEndLineNumber===0?x=new l.LineRange(R.originalStartLineNumber+1,R.originalStartLineNumber+1):x=new l.LineRange(R.originalStartLineNumber,R.originalEndLineNumber+1);let P;R.modifiedEndLineNumber===0?P=new l.LineRange(R.modifiedStartLineNumber+1,R.modifiedStartLineNumber+1):P=new l.LineRange(R.modifiedStartLineNumber,R.modifiedEndLineNumber+1);let F=new A.DetailedLineRangeMapping(x,P,(p=R.charChanges)===null||p===void 0?void 0:p.map(I=>new A.RangeMapping(new h.Range(I.originalStartLineNumber,I.originalStartColumn,I.originalEndLineNumber,I.originalEndColumn),new h.Range(I.modifiedStartLineNumber,I.modifiedStartColumn,I.modifiedEndLineNumber,I.modifiedEndColumn))));E&&(E.modified.endLineNumberExclusive===F.modified.startLineNumber||E.original.endLineNumberExclusive===F.original.startLineNumber)&&(F=new A.DetailedLineRangeMapping(E.original.join(F.original),E.modified.join(F.modified),E.innerChanges&&F.innerChanges?E.innerChanges.concat(F.innerChanges):void 0),y.pop()),y.push(F),E=F}return(0,v.assertFn)(()=>(0,v.checkAdjacentItems)(y,(R,x)=>x.original.startLineNumber-R.original.endLineNumberExclusive===x.modified.startLineNumber-R.modified.endLineNumberExclusive&&R.original.endLineNumberExclusive<x.original.startLineNumber&&R.modified.endLineNumberExclusive<x.modified.startLineNumber)),new D.LinesDiff(y,[],N.quitEarly)}}n.LegacyLinesDiffComputer=g;function e(L,b,s,o){return new r.LcsDiff(L,b,s).ComputeDiff(o)}class c{constructor(b){const s=[],o=[];for(let p=0,w=b.length;p<w;p++)s[p]=_(b[p],1),o[p]=S(b[p],1);this.lines=b,this._startColumns=s,this._endColumns=o}getElements(){const b=[];for(let s=0,o=this.lines.length;s<o;s++)b[s]=this.lines[s].substring(this._startColumns[s]-1,this._endColumns[s]-1);return b}getStrictElement(b){return this.lines[b]}getStartLineNumber(b){return b+1}getEndLineNumber(b){return b+1}createCharSequence(b,s,o){const p=[],w=[],N=[];let y=0;for(let E=s;E<=o;E++){const R=this.lines[E],x=b?this._startColumns[E]:1,P=b?this._endColumns[E]:R.length+1;for(let F=x;F<P;F++)p[y]=R.charCodeAt(F-1),w[y]=E+1,N[y]=F,y++;!b&&E<o&&(p[y]=10,w[y]=E+1,N[y]=R.length+1,y++)}return new i(p,w,N)}}class i{constructor(b,s,o){this._charCodes=b,this._lineNumbers=s,this._columns=o}toString(){return"["+this._charCodes.map((b,s)=>(b===10?"\\n":String.fromCharCode(b))+`-(${this._lineNumbers[s]},${this._columns[s]})`).join(", ")+"]"}_assertIndex(b,s){if(b<0||b>=s.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(b){return b>0&&b===this._lineNumbers.length?this.getEndLineNumber(b-1):(this._assertIndex(b,this._lineNumbers),this._lineNumbers[b])}getEndLineNumber(b){return b===-1?this.getStartLineNumber(b+1):(this._assertIndex(b,this._lineNumbers),this._charCodes[b]===10?this._lineNumbers[b]+1:this._lineNumbers[b])}getStartColumn(b){return b>0&&b===this._columns.length?this.getEndColumn(b-1):(this._assertIndex(b,this._columns),this._columns[b])}getEndColumn(b){return b===-1?this.getStartColumn(b+1):(this._assertIndex(b,this._columns),this._charCodes[b]===10?1:this._columns[b]+1)}}class u{constructor(b,s,o,p,w,N,y,E){this.originalStartLineNumber=b,this.originalStartColumn=s,this.originalEndLineNumber=o,this.originalEndColumn=p,this.modifiedStartLineNumber=w,this.modifiedStartColumn=N,this.modifiedEndLineNumber=y,this.modifiedEndColumn=E}static createFromDiffChange(b,s,o){const p=s.getStartLineNumber(b.originalStart),w=s.getStartColumn(b.originalStart),N=s.getEndLineNumber(b.originalStart+b.originalLength-1),y=s.getEndColumn(b.originalStart+b.originalLength-1),E=o.getStartLineNumber(b.modifiedStart),R=o.getStartColumn(b.modifiedStart),x=o.getEndLineNumber(b.modifiedStart+b.modifiedLength-1),P=o.getEndColumn(b.modifiedStart+b.modifiedLength-1);return new u(p,w,N,y,E,R,x,P)}}function d(L){if(L.length<=1)return L;const b=[L[0]];let s=b[0];for(let o=1,p=L.length;o<p;o++){const w=L[o],N=w.originalStart-(s.originalStart+s.originalLength),y=w.modifiedStart-(s.modifiedStart+s.modifiedLength);Math.min(N,y)<a?(s.originalLength=w.originalStart+w.originalLength-s.originalStart,s.modifiedLength=w.modifiedStart+w.modifiedLength-s.modifiedStart):(b.push(w),s=w)}return b}class f{constructor(b,s,o,p,w){this.originalStartLineNumber=b,this.originalEndLineNumber=s,this.modifiedStartLineNumber=o,this.modifiedEndLineNumber=p,this.charChanges=w}static createFromDiffResult(b,s,o,p,w,N,y){let E,R,x,P,F;if(s.originalLength===0?(E=o.getStartLineNumber(s.originalStart)-1,R=0):(E=o.getStartLineNumber(s.originalStart),R=o.getEndLineNumber(s.originalStart+s.originalLength-1)),s.modifiedLength===0?(x=p.getStartLineNumber(s.modifiedStart)-1,P=0):(x=p.getStartLineNumber(s.modifiedStart),P=p.getEndLineNumber(s.modifiedStart+s.modifiedLength-1)),N&&s.originalLength>0&&s.originalLength<20&&s.modifiedLength>0&&s.modifiedLength<20&&w()){const I=o.createCharSequence(b,s.originalStart,s.originalStart+s.originalLength-1),V=p.createCharSequence(b,s.modifiedStart,s.modifiedStart+s.modifiedLength-1);if(I.getElements().length>0&&V.getElements().length>0){let $=e(I,V,w,!0).changes;y&&($=d($)),F=[];for(let T=0,O=$.length;T<O;T++)F.push(u.createFromDiffChange($[T],I,V))}}return new f(E,R,x,P,F)}}class C{constructor(b,s,o){this.shouldComputeCharChanges=o.shouldComputeCharChanges,this.shouldPostProcessCharChanges=o.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=o.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=o.shouldMakePrettyDiff,this.originalLines=b,this.modifiedLines=s,this.original=new c(b),this.modified=new c(s),this.continueLineDiff=M(o.maxComputationTime),this.continueCharDiff=M(o.maxComputationTime===0?0:Math.min(o.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const b=e(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),s=b.changes,o=b.quitEarly;if(this.shouldIgnoreTrimWhitespace){const y=[];for(let E=0,R=s.length;E<R;E++)y.push(f.createFromDiffResult(this.shouldIgnoreTrimWhitespace,s[E],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:o,changes:y}}const p=[];let w=0,N=0;for(let y=-1,E=s.length;y<E;y++){const R=y+1<E?s[y+1]:null,x=R?R.originalStart:this.originalLines.length,P=R?R.modifiedStart:this.modifiedLines.length;for(;w<x&&N<P;){const F=this.originalLines[w],I=this.modifiedLines[N];if(F!==I){{let V=_(F,1),$=_(I,1);for(;V>1&&$>1;){const T=F.charCodeAt(V-2),O=I.charCodeAt($-2);if(T!==O)break;V--,$--}(V>1||$>1)&&this._pushTrimWhitespaceCharChange(p,w+1,1,V,N+1,1,$)}{let V=S(F,1),$=S(I,1);const T=F.length+1,O=I.length+1;for(;V<T&&$<O;){const B=F.charCodeAt(V-1),z=F.charCodeAt($-1);if(B!==z)break;V++,$++}(V<T||$<O)&&this._pushTrimWhitespaceCharChange(p,w+1,V,T,N+1,$,O)}}w++,N++}R&&(p.push(f.createFromDiffResult(this.shouldIgnoreTrimWhitespace,R,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),w+=R.originalLength,N+=R.modifiedLength)}return{quitEarly:o,changes:p}}_pushTrimWhitespaceCharChange(b,s,o,p,w,N,y){if(this._mergeTrimWhitespaceCharChange(b,s,o,p,w,N,y))return;let E;this.shouldComputeCharChanges&&(E=[new u(s,o,s,p,w,N,w,y)]),b.push(new f(s,s,w,w,E))}_mergeTrimWhitespaceCharChange(b,s,o,p,w,N,y){const E=b.length;if(E===0)return!1;const R=b[E-1];return R.originalEndLineNumber===0||R.modifiedEndLineNumber===0?!1:R.originalEndLineNumber===s&&R.modifiedEndLineNumber===w?(this.shouldComputeCharChanges&&R.charChanges&&R.charChanges.push(new u(s,o,s,p,w,N,w,y)),!0):R.originalEndLineNumber+1===s&&R.modifiedEndLineNumber+1===w?(R.originalEndLineNumber=s,R.modifiedEndLineNumber=w,this.shouldComputeCharChanges&&R.charChanges&&R.charChanges.push(new u(s,o,s,p,w,N,w,y)),!0):!1}}n.DiffComputer=C;function _(L,b){const s=m.firstNonWhitespaceIndex(L);return s===-1?b:s+1}function S(L,b){const s=m.lastNonWhitespaceIndex(L);return s===-1?b:s+2}function M(L){if(L===0)return()=>!0;const b=Date.now();return()=>Date.now()-b<L}}),Y(J[55],Z([0,1,54,53]),function(W,n,r,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.linesDiffComputers=void 0,n.linesDiffComputers={getLegacy:()=>new r.LegacyLinesDiffComputer,getDefault:()=>new D.DefaultLinesDiffComputer}}),Y(J[56],Z([0,1,35]),function(W,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeDefaultDocumentColors=e;function D(c){const i=[];for(const u of c){const d=Number(u);(d||d===0&&u.replace(/\s/g,"")!=="")&&i.push(d)}return i}function A(c,i,u,d){return{red:c/255,blue:u/255,green:i/255,alpha:d}}function m(c,i){const u=i.index,d=i[0].length;if(!u)return;const f=c.positionAt(u);return{startLineNumber:f.lineNumber,startColumn:f.column,endLineNumber:f.lineNumber,endColumn:f.column+d}}function h(c,i){if(!c)return;const u=r.Color.Format.CSS.parseHex(i);if(u)return{range:c,color:A(u.rgba.r,u.rgba.g,u.rgba.b,u.rgba.a)}}function v(c,i,u){if(!c||i.length!==1)return;const f=i[0].values(),C=D(f);return{range:c,color:A(C[0],C[1],C[2],u?C[3]:1)}}function l(c,i,u){if(!c||i.length!==1)return;const f=i[0].values(),C=D(f),_=new r.Color(new r.HSLA(C[0],C[1]/100,C[2]/100,u?C[3]:1));return{range:c,color:A(_.rgba.r,_.rgba.g,_.rgba.b,_.rgba.a)}}function a(c,i){return typeof c=="string"?[...c.matchAll(i)]:c.findMatches(i)}function g(c){const i=[],d=a(c,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(d.length>0)for(const f of d){const C=f.filter(L=>L!==void 0),_=C[1],S=C[2];if(!S)continue;let M;if(_==="rgb"){const L=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;M=v(m(c,f),a(S,L),!1)}else if(_==="rgba"){const L=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;M=v(m(c,f),a(S,L),!0)}else if(_==="hsl"){const L=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;M=l(m(c,f),a(S,L),!1)}else if(_==="hsla"){const L=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;M=l(m(c,f),a(S,L),!0)}else _==="#"&&(M=h(m(c,f),_+S));M&&i.push(M)}return i}function e(c){return!c||typeof c.getValue!="function"||typeof c.positionAt!="function"?[]:g(c)}}),Y(J[57],Z([0,1,28]),function(W,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkComputer=n.StateMachine=void 0,n.computeLinks=g;class D{constructor(c,i,u){const d=new Uint8Array(c*i);for(let f=0,C=c*i;f<C;f++)d[f]=u;this._data=d,this.rows=c,this.cols=i}get(c,i){return this._data[c*this.cols+i]}set(c,i,u){this._data[c*this.cols+i]=u}}class A{constructor(c){let i=0,u=0;for(let f=0,C=c.length;f<C;f++){const[_,S,M]=c[f];S>i&&(i=S),_>u&&(u=_),M>u&&(u=M)}i++,u++;const d=new D(u,i,0);for(let f=0,C=c.length;f<C;f++){const[_,S,M]=c[f];d.set(_,S,M)}this._states=d,this._maxCharCode=i}nextState(c,i){return i<0||i>=this._maxCharCode?0:this._states.get(c,i)}}n.StateMachine=A;let m=null;function h(){return m===null&&(m=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),m}let v=null;function l(){if(v===null){v=new r.CharacterClassifier(0);const e=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let i=0;i<e.length;i++)v.set(e.charCodeAt(i),1);const c=".,;:";for(let i=0;i<c.length;i++)v.set(c.charCodeAt(i),2)}return v}class a{static _createLink(c,i,u,d,f){let C=f-1;do{const _=i.charCodeAt(C);if(c.get(_)!==2)break;C--}while(C>d);if(d>0){const _=i.charCodeAt(d-1),S=i.charCodeAt(C);(_===40&&S===41||_===91&&S===93||_===123&&S===125)&&C--}return{range:{startLineNumber:u,startColumn:d+1,endLineNumber:u,endColumn:C+2},url:i.substring(d,C+1)}}static computeLinks(c,i=h()){const u=l(),d=[];for(let f=1,C=c.getLineCount();f<=C;f++){const _=c.getLineContent(f),S=_.length;let M=0,L=0,b=0,s=1,o=!1,p=!1,w=!1,N=!1;for(;M<S;){let y=!1;const E=_.charCodeAt(M);if(s===13){let R;switch(E){case 40:o=!0,R=0;break;case 41:R=o?0:1;break;case 91:w=!0,p=!0,R=0;break;case 93:w=!1,R=p?0:1;break;case 123:N=!0,R=0;break;case 125:R=N?0:1;break;case 39:case 34:case 96:b===E?R=1:b===39||b===34||b===96?R=0:R=1;break;case 42:R=b===42?1:0;break;case 124:R=b===124?1:0;break;case 32:R=w?0:1;break;default:R=u.get(E)}R===1&&(d.push(a._createLink(u,_,f,L,M)),y=!0)}else if(s===12){let R;E===91?(p=!0,R=0):R=u.get(E),R===1?y=!0:s=13}else s=i.nextState(s,E),s===0&&(y=!0);y&&(s=1,o=!1,p=!1,N=!1,L=M+1,b=E),M++}s===13&&d.push(a._createLink(u,_,f,L,S))}return d}}n.LinkComputer=a;function g(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:a.computeLinks(e)}}),Y(J[58],Z([0,1]),function(W,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class r{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(A,m,h,v,l){if(A&&m){const a=this.doNavigateValueSet(m,l);if(a)return{range:A,value:a}}if(h&&v){const a=this.doNavigateValueSet(v,l);if(a)return{range:h,value:a}}return null}doNavigateValueSet(A,m){const h=this.numberReplace(A,m);return h!==null?h:this.textReplace(A,m)}numberReplace(A,m){const h=Math.pow(10,A.length-(A.lastIndexOf(".")+1));let v=Number(A);const l=parseFloat(A);return!isNaN(v)&&!isNaN(l)&&v===l?v===0&&!m?null:(v=Math.floor(v*h),v+=m?h:-h,String(v/h)):null}textReplace(A,m){return this.valueSetsReplace(this._defaultValueSet,A,m)}valueSetsReplace(A,m,h){let v=null;for(let l=0,a=A.length;v===null&&l<a;l++)v=this.valueSetReplace(A[l],m,h);return v}valueSetReplace(A,m,h){let v=A.indexOf(m);return v>=0?(v+=h?1:-1,v<0?v=A.length-1:v%=A.length,A[v]):null}}n.BasicInplaceReplace=r,r.INSTANCE=new r}),Y(J[59],Z([0,1,15]),function(W,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ApplyEditsResult=n.SearchData=n.ValidAnnotatedEditOperation=n.FindMatch=n.TextModelResolvedOptions=n.InjectedTextCursorStops=n.GlyphMarginLane=n.OverviewRulerLane=void 0,n.isITextSnapshot=l,n.shouldSynchronizeModel=c;var D;(function(i){i[i.Left=1]="Left",i[i.Center=2]="Center",i[i.Right=4]="Right",i[i.Full=7]="Full"})(D||(n.OverviewRulerLane=D={}));var A;(function(i){i[i.Left=1]="Left",i[i.Center=2]="Center",i[i.Right=3]="Right"})(A||(n.GlyphMarginLane=A={}));var m;(function(i){i[i.Both=0]="Both",i[i.Right=1]="Right",i[i.Left=2]="Left",i[i.None=3]="None"})(m||(n.InjectedTextCursorStops=m={}));class h{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(u){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,u.tabSize|0),u.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,u.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!u.insertSpaces,this.defaultEOL=u.defaultEOL|0,this.trimAutoWhitespace=!!u.trimAutoWhitespace,this.bracketPairColorizationOptions=u.bracketPairColorizationOptions}equals(u){return this.tabSize===u.tabSize&&this._indentSizeIsTabSize===u._indentSizeIsTabSize&&this.indentSize===u.indentSize&&this.insertSpaces===u.insertSpaces&&this.defaultEOL===u.defaultEOL&&this.trimAutoWhitespace===u.trimAutoWhitespace&&(0,r.equals)(this.bracketPairColorizationOptions,u.bracketPairColorizationOptions)}createChangeEvent(u){return{tabSize:this.tabSize!==u.tabSize,indentSize:this.indentSize!==u.indentSize,insertSpaces:this.insertSpaces!==u.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==u.trimAutoWhitespace}}}n.TextModelResolvedOptions=h;class v{constructor(u,d){this._findMatchBrand=void 0,this.range=u,this.matches=d}}n.FindMatch=v;function l(i){return i&&typeof i.read=="function"}class a{constructor(u,d,f,C,_,S){this.identifier=u,this.range=d,this.text=f,this.forceMoveMarkers=C,this.isAutoWhitespaceEdit=_,this._isTracked=S}}n.ValidAnnotatedEditOperation=a;class g{constructor(u,d,f){this.regex=u,this.wordSeparators=d,this.simpleSearch=f}}n.SearchData=g;class e{constructor(u,d,f){this.reverseEdits=u,this.changes=d,this.trimAutoWhitespaceLineNumbers=f}}n.ApplyEditsResult=e;function c(i){return!i.isTooLargeForSyncing()&&!i.isForSimpleWidget}}),Y(J[60],Z([0,1,7,27]),function(W,n,r,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class A{constructor(l){this.values=l,this.prefixSum=new Uint32Array(l.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}insertValues(l,a){l=(0,D.toUint32)(l);const g=this.values,e=this.prefixSum,c=a.length;return c===0?!1:(this.values=new Uint32Array(g.length+c),this.values.set(g.subarray(0,l),0),this.values.set(g.subarray(l),l+c),this.values.set(a,l),l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(l,a){return l=(0,D.toUint32)(l),a=(0,D.toUint32)(a),this.values[l]===a?!1:(this.values[l]=a,l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),!0)}removeValues(l,a){l=(0,D.toUint32)(l),a=(0,D.toUint32)(a);const g=this.values,e=this.prefixSum;if(l>=g.length)return!1;const c=g.length-l;return a>=c&&(a=c),a===0?!1:(this.values=new Uint32Array(g.length-a),this.values.set(g.subarray(0,l),0),this.values.set(g.subarray(l+a),l),this.prefixSum=new Uint32Array(this.values.length),l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(l){return l<0?0:(l=(0,D.toUint32)(l),this._getPrefixSum(l))}_getPrefixSum(l){if(l<=this.prefixSumValidIndex[0])return this.prefixSum[l];let a=this.prefixSumValidIndex[0]+1;a===0&&(this.prefixSum[0]=this.values[0],a++),l>=this.values.length&&(l=this.values.length-1);for(let g=a;g<=l;g++)this.prefixSum[g]=this.prefixSum[g-1]+this.values[g];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],l),this.prefixSum[l]}getIndexOf(l){l=Math.floor(l),this.getTotalSum();let a=0,g=this.values.length-1,e=0,c=0,i=0;for(;a<=g;)if(e=a+(g-a)/2|0,c=this.prefixSum[e],i=c-this.values[e],l<i)g=e-1;else if(l>=c)a=e+1;else break;return new h(e,l-i)}}n.PrefixSumComputer=A;class m{constructor(l){this._values=l,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(l){return this._ensureValid(),l===0?0:this._prefixSum[l-1]}getIndexOf(l){this._ensureValid();const a=this._indexBySum[l],g=a>0?this._prefixSum[a-1]:0;return new h(a,l-g)}removeValues(l,a){this._values.splice(l,a),this._invalidate(l)}insertValues(l,a){this._values=(0,r.arrayInsert)(this._values,l,a),this._invalidate(l)}_invalidate(l){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,l-1)}_ensureValid(){if(!this._isValid){for(let l=this._validEndIndex+1,a=this._values.length;l<a;l++){const g=this._values[l],e=l>0?this._prefixSum[l-1]:0;this._prefixSum[l]=e+g;for(let c=0;c<g;c++)this._indexBySum[e+c]=l}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(l,a){this._values[l]!==a&&(this._values[l]=a,this._invalidate(l))}}n.ConstantTimePrefixSumComputer=m;class h{constructor(l,a){this.index=l,this.remainder=a,this._prefixSumIndexOfResultBrand=void 0,this.index=l,this.remainder=a}}n.PrefixSumIndexOfResult=h}),Y(J[61],Z([0,1,6,4,60]),function(W,n,r,D,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class m{constructor(v,l,a,g){this._uri=v,this._lines=l,this._eol=a,this._versionId=g,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(v){v.eol&&v.eol!==this._eol&&(this._eol=v.eol,this._lineStarts=null);const l=v.changes;for(const a of l)this._acceptDeleteRange(a.range),this._acceptInsertText(new D.Position(a.range.startLineNumber,a.range.startColumn),a.text);this._versionId=v.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const v=this._eol.length,l=this._lines.length,a=new Uint32Array(l);for(let g=0;g<l;g++)a[g]=this._lines[g].length+v;this._lineStarts=new A.PrefixSumComputer(a)}}_setLineText(v,l){this._lines[v]=l,this._lineStarts&&this._lineStarts.setValue(v,this._lines[v].length+this._eol.length)}_acceptDeleteRange(v){if(v.startLineNumber===v.endLineNumber){if(v.startColumn===v.endColumn)return;this._setLineText(v.startLineNumber-1,this._lines[v.startLineNumber-1].substring(0,v.startColumn-1)+this._lines[v.startLineNumber-1].substring(v.endColumn-1));return}this._setLineText(v.startLineNumber-1,this._lines[v.startLineNumber-1].substring(0,v.startColumn-1)+this._lines[v.endLineNumber-1].substring(v.endColumn-1)),this._lines.splice(v.startLineNumber,v.endLineNumber-v.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(v.startLineNumber,v.endLineNumber-v.startLineNumber)}_acceptInsertText(v,l){if(l.length===0)return;const a=(0,r.splitLines)(l);if(a.length===1){this._setLineText(v.lineNumber-1,this._lines[v.lineNumber-1].substring(0,v.column-1)+a[0]+this._lines[v.lineNumber-1].substring(v.column-1));return}a[a.length-1]+=this._lines[v.lineNumber-1].substring(v.column-1),this._setLineText(v.lineNumber-1,this._lines[v.lineNumber-1].substring(0,v.column-1)+a[0]);const g=new Uint32Array(a.length-1);for(let e=1;e<a.length;e++)this._lines.splice(v.lineNumber+e-1,0,a[e]),g[e-1]=a[e].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(v.lineNumber,g)}}n.MirrorTextModel=m}),Y(J[62],Z([0,1,6,48,4,2,59]),function(W,n,r,D,A,m,h){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Searcher=n.TextModelSearch=n.SearchParams=void 0,n.isMultilineRegexSource=a,n.createFindMatch=g,n.isValidMatch=d;const v=999;class l{constructor(_,S,M,L){this.searchString=_,this.isRegex=S,this.matchCase=M,this.wordSeparators=L}parseSearchRequest(){if(this.searchString==="")return null;let _;this.isRegex?_=a(this.searchString):_=this.searchString.indexOf(`
`)>=0;let S=null;try{S=r.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:_,global:!0,unicode:!0})}catch{return null}if(!S)return null;let M=!this.isRegex&&!_;return M&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(M=this.matchCase),new h.SearchData(S,this.wordSeparators?(0,D.getMapForWordSeparators)(this.wordSeparators,[]):null,M?this.searchString:null)}}n.SearchParams=l;function a(C){if(!C||C.length===0)return!1;for(let _=0,S=C.length;_<S;_++){const M=C.charCodeAt(_);if(M===10)return!0;if(M===92){if(_++,_>=S)break;const L=C.charCodeAt(_);if(L===110||L===114||L===87)return!0}}return!1}function g(C,_,S){if(!S)return new h.FindMatch(C,null);const M=[];for(let L=0,b=_.length;L<b;L++)M[L]=_[L];return new h.FindMatch(C,M)}class e{constructor(_){const S=[];let M=0;for(let L=0,b=_.length;L<b;L++)_.charCodeAt(L)===10&&(S[M++]=L);this._lineFeedsOffsets=S}findLineFeedCountBeforeOffset(_){const S=this._lineFeedsOffsets;let M=0,L=S.length-1;if(L===-1||_<=S[0])return 0;for(;M<L;){const b=M+((L-M)/2>>0);S[b]>=_?L=b-1:S[b+1]>=_?(M=b,L=b):M=b+1}return M+1}}class c{static findMatches(_,S,M,L,b){const s=S.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(_,M,new f(s.wordSeparators,s.regex),L,b):this._doFindMatchesLineByLine(_,M,s,L,b):[]}static _getMultilineMatchRange(_,S,M,L,b,s){let o,p=0;L?(p=L.findLineFeedCountBeforeOffset(b),o=S+b+p):o=S+b;let w;if(L){const R=L.findLineFeedCountBeforeOffset(b+s.length)-p;w=o+s.length+R}else w=o+s.length;const N=_.getPositionAt(o),y=_.getPositionAt(w);return new m.Range(N.lineNumber,N.column,y.lineNumber,y.column)}static _doFindMatchesMultiline(_,S,M,L,b){const s=_.getOffsetAt(S.getStartPosition()),o=_.getValueInRange(S,1),p=_.getEOL()===`\r
`?new e(o):null,w=[];let N=0,y;for(M.reset(0);y=M.next(o);)if(w[N++]=g(this._getMultilineMatchRange(_,s,o,p,y.index,y[0]),y,L),N>=b)return w;return w}static _doFindMatchesLineByLine(_,S,M,L,b){const s=[];let o=0;if(S.startLineNumber===S.endLineNumber){const w=_.getLineContent(S.startLineNumber).substring(S.startColumn-1,S.endColumn-1);return o=this._findMatchesInLine(M,w,S.startLineNumber,S.startColumn-1,o,s,L,b),s}const p=_.getLineContent(S.startLineNumber).substring(S.startColumn-1);o=this._findMatchesInLine(M,p,S.startLineNumber,S.startColumn-1,o,s,L,b);for(let w=S.startLineNumber+1;w<S.endLineNumber&&o<b;w++)o=this._findMatchesInLine(M,_.getLineContent(w),w,0,o,s,L,b);if(o<b){const w=_.getLineContent(S.endLineNumber).substring(0,S.endColumn-1);o=this._findMatchesInLine(M,w,S.endLineNumber,0,o,s,L,b)}return s}static _findMatchesInLine(_,S,M,L,b,s,o,p){const w=_.wordSeparators;if(!o&&_.simpleSearch){const E=_.simpleSearch,R=E.length,x=S.length;let P=-R;for(;(P=S.indexOf(E,P+R))!==-1;)if((!w||d(w,S,x,P,R))&&(s[b++]=new h.FindMatch(new m.Range(M,P+1+L,M,P+1+R+L),null),b>=p))return b;return b}const N=new f(_.wordSeparators,_.regex);let y;N.reset(0);do if(y=N.next(S),y&&(s[b++]=g(new m.Range(M,y.index+1+L,M,y.index+1+y[0].length+L),y,o),b>=p))return b;while(y);return b}static findNextMatch(_,S,M,L){const b=S.parseSearchRequest();if(!b)return null;const s=new f(b.wordSeparators,b.regex);return b.regex.multiline?this._doFindNextMatchMultiline(_,M,s,L):this._doFindNextMatchLineByLine(_,M,s,L)}static _doFindNextMatchMultiline(_,S,M,L){const b=new A.Position(S.lineNumber,1),s=_.getOffsetAt(b),o=_.getLineCount(),p=_.getValueInRange(new m.Range(b.lineNumber,b.column,o,_.getLineMaxColumn(o)),1),w=_.getEOL()===`\r
`?new e(p):null;M.reset(S.column-1);const N=M.next(p);return N?g(this._getMultilineMatchRange(_,s,p,w,N.index,N[0]),N,L):S.lineNumber!==1||S.column!==1?this._doFindNextMatchMultiline(_,new A.Position(1,1),M,L):null}static _doFindNextMatchLineByLine(_,S,M,L){const b=_.getLineCount(),s=S.lineNumber,o=_.getLineContent(s),p=this._findFirstMatchInLine(M,o,s,S.column,L);if(p)return p;for(let w=1;w<=b;w++){const N=(s+w-1)%b,y=_.getLineContent(N+1),E=this._findFirstMatchInLine(M,y,N+1,1,L);if(E)return E}return null}static _findFirstMatchInLine(_,S,M,L,b){_.reset(L-1);const s=_.next(S);return s?g(new m.Range(M,s.index+1,M,s.index+1+s[0].length),s,b):null}static findPreviousMatch(_,S,M,L){const b=S.parseSearchRequest();if(!b)return null;const s=new f(b.wordSeparators,b.regex);return b.regex.multiline?this._doFindPreviousMatchMultiline(_,M,s,L):this._doFindPreviousMatchLineByLine(_,M,s,L)}static _doFindPreviousMatchMultiline(_,S,M,L){const b=this._doFindMatchesMultiline(_,new m.Range(1,1,S.lineNumber,S.column),M,L,10*v);if(b.length>0)return b[b.length-1];const s=_.getLineCount();return S.lineNumber!==s||S.column!==_.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(_,new A.Position(s,_.getLineMaxColumn(s)),M,L):null}static _doFindPreviousMatchLineByLine(_,S,M,L){const b=_.getLineCount(),s=S.lineNumber,o=_.getLineContent(s).substring(0,S.column-1),p=this._findLastMatchInLine(M,o,s,L);if(p)return p;for(let w=1;w<=b;w++){const N=(b+s-w-1)%b,y=_.getLineContent(N+1),E=this._findLastMatchInLine(M,y,N+1,L);if(E)return E}return null}static _findLastMatchInLine(_,S,M,L){let b=null,s;for(_.reset(0);s=_.next(S);)b=g(new m.Range(M,s.index+1,M,s.index+1+s[0].length),s,L);return b}}n.TextModelSearch=c;function i(C,_,S,M,L){if(M===0)return!0;const b=_.charCodeAt(M-1);if(C.get(b)!==0||b===13||b===10)return!0;if(L>0){const s=_.charCodeAt(M);if(C.get(s)!==0)return!0}return!1}function u(C,_,S,M,L){if(M+L===S)return!0;const b=_.charCodeAt(M+L);if(C.get(b)!==0||b===13||b===10)return!0;if(L>0){const s=_.charCodeAt(M+L-1);if(C.get(s)!==0)return!0}return!1}function d(C,_,S,M,L){return i(C,_,S,M,L)&&u(C,_,S,M,L)}class f{constructor(_,S){this._wordSeparators=_,this._searchRegex=S,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(_){this._searchRegex.lastIndex=_,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(_){const S=_.length;let M;do{if(this._prevMatchStartIndex+this._prevMatchLength===S||(M=this._searchRegex.exec(_),!M))return null;const L=M.index,b=M[0].length;if(L===this._prevMatchStartIndex&&b===this._prevMatchLength){if(b===0){r.getNextCodePoint(_,S,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=L,this._prevMatchLength=b,!this._wordSeparators||d(this._wordSeparators,_,S,L,b))return M}while(M);return null}}n.Searcher=f}),Y(J[63],Z([0,1]),function(W,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.findSectionHeaders=A;const r=new RegExp("\\bMARK:\\s*(.*)$","d"),D=/^-+|-+$/g;function A(a,g){var e;let c=[];if(g.findRegionSectionHeaders&&(!((e=g.foldingRules)===null||e===void 0)&&e.markers)){const i=m(a,g);c=c.concat(i)}if(g.findMarkSectionHeaders){const i=h(a);c=c.concat(i)}return c}function m(a,g){const e=[],c=a.getLineCount();for(let i=1;i<=c;i++){const u=a.getLineContent(i),d=u.match(g.foldingRules.markers.start);if(d){const f={startLineNumber:i,startColumn:d[0].length+1,endLineNumber:i,endColumn:u.length+1};if(f.endColumn>f.startColumn){const C={range:f,...l(u.substring(d[0].length)),shouldBeInComments:!1};(C.text||C.hasSeparatorLine)&&e.push(C)}}}return e}function h(a){const g=[],e=a.getLineCount();for(let c=1;c<=e;c++){const i=a.getLineContent(c);v(i,c,g)}return g}function v(a,g,e){r.lastIndex=0;const c=r.exec(a);if(c){const i=c.indices[1][0]+1,u=c.indices[1][1]+1,d={startLineNumber:g,startColumn:i,endLineNumber:g,endColumn:u};if(d.endColumn>d.startColumn){const f={range:d,...l(c[1]),shouldBeInComments:!0};(f.text||f.hasSeparatorLine)&&e.push(f)}}}function l(a){a=a.trim();const g=a.startsWith("-");return a=a.replace(D,""),{text:a,hasSeparatorLine:g}}}),Y(J[64],Z([0,1,2,62,6,9,30]),function(W,n,r,D,A,m,h){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.UnicodeTextModelHighlighter=void 0;class v{static computeUnicodeHighlights(c,i,u){const d=u?u.startLineNumber:1,f=u?u.endLineNumber:c.getLineCount(),C=new a(i),_=C.getCandidateCodePoints();let S;_==="allNonBasicAscii"?S=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):S=new RegExp(`${l(Array.from(_))}`,"g");const M=new D.Searcher(null,S),L=[];let b=!1,s,o=0,p=0,w=0;e:for(let N=d,y=f;N<=y;N++){const E=c.getLineContent(N),R=E.length;M.reset(0);do if(s=M.next(E),s){let x=s.index,P=s.index+s[0].length;if(x>0){const $=E.charCodeAt(x-1);A.isHighSurrogate($)&&x--}if(P+1<R){const $=E.charCodeAt(P-1);A.isHighSurrogate($)&&P++}const F=E.substring(x,P);let I=(0,h.getWordAtText)(x+1,h.DEFAULT_WORD_REGEXP,E,0);I&&I.endColumn<=x+1&&(I=null);const V=C.shouldHighlightNonBasicASCII(F,I?I.word:null);if(V!==0){if(V===3?o++:V===2?p++:V===1?w++:(0,m.assertNever)(V),L.length>=1e3){b=!0;break e}L.push(new r.Range(N,x+1,N,P+1))}}while(s)}return{ranges:L,hasMore:b,ambiguousCharacterCount:o,invisibleCharacterCount:p,nonBasicAsciiCharacterCount:w}}static computeUnicodeHighlightReason(c,i){const u=new a(i);switch(u.shouldHighlightNonBasicASCII(c,null)){case 0:return null;case 2:return{kind:1};case 3:{const f=c.codePointAt(0),C=u.ambiguousCharacters.getPrimaryConfusable(f),_=A.AmbiguousCharacters.getLocales().filter(S=>!A.AmbiguousCharacters.getInstance(new Set([...i.allowedLocales,S])).isAmbiguous(f));return{kind:0,confusableWith:String.fromCodePoint(C),notAmbiguousInLocales:_}}case 1:return{kind:2}}}}n.UnicodeTextModelHighlighter=v;function l(e,c){return`[${A.escapeRegExpCharacters(e.map(u=>String.fromCodePoint(u)).join(""))}]`}class a{constructor(c){this.options=c,this.allowedCodePoints=new Set(c.allowedCodePoints),this.ambiguousCharacters=A.AmbiguousCharacters.getInstance(new Set(c.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const c=new Set;if(this.options.invisibleCharacters)for(const i of A.InvisibleCharacters.codePoints)g(String.fromCodePoint(i))||c.add(i);if(this.options.ambiguousCharacters)for(const i of this.ambiguousCharacters.getConfusableCodePoints())c.add(i);for(const i of this.allowedCodePoints)c.delete(i);return c}shouldHighlightNonBasicASCII(c,i){const u=c.codePointAt(0);if(this.allowedCodePoints.has(u))return 0;if(this.options.nonBasicASCII)return 1;let d=!1,f=!1;if(i)for(const C of i){const _=C.codePointAt(0),S=A.isBasicASCII(C);d=d||S,!S&&!this.ambiguousCharacters.isAmbiguous(_)&&!A.InvisibleCharacters.isInvisibleCharacter(_)&&(f=!0)}return!d&&f?0:this.options.invisibleCharacters&&!g(c)&&A.InvisibleCharacters.isInvisibleCharacter(u)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(u)?3:0}}function g(e){return e===" "||e===`
`||e==="	"}}),Y(J[65],Z([0,1]),function(W,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.ShowLightbulbIconMode=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.PositionAffinity=n.PartialAcceptTriggerKind=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.NewSymbolNameTriggerKind=n.NewSymbolNameTag=n.MouseTargetType=n.MinimapSectionHeaderStyle=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineEditTriggerKind=n.InlineCompletionTriggerKind=n.InlayHintKind=n.InjectedTextCursorStops=n.IndentAction=n.HoverVerbosityAction=n.GlyphMarginLane=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.CodeActionTriggerType=n.AccessibilitySupport=void 0;var r;(function(t){t[t.Unknown=0]="Unknown",t[t.Disabled=1]="Disabled",t[t.Enabled=2]="Enabled"})(r||(n.AccessibilitySupport=r={}));var D;(function(t){t[t.Invoke=1]="Invoke",t[t.Auto=2]="Auto"})(D||(n.CodeActionTriggerType=D={}));var A;(function(t){t[t.None=0]="None",t[t.KeepWhitespace=1]="KeepWhitespace",t[t.InsertAsSnippet=4]="InsertAsSnippet"})(A||(n.CompletionItemInsertTextRule=A={}));var m;(function(t){t[t.Method=0]="Method",t[t.Function=1]="Function",t[t.Constructor=2]="Constructor",t[t.Field=3]="Field",t[t.Variable=4]="Variable",t[t.Class=5]="Class",t[t.Struct=6]="Struct",t[t.Interface=7]="Interface",t[t.Module=8]="Module",t[t.Property=9]="Property",t[t.Event=10]="Event",t[t.Operator=11]="Operator",t[t.Unit=12]="Unit",t[t.Value=13]="Value",t[t.Constant=14]="Constant",t[t.Enum=15]="Enum",t[t.EnumMember=16]="EnumMember",t[t.Keyword=17]="Keyword",t[t.Text=18]="Text",t[t.Color=19]="Color",t[t.File=20]="File",t[t.Reference=21]="Reference",t[t.Customcolor=22]="Customcolor",t[t.Folder=23]="Folder",t[t.TypeParameter=24]="TypeParameter",t[t.User=25]="User",t[t.Issue=26]="Issue",t[t.Snippet=27]="Snippet"})(m||(n.CompletionItemKind=m={}));var h;(function(t){t[t.Deprecated=1]="Deprecated"})(h||(n.CompletionItemTag=h={}));var v;(function(t){t[t.Invoke=0]="Invoke",t[t.TriggerCharacter=1]="TriggerCharacter",t[t.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v||(n.CompletionTriggerKind=v={}));var l;(function(t){t[t.EXACT=0]="EXACT",t[t.ABOVE=1]="ABOVE",t[t.BELOW=2]="BELOW"})(l||(n.ContentWidgetPositionPreference=l={}));var a;(function(t){t[t.NotSet=0]="NotSet",t[t.ContentFlush=1]="ContentFlush",t[t.RecoverFromMarkers=2]="RecoverFromMarkers",t[t.Explicit=3]="Explicit",t[t.Paste=4]="Paste",t[t.Undo=5]="Undo",t[t.Redo=6]="Redo"})(a||(n.CursorChangeReason=a={}));var g;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(g||(n.DefaultEndOfLine=g={}));var e;(function(t){t[t.Text=0]="Text",t[t.Read=1]="Read",t[t.Write=2]="Write"})(e||(n.DocumentHighlightKind=e={}));var c;(function(t){t[t.None=0]="None",t[t.Keep=1]="Keep",t[t.Brackets=2]="Brackets",t[t.Advanced=3]="Advanced",t[t.Full=4]="Full"})(c||(n.EditorAutoIndentStrategy=c={}));var i;(function(t){t[t.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",t[t.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",t[t.accessibilitySupport=2]="accessibilitySupport",t[t.accessibilityPageSize=3]="accessibilityPageSize",t[t.ariaLabel=4]="ariaLabel",t[t.ariaRequired=5]="ariaRequired",t[t.autoClosingBrackets=6]="autoClosingBrackets",t[t.autoClosingComments=7]="autoClosingComments",t[t.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",t[t.autoClosingDelete=9]="autoClosingDelete",t[t.autoClosingOvertype=10]="autoClosingOvertype",t[t.autoClosingQuotes=11]="autoClosingQuotes",t[t.autoIndent=12]="autoIndent",t[t.automaticLayout=13]="automaticLayout",t[t.autoSurround=14]="autoSurround",t[t.bracketPairColorization=15]="bracketPairColorization",t[t.guides=16]="guides",t[t.codeLens=17]="codeLens",t[t.codeLensFontFamily=18]="codeLensFontFamily",t[t.codeLensFontSize=19]="codeLensFontSize",t[t.colorDecorators=20]="colorDecorators",t[t.colorDecoratorsLimit=21]="colorDecoratorsLimit",t[t.columnSelection=22]="columnSelection",t[t.comments=23]="comments",t[t.contextmenu=24]="contextmenu",t[t.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",t[t.cursorBlinking=26]="cursorBlinking",t[t.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",t[t.cursorStyle=28]="cursorStyle",t[t.cursorSurroundingLines=29]="cursorSurroundingLines",t[t.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",t[t.cursorWidth=31]="cursorWidth",t[t.disableLayerHinting=32]="disableLayerHinting",t[t.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",t[t.domReadOnly=34]="domReadOnly",t[t.dragAndDrop=35]="dragAndDrop",t[t.dropIntoEditor=36]="dropIntoEditor",t[t.emptySelectionClipboard=37]="emptySelectionClipboard",t[t.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",t[t.extraEditorClassName=39]="extraEditorClassName",t[t.fastScrollSensitivity=40]="fastScrollSensitivity",t[t.find=41]="find",t[t.fixedOverflowWidgets=42]="fixedOverflowWidgets",t[t.folding=43]="folding",t[t.foldingStrategy=44]="foldingStrategy",t[t.foldingHighlight=45]="foldingHighlight",t[t.foldingImportsByDefault=46]="foldingImportsByDefault",t[t.foldingMaximumRegions=47]="foldingMaximumRegions",t[t.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",t[t.fontFamily=49]="fontFamily",t[t.fontInfo=50]="fontInfo",t[t.fontLigatures=51]="fontLigatures",t[t.fontSize=52]="fontSize",t[t.fontWeight=53]="fontWeight",t[t.fontVariations=54]="fontVariations",t[t.formatOnPaste=55]="formatOnPaste",t[t.formatOnType=56]="formatOnType",t[t.glyphMargin=57]="glyphMargin",t[t.gotoLocation=58]="gotoLocation",t[t.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",t[t.hover=60]="hover",t[t.inDiffEditor=61]="inDiffEditor",t[t.inlineSuggest=62]="inlineSuggest",t[t.inlineEdit=63]="inlineEdit",t[t.letterSpacing=64]="letterSpacing",t[t.lightbulb=65]="lightbulb",t[t.lineDecorationsWidth=66]="lineDecorationsWidth",t[t.lineHeight=67]="lineHeight",t[t.lineNumbers=68]="lineNumbers",t[t.lineNumbersMinChars=69]="lineNumbersMinChars",t[t.linkedEditing=70]="linkedEditing",t[t.links=71]="links",t[t.matchBrackets=72]="matchBrackets",t[t.minimap=73]="minimap",t[t.mouseStyle=74]="mouseStyle",t[t.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",t[t.mouseWheelZoom=76]="mouseWheelZoom",t[t.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",t[t.multiCursorModifier=78]="multiCursorModifier",t[t.multiCursorPaste=79]="multiCursorPaste",t[t.multiCursorLimit=80]="multiCursorLimit",t[t.occurrencesHighlight=81]="occurrencesHighlight",t[t.overviewRulerBorder=82]="overviewRulerBorder",t[t.overviewRulerLanes=83]="overviewRulerLanes",t[t.padding=84]="padding",t[t.pasteAs=85]="pasteAs",t[t.parameterHints=86]="parameterHints",t[t.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",t[t.placeholder=88]="placeholder",t[t.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",t[t.quickSuggestions=90]="quickSuggestions",t[t.quickSuggestionsDelay=91]="quickSuggestionsDelay",t[t.readOnly=92]="readOnly",t[t.readOnlyMessage=93]="readOnlyMessage",t[t.renameOnType=94]="renameOnType",t[t.renderControlCharacters=95]="renderControlCharacters",t[t.renderFinalNewline=96]="renderFinalNewline",t[t.renderLineHighlight=97]="renderLineHighlight",t[t.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",t[t.renderValidationDecorations=99]="renderValidationDecorations",t[t.renderWhitespace=100]="renderWhitespace",t[t.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",t[t.roundedSelection=102]="roundedSelection",t[t.rulers=103]="rulers",t[t.scrollbar=104]="scrollbar",t[t.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",t[t.scrollBeyondLastLine=106]="scrollBeyondLastLine",t[t.scrollPredominantAxis=107]="scrollPredominantAxis",t[t.selectionClipboard=108]="selectionClipboard",t[t.selectionHighlight=109]="selectionHighlight",t[t.selectOnLineNumbers=110]="selectOnLineNumbers",t[t.showFoldingControls=111]="showFoldingControls",t[t.showUnused=112]="showUnused",t[t.snippetSuggestions=113]="snippetSuggestions",t[t.smartSelect=114]="smartSelect",t[t.smoothScrolling=115]="smoothScrolling",t[t.stickyScroll=116]="stickyScroll",t[t.stickyTabStops=117]="stickyTabStops",t[t.stopRenderingLineAfter=118]="stopRenderingLineAfter",t[t.suggest=119]="suggest",t[t.suggestFontSize=120]="suggestFontSize",t[t.suggestLineHeight=121]="suggestLineHeight",t[t.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",t[t.suggestSelection=123]="suggestSelection",t[t.tabCompletion=124]="tabCompletion",t[t.tabIndex=125]="tabIndex",t[t.unicodeHighlighting=126]="unicodeHighlighting",t[t.unusualLineTerminators=127]="unusualLineTerminators",t[t.useShadowDOM=128]="useShadowDOM",t[t.useTabStops=129]="useTabStops",t[t.wordBreak=130]="wordBreak",t[t.wordSegmenterLocales=131]="wordSegmenterLocales",t[t.wordSeparators=132]="wordSeparators",t[t.wordWrap=133]="wordWrap",t[t.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",t[t.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",t[t.wordWrapColumn=136]="wordWrapColumn",t[t.wordWrapOverride1=137]="wordWrapOverride1",t[t.wordWrapOverride2=138]="wordWrapOverride2",t[t.wrappingIndent=139]="wrappingIndent",t[t.wrappingStrategy=140]="wrappingStrategy",t[t.showDeprecated=141]="showDeprecated",t[t.inlayHints=142]="inlayHints",t[t.editorClassName=143]="editorClassName",t[t.pixelRatio=144]="pixelRatio",t[t.tabFocusMode=145]="tabFocusMode",t[t.layoutInfo=146]="layoutInfo",t[t.wrappingInfo=147]="wrappingInfo",t[t.defaultColorDecorators=148]="defaultColorDecorators",t[t.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",t[t.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(i||(n.EditorOption=i={}));var u;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(u||(n.EndOfLinePreference=u={}));var d;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(d||(n.EndOfLineSequence=d={}));var f;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=3]="Right"})(f||(n.GlyphMarginLane=f={}));var C;(function(t){t[t.Increase=0]="Increase",t[t.Decrease=1]="Decrease"})(C||(n.HoverVerbosityAction=C={}));var _;(function(t){t[t.None=0]="None",t[t.Indent=1]="Indent",t[t.IndentOutdent=2]="IndentOutdent",t[t.Outdent=3]="Outdent"})(_||(n.IndentAction=_={}));var S;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(S||(n.InjectedTextCursorStops=S={}));var M;(function(t){t[t.Type=1]="Type",t[t.Parameter=2]="Parameter"})(M||(n.InlayHintKind=M={}));var L;(function(t){t[t.Automatic=0]="Automatic",t[t.Explicit=1]="Explicit"})(L||(n.InlineCompletionTriggerKind=L={}));var b;(function(t){t[t.Invoke=0]="Invoke",t[t.Automatic=1]="Automatic"})(b||(n.InlineEditTriggerKind=b={}));var s;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.F20=78]="F20",t[t.F21=79]="F21",t[t.F22=80]="F22",t[t.F23=81]="F23",t[t.F24=82]="F24",t[t.NumLock=83]="NumLock",t[t.ScrollLock=84]="ScrollLock",t[t.Semicolon=85]="Semicolon",t[t.Equal=86]="Equal",t[t.Comma=87]="Comma",t[t.Minus=88]="Minus",t[t.Period=89]="Period",t[t.Slash=90]="Slash",t[t.Backquote=91]="Backquote",t[t.BracketLeft=92]="BracketLeft",t[t.Backslash=93]="Backslash",t[t.BracketRight=94]="BracketRight",t[t.Quote=95]="Quote",t[t.OEM_8=96]="OEM_8",t[t.IntlBackslash=97]="IntlBackslash",t[t.Numpad0=98]="Numpad0",t[t.Numpad1=99]="Numpad1",t[t.Numpad2=100]="Numpad2",t[t.Numpad3=101]="Numpad3",t[t.Numpad4=102]="Numpad4",t[t.Numpad5=103]="Numpad5",t[t.Numpad6=104]="Numpad6",t[t.Numpad7=105]="Numpad7",t[t.Numpad8=106]="Numpad8",t[t.Numpad9=107]="Numpad9",t[t.NumpadMultiply=108]="NumpadMultiply",t[t.NumpadAdd=109]="NumpadAdd",t[t.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=111]="NumpadSubtract",t[t.NumpadDecimal=112]="NumpadDecimal",t[t.NumpadDivide=113]="NumpadDivide",t[t.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",t[t.ABNT_C1=115]="ABNT_C1",t[t.ABNT_C2=116]="ABNT_C2",t[t.AudioVolumeMute=117]="AudioVolumeMute",t[t.AudioVolumeUp=118]="AudioVolumeUp",t[t.AudioVolumeDown=119]="AudioVolumeDown",t[t.BrowserSearch=120]="BrowserSearch",t[t.BrowserHome=121]="BrowserHome",t[t.BrowserBack=122]="BrowserBack",t[t.BrowserForward=123]="BrowserForward",t[t.MediaTrackNext=124]="MediaTrackNext",t[t.MediaTrackPrevious=125]="MediaTrackPrevious",t[t.MediaStop=126]="MediaStop",t[t.MediaPlayPause=127]="MediaPlayPause",t[t.LaunchMediaPlayer=128]="LaunchMediaPlayer",t[t.LaunchMail=129]="LaunchMail",t[t.LaunchApp2=130]="LaunchApp2",t[t.Clear=131]="Clear",t[t.MAX_VALUE=132]="MAX_VALUE"})(s||(n.KeyCode=s={}));var o;(function(t){t[t.Hint=1]="Hint",t[t.Info=2]="Info",t[t.Warning=4]="Warning",t[t.Error=8]="Error"})(o||(n.MarkerSeverity=o={}));var p;(function(t){t[t.Unnecessary=1]="Unnecessary",t[t.Deprecated=2]="Deprecated"})(p||(n.MarkerTag=p={}));var w;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(w||(n.MinimapPosition=w={}));var N;(function(t){t[t.Normal=1]="Normal",t[t.Underlined=2]="Underlined"})(N||(n.MinimapSectionHeaderStyle=N={}));var y;(function(t){t[t.UNKNOWN=0]="UNKNOWN",t[t.TEXTAREA=1]="TEXTAREA",t[t.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",t[t.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",t[t.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",t[t.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",t[t.CONTENT_TEXT=6]="CONTENT_TEXT",t[t.CONTENT_EMPTY=7]="CONTENT_EMPTY",t[t.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",t[t.CONTENT_WIDGET=9]="CONTENT_WIDGET",t[t.OVERVIEW_RULER=10]="OVERVIEW_RULER",t[t.SCROLLBAR=11]="SCROLLBAR",t[t.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",t[t.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(y||(n.MouseTargetType=y={}));var E;(function(t){t[t.AIGenerated=1]="AIGenerated"})(E||(n.NewSymbolNameTag=E={}));var R;(function(t){t[t.Invoke=0]="Invoke",t[t.Automatic=1]="Automatic"})(R||(n.NewSymbolNameTriggerKind=R={}));var x;(function(t){t[t.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",t[t.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",t[t.TOP_CENTER=2]="TOP_CENTER"})(x||(n.OverlayWidgetPositionPreference=x={}));var P;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(P||(n.OverviewRulerLane=P={}));var F;(function(t){t[t.Word=0]="Word",t[t.Line=1]="Line",t[t.Suggest=2]="Suggest"})(F||(n.PartialAcceptTriggerKind=F={}));var I;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(I||(n.PositionAffinity=I={}));var V;(function(t){t[t.Off=0]="Off",t[t.On=1]="On",t[t.Relative=2]="Relative",t[t.Interval=3]="Interval",t[t.Custom=4]="Custom"})(V||(n.RenderLineNumbersType=V={}));var $;(function(t){t[t.None=0]="None",t[t.Text=1]="Text",t[t.Blocks=2]="Blocks"})($||(n.RenderMinimap=$={}));var T;(function(t){t[t.Smooth=0]="Smooth",t[t.Immediate=1]="Immediate"})(T||(n.ScrollType=T={}));var O;(function(t){t[t.Auto=1]="Auto",t[t.Hidden=2]="Hidden",t[t.Visible=3]="Visible"})(O||(n.ScrollbarVisibility=O={}));var B;(function(t){t[t.LTR=0]="LTR",t[t.RTL=1]="RTL"})(B||(n.SelectionDirection=B={}));var z;(function(t){t.Off="off",t.OnCode="onCode",t.On="on"})(z||(n.ShowLightbulbIconMode=z={}));var j;(function(t){t[t.Invoke=1]="Invoke",t[t.TriggerCharacter=2]="TriggerCharacter",t[t.ContentChange=3]="ContentChange"})(j||(n.SignatureHelpTriggerKind=j={}));var K;(function(t){t[t.File=0]="File",t[t.Module=1]="Module",t[t.Namespace=2]="Namespace",t[t.Package=3]="Package",t[t.Class=4]="Class",t[t.Method=5]="Method",t[t.Property=6]="Property",t[t.Field=7]="Field",t[t.Constructor=8]="Constructor",t[t.Enum=9]="Enum",t[t.Interface=10]="Interface",t[t.Function=11]="Function",t[t.Variable=12]="Variable",t[t.Constant=13]="Constant",t[t.String=14]="String",t[t.Number=15]="Number",t[t.Boolean=16]="Boolean",t[t.Array=17]="Array",t[t.Object=18]="Object",t[t.Key=19]="Key",t[t.Null=20]="Null",t[t.EnumMember=21]="EnumMember",t[t.Struct=22]="Struct",t[t.Event=23]="Event",t[t.Operator=24]="Operator",t[t.TypeParameter=25]="TypeParameter"})(K||(n.SymbolKind=K={}));var ne;(function(t){t[t.Deprecated=1]="Deprecated"})(ne||(n.SymbolTag=ne={}));var se;(function(t){t[t.Hidden=0]="Hidden",t[t.Blink=1]="Blink",t[t.Smooth=2]="Smooth",t[t.Phase=3]="Phase",t[t.Expand=4]="Expand",t[t.Solid=5]="Solid"})(se||(n.TextEditorCursorBlinkingStyle=se={}));var oe;(function(t){t[t.Line=1]="Line",t[t.Block=2]="Block",t[t.Underline=3]="Underline",t[t.LineThin=4]="LineThin",t[t.BlockOutline=5]="BlockOutline",t[t.UnderlineThin=6]="UnderlineThin"})(oe||(n.TextEditorCursorStyle=oe={}));var ce;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(ce||(n.TrackedRangeStickiness=ce={}));var de;(function(t){t[t.None=0]="None",t[t.Same=1]="Same",t[t.Indent=2]="Indent",t[t.DeepIndent=3]="DeepIndent"})(de||(n.WrappingIndent=de={}))}),Y(J[66],Z([0,1,10,13]),function(W,n,r,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=void 0;class A{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new r.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(v){this._onDidChange.fire({changedLanguages:v,changedColorMap:!1})}register(v,l){return this._tokenizationSupports.set(v,l),this.handleChange([v]),(0,D.toDisposable)(()=>{this._tokenizationSupports.get(v)===l&&(this._tokenizationSupports.delete(v),this.handleChange([v]))})}get(v){return this._tokenizationSupports.get(v)||null}registerFactory(v,l){var a;(a=this._factories.get(v))===null||a===void 0||a.dispose();const g=new m(this,v,l);return this._factories.set(v,g),(0,D.toDisposable)(()=>{const e=this._factories.get(v);!e||e!==g||(this._factories.delete(v),e.dispose())})}async getOrCreate(v){const l=this.get(v);if(l)return l;const a=this._factories.get(v);return!a||a.isResolved?null:(await a.resolve(),this.get(v))}isResolved(v){if(this.get(v))return!0;const a=this._factories.get(v);return!!(!a||a.isResolved)}setColorMap(v){this._colorMap=v,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}n.TokenizationRegistry=A;class m extends D.Disposable{get isResolved(){return this._isResolved}constructor(v,l,a){super(),this._registry=v,this._languageId=l,this._factory=a,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const v=await this._factory.tokenizationSupport;this._isResolved=!0,v&&!this._isDisposed&&this._register(this._registry.register(this._languageId,v))}}}),Y(J[67],Z([0,1]),function(W,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.localize=A,n.localize2=h;const r=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function D(v,l){let a;return l.length===0?a=v:a=v.replace(/\{(\d+)\}/g,(g,e)=>{const c=e[0],i=l[c];let u=g;return typeof i=="string"?u=i:(typeof i=="number"||typeof i=="boolean"||i===void 0||i===null)&&(u=String(i)),u}),r&&(a="\uFF3B"+a.replace(/[aouei]/g,"$&$&")+"\uFF3D"),a}function A(v,l,...a){return D(typeof v=="number"?m(v,l):l,a)}function m(v,l){var a;const g=(a=globalThis._VSCODE_NLS_MESSAGES)===null||a===void 0?void 0:a[v];if(typeof g!="string"){if(typeof l=="string")return l;throw new Error(`!!! NLS MISSING: ${v} !!!`)}return g}function h(v,l,...a){let g;typeof v=="number"?g=m(v,l):g=l;const e=D(g,a);return{value:e,original:l===g?e:D(l,a)}}}),Y(J[68],Z([0,1,44,16,2,66,67]),function(W,n,r,D,A,m,h){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.InlineEditTriggerKind=n.TokenizationRegistry=n.LazyTokenizationSupport=n.InlayHintKind=n.Command=n.NewSymbolNameTriggerKind=n.NewSymbolNameTag=n.FoldingRangeKind=n.TextEdit=n.SymbolKinds=n.symbolKindNames=n.DocumentHighlightKind=n.SignatureHelpTriggerKind=n.DocumentPasteTriggerKind=n.SelectedSuggestionInfo=n.InlineCompletionTriggerKind=n.CompletionItemKinds=n.HoverVerbosityAction=n.EncodedTokenizationResult=n.TokenizationResult=n.Token=void 0,n.isLocationLink=C,n.getAriaLabelForSymbol=_;class v{constructor(E,R,x){this.offset=E,this.type=R,this.language=x,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=v;class l{constructor(E,R){this.tokens=E,this.endState=R,this._tokenizationResultBrand=void 0}}n.TokenizationResult=l;class a{constructor(E,R){this.tokens=E,this.endState=R,this._encodedTokenizationResultBrand=void 0}}n.EncodedTokenizationResult=a;var g;(function(y){y[y.Increase=0]="Increase",y[y.Decrease=1]="Decrease"})(g||(n.HoverVerbosityAction=g={}));var e;(function(y){const E=new Map;E.set(0,r.Codicon.symbolMethod),E.set(1,r.Codicon.symbolFunction),E.set(2,r.Codicon.symbolConstructor),E.set(3,r.Codicon.symbolField),E.set(4,r.Codicon.symbolVariable),E.set(5,r.Codicon.symbolClass),E.set(6,r.Codicon.symbolStruct),E.set(7,r.Codicon.symbolInterface),E.set(8,r.Codicon.symbolModule),E.set(9,r.Codicon.symbolProperty),E.set(10,r.Codicon.symbolEvent),E.set(11,r.Codicon.symbolOperator),E.set(12,r.Codicon.symbolUnit),E.set(13,r.Codicon.symbolValue),E.set(15,r.Codicon.symbolEnum),E.set(14,r.Codicon.symbolConstant),E.set(15,r.Codicon.symbolEnum),E.set(16,r.Codicon.symbolEnumMember),E.set(17,r.Codicon.symbolKeyword),E.set(27,r.Codicon.symbolSnippet),E.set(18,r.Codicon.symbolText),E.set(19,r.Codicon.symbolColor),E.set(20,r.Codicon.symbolFile),E.set(21,r.Codicon.symbolReference),E.set(22,r.Codicon.symbolCustomColor),E.set(23,r.Codicon.symbolFolder),E.set(24,r.Codicon.symbolTypeParameter),E.set(25,r.Codicon.account),E.set(26,r.Codicon.issues);function R(F){let I=E.get(F);return I||(console.info("No codicon found for CompletionItemKind "+F),I=r.Codicon.symbolProperty),I}y.toIcon=R;const x=new Map;x.set("method",0),x.set("function",1),x.set("constructor",2),x.set("field",3),x.set("variable",4),x.set("class",5),x.set("struct",6),x.set("interface",7),x.set("module",8),x.set("property",9),x.set("event",10),x.set("operator",11),x.set("unit",12),x.set("value",13),x.set("constant",14),x.set("enum",15),x.set("enum-member",16),x.set("enumMember",16),x.set("keyword",17),x.set("snippet",27),x.set("text",18),x.set("color",19),x.set("file",20),x.set("reference",21),x.set("customcolor",22),x.set("folder",23),x.set("type-parameter",24),x.set("typeParameter",24),x.set("account",25),x.set("issue",26);function P(F,I){let V=x.get(F);return typeof V>"u"&&!I&&(V=9),V}y.fromString=P})(e||(n.CompletionItemKinds=e={}));var c;(function(y){y[y.Automatic=0]="Automatic",y[y.Explicit=1]="Explicit"})(c||(n.InlineCompletionTriggerKind=c={}));class i{constructor(E,R,x,P){this.range=E,this.text=R,this.completionKind=x,this.isSnippetText=P}equals(E){return A.Range.lift(this.range).equalsRange(E.range)&&this.text===E.text&&this.completionKind===E.completionKind&&this.isSnippetText===E.isSnippetText}}n.SelectedSuggestionInfo=i;var u;(function(y){y[y.Automatic=0]="Automatic",y[y.PasteAs=1]="PasteAs"})(u||(n.DocumentPasteTriggerKind=u={}));var d;(function(y){y[y.Invoke=1]="Invoke",y[y.TriggerCharacter=2]="TriggerCharacter",y[y.ContentChange=3]="ContentChange"})(d||(n.SignatureHelpTriggerKind=d={}));var f;(function(y){y[y.Text=0]="Text",y[y.Read=1]="Read",y[y.Write=2]="Write"})(f||(n.DocumentHighlightKind=f={}));function C(y){return y&&D.URI.isUri(y.uri)&&A.Range.isIRange(y.range)&&(A.Range.isIRange(y.originSelectionRange)||A.Range.isIRange(y.targetSelectionRange))}n.symbolKindNames={17:(0,h.localize)(1744,"array"),16:(0,h.localize)(1745,"boolean"),4:(0,h.localize)(1746,"class"),13:(0,h.localize)(1747,"constant"),8:(0,h.localize)(1748,"constructor"),9:(0,h.localize)(1749,"enumeration"),21:(0,h.localize)(1750,"enumeration member"),23:(0,h.localize)(1751,"event"),7:(0,h.localize)(1752,"field"),0:(0,h.localize)(1753,"file"),11:(0,h.localize)(1754,"function"),10:(0,h.localize)(1755,"interface"),19:(0,h.localize)(1756,"key"),5:(0,h.localize)(1757,"method"),1:(0,h.localize)(1758,"module"),2:(0,h.localize)(1759,"namespace"),20:(0,h.localize)(1760,"null"),15:(0,h.localize)(1761,"number"),18:(0,h.localize)(1762,"object"),24:(0,h.localize)(1763,"operator"),3:(0,h.localize)(1764,"package"),6:(0,h.localize)(1765,"property"),14:(0,h.localize)(1766,"string"),22:(0,h.localize)(1767,"struct"),25:(0,h.localize)(1768,"type parameter"),12:(0,h.localize)(1769,"variable")};function _(y,E){return(0,h.localize)(1770,"{0} ({1})",y,n.symbolKindNames[E])}var S;(function(y){const E=new Map;E.set(0,r.Codicon.symbolFile),E.set(1,r.Codicon.symbolModule),E.set(2,r.Codicon.symbolNamespace),E.set(3,r.Codicon.symbolPackage),E.set(4,r.Codicon.symbolClass),E.set(5,r.Codicon.symbolMethod),E.set(6,r.Codicon.symbolProperty),E.set(7,r.Codicon.symbolField),E.set(8,r.Codicon.symbolConstructor),E.set(9,r.Codicon.symbolEnum),E.set(10,r.Codicon.symbolInterface),E.set(11,r.Codicon.symbolFunction),E.set(12,r.Codicon.symbolVariable),E.set(13,r.Codicon.symbolConstant),E.set(14,r.Codicon.symbolString),E.set(15,r.Codicon.symbolNumber),E.set(16,r.Codicon.symbolBoolean),E.set(17,r.Codicon.symbolArray),E.set(18,r.Codicon.symbolObject),E.set(19,r.Codicon.symbolKey),E.set(20,r.Codicon.symbolNull),E.set(21,r.Codicon.symbolEnumMember),E.set(22,r.Codicon.symbolStruct),E.set(23,r.Codicon.symbolEvent),E.set(24,r.Codicon.symbolOperator),E.set(25,r.Codicon.symbolTypeParameter);function R(x){let P=E.get(x);return P||(console.info("No codicon found for SymbolKind "+x),P=r.Codicon.symbolProperty),P}y.toIcon=R})(S||(n.SymbolKinds=S={}));class M{}n.TextEdit=M;class L{static fromValue(E){switch(E){case"comment":return L.Comment;case"imports":return L.Imports;case"region":return L.Region}return new L(E)}constructor(E){this.value=E}}n.FoldingRangeKind=L,L.Comment=new L("comment"),L.Imports=new L("imports"),L.Region=new L("region");var b;(function(y){y[y.AIGenerated=1]="AIGenerated"})(b||(n.NewSymbolNameTag=b={}));var s;(function(y){y[y.Invoke=0]="Invoke",y[y.Automatic=1]="Automatic"})(s||(n.NewSymbolNameTriggerKind=s={}));var o;(function(y){function E(R){return!R||typeof R!="object"?!1:typeof R.id=="string"&&typeof R.title=="string"}y.is=E})(o||(n.Command=o={}));var p;(function(y){y[y.Type=1]="Type",y[y.Parameter=2]="Parameter"})(p||(n.InlayHintKind=p={}));class w{constructor(E){this.createSupport=E,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(E=>{E&&E.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}n.LazyTokenizationSupport=w,n.TokenizationRegistry=new m.TokenizationRegistry;var N;(function(y){y[y.Invoke=0]="Invoke",y[y.Automatic=1]="Automatic"})(N||(n.InlineEditTriggerKind=N={}))}),Y(J[69],Z([0,1,41,10,37,16,4,2,45,68,65]),function(W,n,r,D,A,m,h,v,l,a,g){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyMod=void 0,n.createMonacoBaseAPI=c;class e{static chord(u,d){return(0,A.KeyChord)(u,d)}}n.KeyMod=e,e.CtrlCmd=2048,e.Shift=1024,e.Alt=512,e.WinCtrl=256;function c(){return{editor:void 0,languages:void 0,CancellationTokenSource:r.CancellationTokenSource,Emitter:D.Emitter,KeyCode:g.KeyCode,KeyMod:e,Position:h.Position,Range:v.Range,Selection:l.Selection,SelectionDirection:g.SelectionDirection,MarkerSeverity:g.MarkerSeverity,MarkerTag:g.MarkerTag,Uri:m.URI,Token:a.Token}}}),Y(J[71],Z([0,1,24,16,4,2,61,30,57,58,69,23,64,55,15,56,63]),function(W,n,r,D,A,m,h,v,l,a,g,e,c,i,u,d,f){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.EditorSimpleWorker=void 0,n.create=S;class C extends h.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}findMatches(L){const b=[];for(let s=0;s<this._lines.length;s++){const o=this._lines[s],p=this.offsetAt(new A.Position(s+1,1)),w=o.matchAll(L);for(const N of w)(N.index||N.index===0)&&(N.index=N.index+p),b.push(N)}return b}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(L){return this._lines[L-1]}getWordAtPosition(L,b){const s=(0,v.getWordAtText)(L.column,(0,v.ensureValidWordDefinition)(b),this._lines[L.lineNumber-1],0);return s?new m.Range(L.lineNumber,s.startColumn,L.lineNumber,s.endColumn):null}words(L){const b=this._lines,s=this._wordenize.bind(this);let o=0,p="",w=0,N=[];return{*[Symbol.iterator](){for(;;)if(w<N.length){const y=p.substring(N[w].start,N[w].end);w+=1,yield y}else if(o<b.length)p=b[o],N=s(p,L),w=0,o+=1;else break}}}getLineWords(L,b){const s=this._lines[L-1],o=this._wordenize(s,b),p=[];for(const w of o)p.push({word:s.substring(w.start,w.end),startColumn:w.start+1,endColumn:w.end+1});return p}_wordenize(L,b){const s=[];let o;for(b.lastIndex=0;(o=b.exec(L))&&o[0].length!==0;)s.push({start:o.index,end:o.index+o[0].length});return s}getValueInRange(L){if(L=this._validateRange(L),L.startLineNumber===L.endLineNumber)return this._lines[L.startLineNumber-1].substring(L.startColumn-1,L.endColumn-1);const b=this._eol,s=L.startLineNumber-1,o=L.endLineNumber-1,p=[];p.push(this._lines[s].substring(L.startColumn-1));for(let w=s+1;w<o;w++)p.push(this._lines[w]);return p.push(this._lines[o].substring(0,L.endColumn-1)),p.join(b)}offsetAt(L){return L=this._validatePosition(L),this._ensureLineStarts(),this._lineStarts.getPrefixSum(L.lineNumber-2)+(L.column-1)}positionAt(L){L=Math.floor(L),L=Math.max(0,L),this._ensureLineStarts();const b=this._lineStarts.getIndexOf(L),s=this._lines[b.index].length;return{lineNumber:1+b.index,column:1+Math.min(b.remainder,s)}}_validateRange(L){const b=this._validatePosition({lineNumber:L.startLineNumber,column:L.startColumn}),s=this._validatePosition({lineNumber:L.endLineNumber,column:L.endColumn});return b.lineNumber!==L.startLineNumber||b.column!==L.startColumn||s.lineNumber!==L.endLineNumber||s.column!==L.endColumn?{startLineNumber:b.lineNumber,startColumn:b.column,endLineNumber:s.lineNumber,endColumn:s.column}:L}_validatePosition(L){if(!A.Position.isIPosition(L))throw new Error("bad position");let{lineNumber:b,column:s}=L,o=!1;if(b<1)b=1,s=1,o=!0;else if(b>this._lines.length)b=this._lines.length,s=this._lines[b-1].length+1,o=!0;else{const p=this._lines[b-1].length+1;s<1?(s=1,o=!0):s>p&&(s=p,o=!0)}return o?{lineNumber:b,column:s}:L}}class _{constructor(L,b){this._host=L,this._models=Object.create(null),this._foreignModuleFactory=b,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(L){return this._models[L]}_getModels(){const L=[];return Object.keys(this._models).forEach(b=>L.push(this._models[b])),L}acceptNewModel(L){this._models[L.url]=new C(D.URI.parse(L.url),L.lines,L.EOL,L.versionId)}acceptModelChanged(L,b){if(!this._models[L])return;this._models[L].onEvents(b)}acceptRemovedModel(L){this._models[L]&&delete this._models[L]}async computeUnicodeHighlights(L,b,s){const o=this._getModel(L);return o?c.UnicodeTextModelHighlighter.computeUnicodeHighlights(o,b,s):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async findSectionHeaders(L,b){const s=this._getModel(L);return s?(0,f.findSectionHeaders)(s,b):[]}async computeDiff(L,b,s,o){const p=this._getModel(L),w=this._getModel(b);return!p||!w?null:_.computeDiff(p,w,s,o)}static computeDiff(L,b,s,o){const p=o==="advanced"?i.linesDiffComputers.getDefault():i.linesDiffComputers.getLegacy(),w=L.getLinesContent(),N=b.getLinesContent(),y=p.computeDiff(w,N,s),E=y.changes.length>0?!1:this._modelsAreIdentical(L,b);function R(x){return x.map(P=>{var F;return[P.original.startLineNumber,P.original.endLineNumberExclusive,P.modified.startLineNumber,P.modified.endLineNumberExclusive,(F=P.innerChanges)===null||F===void 0?void 0:F.map(I=>[I.originalRange.startLineNumber,I.originalRange.startColumn,I.originalRange.endLineNumber,I.originalRange.endColumn,I.modifiedRange.startLineNumber,I.modifiedRange.startColumn,I.modifiedRange.endLineNumber,I.modifiedRange.endColumn])]})}return{identical:E,quitEarly:y.hitTimeout,changes:R(y.changes),moves:y.moves.map(x=>[x.lineRangeMapping.original.startLineNumber,x.lineRangeMapping.original.endLineNumberExclusive,x.lineRangeMapping.modified.startLineNumber,x.lineRangeMapping.modified.endLineNumberExclusive,R(x.changes)])}}static _modelsAreIdentical(L,b){const s=L.getLineCount(),o=b.getLineCount();if(s!==o)return!1;for(let p=1;p<=s;p++){const w=L.getLineContent(p),N=b.getLineContent(p);if(w!==N)return!1}return!0}async computeMoreMinimalEdits(L,b,s){const o=this._getModel(L);if(!o)return b;const p=[];let w;b=b.slice(0).sort((y,E)=>{if(y.range&&E.range)return m.Range.compareRangesUsingStarts(y.range,E.range);const R=y.range?0:1,x=E.range?0:1;return R-x});let N=0;for(let y=1;y<b.length;y++)m.Range.getEndPosition(b[N].range).equals(m.Range.getStartPosition(b[y].range))?(b[N].range=m.Range.fromPositions(m.Range.getStartPosition(b[N].range),m.Range.getEndPosition(b[y].range)),b[N].text+=b[y].text):(N++,b[N]=b[y]);b.length=N+1;for(let{range:y,text:E,eol:R}of b){if(typeof R=="number"&&(w=R),m.Range.isEmpty(y)&&!E)continue;const x=o.getValueInRange(y);if(E=E.replace(/\r\n|\n|\r/g,o.eol),x===E)continue;if(Math.max(E.length,x.length)>_._diffLimit){p.push({range:y,text:E});continue}const P=(0,r.stringDiff)(x,E,s),F=o.offsetAt(m.Range.lift(y).getStartPosition());for(const I of P){const V=o.positionAt(F+I.originalStart),$=o.positionAt(F+I.originalStart+I.originalLength),T={text:E.substr(I.modifiedStart,I.modifiedLength),range:{startLineNumber:V.lineNumber,startColumn:V.column,endLineNumber:$.lineNumber,endColumn:$.column}};o.getValueInRange(T.range)!==T.text&&p.push(T)}}return typeof w=="number"&&p.push({eol:w,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),p}async computeLinks(L){const b=this._getModel(L);return b?(0,l.computeLinks)(b):null}async computeDefaultDocumentColors(L){const b=this._getModel(L);return b?(0,d.computeDefaultDocumentColors)(b):null}async textualSuggest(L,b,s,o){const p=new e.StopWatch,w=new RegExp(s,o),N=new Set;e:for(const y of L){const E=this._getModel(y);if(E){for(const R of E.words(w))if(!(R===b||!isNaN(Number(R)))&&(N.add(R),N.size>_._suggestionsLimit))break e}}return{words:Array.from(N),duration:p.elapsed()}}async computeWordRanges(L,b,s,o){const p=this._getModel(L);if(!p)return Object.create(null);const w=new RegExp(s,o),N=Object.create(null);for(let y=b.startLineNumber;y<b.endLineNumber;y++){const E=p.getLineWords(y,w);for(const R of E){if(!isNaN(Number(R.word)))continue;let x=N[R.word];x||(x=[],N[R.word]=x),x.push({startLineNumber:y,startColumn:R.startColumn,endLineNumber:y,endColumn:R.endColumn})}}return N}async navigateValueSet(L,b,s,o,p){const w=this._getModel(L);if(!w)return null;const N=new RegExp(o,p);b.startColumn===b.endColumn&&(b={startLineNumber:b.startLineNumber,startColumn:b.startColumn,endLineNumber:b.endLineNumber,endColumn:b.endColumn+1});const y=w.getValueInRange(b),E=w.getWordAtPosition({lineNumber:b.startLineNumber,column:b.startColumn},N);if(!E)return null;const R=w.getValueInRange(E);return a.BasicInplaceReplace.INSTANCE.navigateValueSet(b,y,E,R,s)}loadForeignModule(L,b,s){const o=(N,y)=>this._host.fhr(N,y),w={host:(0,u.createProxyObject)(s,o),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(w,b),Promise.resolve((0,u.getAllMethodNames)(this._foreignModule))):new Promise((N,y)=>{W([L],E=>{this._foreignModule=E.create(w,b),N((0,u.getAllMethodNames)(this._foreignModule))},y)})}fmr(L,b){if(!this._foreignModule||typeof this._foreignModule[L]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+L));try{return Promise.resolve(this._foreignModule[L].apply(this._foreignModule,b))}catch(s){return Promise.reject(s)}}}n.EditorSimpleWorker=_,_._diffLimit=1e5,_._suggestionsLimit=1e4;function S(M){return new _(M,null)}typeof importScripts=="function"&&(globalThis.monaco=(0,g.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=../../../../min-maps/vs/base/worker/workerMain.js.map